#include <stdlib.h>
#include <stdio.h>

/*********************************************************************
**
**                  CGS-DUMMIES
**                  
**                  Routines to satisfy calls of CGS functions.
**                  These routines should never be called in one
**                  of our applications.  Set plot option in tape
**                  to FALSE in case you wind up in any of the 
**                  dummies.  The list below shows where each of
**                  the CGS functions is called, in case a traceback
**                  should be necessary.  
**                  
**                  AUTHOR:  Bernhard Sulzer, LANL
**                 
**********************************************************************/

/*********************************************************************************

cgs-dummies.c   --->   gdone_()

rcb-separfit.c:    extern  int gdone_();
rcb-separfit.c:	gdone_();
rcb-simulfit.c:    extern  int gdone_();
rcb-simulfit.c:	gdone_();


cgs-dummies.c   --->   gpage_()

rcb-dosims.c:    extern  int gpage_();
rcb-dosims.c:	    gpage_();
rcb-jacplot.c:    extern  int gpage_(), hcvls_();
rcb-jacplot.c:    gpage_();
rcb-plres.c:    extern  int gpage_(), hcvls_();
rcb-plres.c:    gpage_();
rcb-plres.c:    gpage_();
rcb-plres.c:    gpage_();
rcb-simplot.c:    extern  int gpage_(), hcvls_();
rcb-simplot.c:    gpage_();


cgs-dummies.c   --->   gplot_()

rcb-setup.c:    extern  int libhi_(), gplot_();
rcb-setup.c:    gplot_("u", "riepe", &c__5, (ftnlen)1, (ftnlen)5);


cgs-dummies.c   --->   libhi_()

rcb-setup.c:    extern  int libhi_(), gplot_();
rcb-setup.c:    libhi_();


cgs-dummies.c   --->   bconvi_()

rcb-modtitle.c:    extern  int bconvi_();
rcb-modtitle.c:    bconvi_(numfit, titles_1.tstring, &c__19, &c__2, (ftnlen)64);


cgs-dummies.c   --->   hcvmrk_()

rcb-jacplot.c:    extern  int ssort_(), hcvmrk_(), hcurve_(), haxrul_();
rcb-jacplot.c:    hcvmrk_("circle", &jaccount, "off", (ftnlen)6, (ftnlen)3);
rcb-jacplot.c:    hcvmrk_("nomarker", &jaccount, "off", (ftnlen)8, (ftnlen)3);
rcb-plres.c:    extern  int hcvmrk_(), hcurve_(), haxrul_(), hmrksz_();
rcb-plres.c:    hcvmrk_("nomarker", &mandn_2.numpts, "off", (ftnlen)8, (ftnlen)3);
rcb-plres.c:    hcvmrk_("circle", &mandn_2.numpts, "off", (ftnlen)6, (ftnlen)3);
rcb-simplot.c:    extern  int hcvmrk_(), hcurve_(), haxrul_();
rcb-simplot.c:    hcvmrk_("circle", &simparms_1.simcount, "off", (ftnlen)6, (ftnlen)3);
rcb-simplot.c:    hcvmrk_("nomarker", &simparms_1.simcount, "off", (ftnlen)8, (ftnlen)3);
rcb-xyplot.c:    extern  int hcvmrk_(), hcurve_(), haxrul_(), hxlogy_(), 
rcb-xyplot.c:    hcvmrk_("circle", &jnpts3, "off", (ftnlen)6, (ftnlen)3);
rcb-xyplot.c:    hcvmrk_("nomarker", npts, "off", (ftnlen)8, (ftnlen)3);


cgs-dummies.c   --->   hcvls_()

rcb-jacplot.c:    extern  int gpage_(), hcvls_();
rcb-jacplot.c:    hcvls_("noline", "off", (ftnlen)6, (ftnlen)3);
rcb-jacplot.c:    hcvls_("solid", "off", (ftnlen)5, (ftnlen)3);
rcb-jacplot.c:    hcvls_("dash", "off", (ftnlen)4, (ftnlen)3);
rcb-jacplot.c:    hcvls_("dot", "off", (ftnlen)3, (ftnlen)3);
rcb-jacplot.c:    hcvls_("solid", "off", (ftnlen)5, (ftnlen)3);
rcb-plres.c:    extern  int gpage_(), hcvls_();
rcb-plres.c:    hcvls_("solid", "off", (ftnlen)5, (ftnlen)3);
rcb-plres.c:    hcvls_("noline", "off", (ftnlen)6, (ftnlen)3);
rcb-simplot.c:    extern  int gpage_(), hcvls_();
rcb-simplot.c:    hcvls_("noline", "off", (ftnlen)6, (ftnlen)3);
rcb-simplot.c:    hcvls_("solid", "off", (ftnlen)5, (ftnlen)3);
rcb-simplot.c:    hcvls_("dash", "off", (ftnlen)4, (ftnlen)3);
rcb-simplot.c:    hcvls_("dot", "off", (ftnlen)3, (ftnlen)3);
rcb-simplot.c:    hcvls_("solid", "off", (ftnlen)5, (ftnlen)3);
rcb-xyplot.c:    extern  int hcvls_();
rcb-xyplot.c:    hcvls_("noline", "off", (ftnlen)6, (ftnlen)3);
rcb-xyplot.c:    hcvls_("solid", "off", (ftnlen)5, (ftnlen)3);


cgs-dummies.c   --->   hmrksz_()

rcb-jacplot.c:    extern  int hmrksz_();
rcb-jacplot.c:    hmrksz_(&c_b812);
rcb-plres.c:    extern  int hcvmrk_(), hcurve_(), haxrul_(), hmrksz_();
rcb-plres.c:    hmrksz_(&c_b689);
rcb-simplot.c:    extern  int hmrksz_();
rcb-simplot.c:    hmrksz_(&c_b812);
rcb-xyplot.c:	    hylogx_(), hlogxy_(), hmrksz_(), hxy_();
rcb-xyplot.c:    hmrksz_(&c_b689);


cgs-dummies.c   --->   haxrul_()

rcb-jacplot.c:    extern  int ssort_(), hcvmrk_(), hcurve_(), haxrul_();
rcb-jacplot.c:    haxrul_("x", &xorig, &xmax, &xstp, "user", (ftnlen)1, (ftnlen)4);
rcb-jacplot.c:    haxrul_("y", &yorig, &ymax, &ystp, "user", (ftnlen)1, (ftnlen)4);
rcb-plres.c:    extern  int hcvmrk_(), hcurve_(), haxrul_(), hmrksz_();
rcb-plres.c:    haxrul_("x", &c_b707, &rm, &r_1, "user", (ftnlen)1, (ftnlen)4);
rcb-plres.c:    haxrul_("y", &r_1, &rrm, &r_2, "user", (ftnlen)1, (ftnlen)4);
rcb-plres.c:    haxrul_("x", &c_b707, &rm, &r_1, "user", (ftnlen)1, (ftnlen)4);
rcb-plres.c:    haxrul_("y", &c_b592, &rrm, &r_1, "user", (ftnlen)1, (ftnlen)4);
rcb-simplot.c:    extern  int hcvmrk_(), hcurve_(), haxrul_();
rcb-simplot.c:    haxrul_("x", &xorig, &xmax, &xstp, "user", (ftnlen)1, (ftnlen)4);
rcb-simplot.c:    haxrul_("y", &yorig, &ymax, &ystp, "user", (ftnlen)1, (ftnlen)4);
rcb-xyplot.c:    extern  int hcvmrk_(), hcurve_(), haxrul_(), hxlogy_(), 
rcb-xyplot.c:    haxrul_("x", &plotting_1.xorig, &plotting_1.xmax, &plotting_1.xstp, 
rcb-xyplot.c:    haxrul_("y", &plotting_1.yorig, &plotting_1.ymax, &plotting_1.ystp, 
rcb-xyplot.c:    haxrul_("x", &plotting_1.xorig, &plotting_1.xmax, &plotting_1.xstp, 
rcb-xyplot.c:    haxrul_("y", &plotting_1.yorig, &plotting_1.ymax, &c_b707, "user", (ftnlen)1, (ftnlen)4)
rcb-xyplot.c:    haxrul_("x", &plotting_1.xorig, &plotting_1.xmax, &c_b707, "user", (ftnlen)1, (ftnlen)4)
rcb-xyplot.c:    haxrul_("y", &plotting_1.yorig, &plotting_1.ymax, &plotting_1.ystp, 
rcb-xyplot.c:    haxrul_("x", &plotting_1.xorig, &plotting_1.xmax, &c_b707, "user", (ftnlen)1, (ftnlen)4)
rcb-xyplot.c:    haxrul_("y", &plotting_1.yorig, &plotting_1.ymax, &c_b707, "user", (ftnlen)1, (ftnlen)4)


cgs-dummies.c   --->   hxy_()

rcb-jacplot.c:    extern  int hxy_();
rcb-jacplot.c:    hxy_(xvals, yvals, &jaccount, name, "", "jacknifes", (ftnlen)7, (ftnlen)0, (ftnlen)9);
rcb-plres.c:    extern  int hxy_();
rcb-plres.c:    hxy_(x2, y2, &c__2, "point number", "", "residuals", (ftnlen)12, (ftnlen)0, (ftnlen)9);
rcb-plres.c:    hxy_(ti, ya, &m, "point number", "", "absolute value of residuals", (ftnlen)12, 
rcb-simplot.c:    extern  int hxy_();
rcb-simplot.c:    hxy_(xvals, yvals, &simparms_1.simcount, name, "", "simulations", (ftnlen)7, (ftnlen)0, 
rcb-xyplot.c:	    hylogx_(), hlogxy_(), hmrksz_(), hxy_();
rcb-xyplot.c:    hxy_(xdata, ydata, &jnpts3, titles_1.xstring, titles_1.ystring, 


cgs-dummies.c   --->   hxlogy_()

rcb-xyplot.c:    extern  int hcvmrk_(), hcurve_(), haxrul_(), hxlogy_(), 
rcb-xyplot.c:    hxlogy_(xdata, ydata, &jnpts3, titles_1.xstring, titles_1.ystring, 


cgs-dummies.c   --->   hylogx_()

rcb-xyplot.c:	    hylogx_(), hlogxy_(), hmrksz_(), hxy_();
rcb-xyplot.c:    hylogx_(xdata, ydata, &jnpts3, titles_1.xstring, titles_1.ystring, 


cgs-dummies.c   --->   hlogxy_()

rcb-xyplot.c:	    hylogx_(), hlogxy_(), hmrksz_(), hxy_();
rcb-xyplot.c:    hlogxy_(xdata, ydata, &jnpts3, titles_1.xstring, titles_1.ystring, 


cgs-dummies.c   --->   hcurve_()

rcb-jacplot.c:    extern  int ssort_(), hcvmrk_(), hcurve_(), haxrul_();
rcb-jacplot.c:    hcurve_(xconst, yconst, &c__2);
rcb-jacplot.c:    hcurve_(xconst, yconst, &c__2);
rcb-jacplot.c:    hcurve_(xconst, yconst, &c__2);
rcb-jacplot.c:    hcurve_(xconst, yconst, &c__2);
rcb-jacplot.c:    hcurve_(xconst, yconst, &c__2);
rcb-jacplot.c:    hcurve_(xconst, yconst, &c__2);
rcb-jacplot.c:    hcurve_(xconst, yconst, &c__2);
rcb-plres.c:    extern  int hcvmrk_(), hcurve_(), haxrul_(), hmrksz_();
rcb-plres.c:    hcurve_(ti, g, &mandn_2.numpts);
rcb-simplot.c:    extern  int hcvmrk_(), hcurve_(), haxrul_();
rcb-simplot.c:    hcurve_(xconst, yconst, &c__2);
rcb-simplot.c:    hcurve_(xconst, yconst, &c__2);
rcb-simplot.c:    hcurve_(xconst, yconst, &c__2);
rcb-simplot.c:    hcurve_(xconst, yconst, &c__2);
rcb-simplot.c:    hcurve_(xconst, yconst, &c__2);
rcb-simplot.c:    hcurve_(xconst, yconst, &c__2);
rcb-simplot.c:    hcurve_(xconst, yconst, &c__2);
rcb-xyplot.c:    extern  int hcvmrk_(), hcurve_(), haxrul_(), hxlogy_(), 
rcb-xyplot.c:    hcurve_(xcalc, ycalc, npts);


cgs-dummies.c   --->   gmova2_()

rcb-pltvls.c:    extern  int gtext_(), gmova2_(), gmovr2_(), bconve_();
rcb-pltvls.c:    gmova2_(&c_b736, &c_b737);
rcb-pltvls.c:    gmova2_(&c_b736, &c_b740);
rcb-pltvls.c:    gmova2_(&c_b741, &c_b737);
rcb-pltvls.c:    gmova2_(&c_b741, &c_b740);


cgs-dummies.c   --->   gtext_()

rcb-pltvls.c:    extern  int gtext_(), gmova2_(), gmovr2_(), bconve_();
rcb-pltvls.c:	gtext_(names + i * 7, &c__7, (ftnlen)7);
rcb-pltvls.c:	gtext_(" = ", &c__3, (ftnlen)3);
rcb-pltvls.c:	gtext_(valstr, &c__12, (ftnlen)32);
rcb-pltvls.c:	gtext_(names + (*isize + 1 - i) * 7, &c__7, (ftnlen)7);
rcb-pltvls.c:	gtext_(" = ", &c__3, (ftnlen)3);
rcb-pltvls.c:	gtext_(valstr, &c__12, (ftnlen)32);


cgs-dummies.c   --->   gmovr2_()

rcb-pltvls.c:    extern  int gtext_(), gmova2_(), gmovr2_(), bconve_();
rcb-pltvls.c:	gmovr2_(&c_b747, &c_b592);
rcb-pltvls.c:	gmovr2_(&c_b751, &c_b592);
rcb-pltvls.c:	gmovr2_(&c_b757, &c_b758);
rcb-pltvls.c:	gmovr2_(&c_b747, &c_b592);
rcb-pltvls.c:	gmovr2_(&c_b751, &c_b592);
rcb-pltvls.c:	gmovr2_(&c_b757, &c_b773);


cgs-dummies.c   --->   bconve_()

rcb-pltvls.c:    extern  int gtext_(), gmova2_(), gmovr2_(), bconve_();
rcb-pltvls.c:	bconve_(&vleg, valstr, &c__1, &c__12, &c__6, (ftnlen)32);
rcb-pltvls.c:	bconve_(&vleg, valstr, &c__1, &c__12, &c__6, (ftnlen)32);


*********************************************************************************/


void
gdone_()
{
    fprintf(stderr, "\nCGS DUMMY (__GDONE__):\n");
    fprintf(stderr, "\tYou are not supposed to be here!\n");
    fprintf(stderr, "Exiting now.\n\n");
    exit(-97);
}
void
gpage_()
{
    fprintf(stderr, "\nCGS DUMMY (__GPAGE__):\n");
    fprintf(stderr, "\tYou are not supposed to be here!\n");
    fprintf(stderr, "Exiting now.\n\n");
    exit(-97);
}
void
gplot_()
{
    fprintf(stderr, "\nCGS DUMMY (__GPLOT__):\n");
    fprintf(stderr, "\tYou are not supposed to be here!\n");
    fprintf(stderr, "Exiting now.\n\n");
    exit(-97);
}
void
libhi_()
{
    fprintf(stderr, "\nCGS DUMMY (__LIBHI__):\n");
    fprintf(stderr, "\tYou are not supposed to be here!\n");
    fprintf(stderr, "Exiting now.\n\n");
    exit(-97);
}
void
bconvi_()
{
    fprintf(stderr, "\nCGS DUMMY (__BCONVI__):\n");
    fprintf(stderr, "\tYou are not supposed to be here!\n");
    fprintf(stderr, "Exiting now.\n\n");
    exit(-97);
}
void
hcvmrk_()
{
    fprintf(stderr, "\nCGS DUMMY (__HCVMRK__):\n");
    fprintf(stderr, "\tYou are not supposed to be here!\n");
    fprintf(stderr, "Exiting now.\n\n");
    exit(-97);
}
void
hcvls_()
{
    fprintf(stderr, "\nCGS DUMMY (__HCVLS__):\n");
    fprintf(stderr, "\tYou are not supposed to be here!\n");
    fprintf(stderr, "Exiting now.\n\n");
    exit(-97);
}
void
hmrksz_()
{
    fprintf(stderr, "\nCGS DUMMY (__HMRKSZ__):\n");
    fprintf(stderr, "\tYou are not supposed to be here!\n");
    fprintf(stderr, "Exiting now.\n\n");
    exit(-97);
}
void
haxrul_()
{
    fprintf(stderr, "\nCGS DUMMY (__HAXRUL__):\n");
    fprintf(stderr, "\tYou are not supposed to be here!\n");
    fprintf(stderr, "Exiting now.\n\n");
    exit(-97);
}
void
hxy_()
{
    fprintf(stderr, "\nCGS DUMMY (__HXY__):\n");
    fprintf(stderr, "\tYou are not supposed to be here!\n");
    fprintf(stderr, "Exiting now.\n\n");
    exit(-97);
}
void
hxlogy_()
{
    fprintf(stderr, "\nCGS DUMMY (__HXLOGY__):\n");
    fprintf(stderr, "\tYou are not supposed to be here!\n");
    fprintf(stderr, "Exiting now.\n\n");
    exit(-97);
}
void
hylogx_()
{
    fprintf(stderr, "\nCGS DUMMY (__HYLOGX__):\n");
    fprintf(stderr, "\tYou are not supposed to be here!\n");
    fprintf(stderr, "Exiting now.\n\n");
    exit(-97);
}
void
hlogxy_()
{
    fprintf(stderr, "\nCGS DUMMY (__HLOGXY__):\n");
    fprintf(stderr, "\tYou are not supposed to be here!\n");
    fprintf(stderr, "Exiting now.\n\n");
    exit(-97);
}
void
hcurve_()
{
    fprintf(stderr, "\nCGS DUMMY (__HCURVE__):\n");
    fprintf(stderr, "\tYou are not supposed to be here!\n");
    fprintf(stderr, "Exiting now.\n\n");
    exit(-97);
}
void
gmova2_()
{
    fprintf(stderr, "\nCGS DUMMY (__GMOVA2__):\n");
    fprintf(stderr, "\tYou are not supposed to be here!\n");
    fprintf(stderr, "Exiting now.\n\n");
    exit(-97);
}
void
gtext_()
{
    fprintf(stderr, "\nCGS DUMMY (__GTEXT__):\n");
    fprintf(stderr, "\tYou are not supposed to be here!\n");
    fprintf(stderr, "Exiting now.\n\n");
    exit(-97);
}
void
gmovr2_()
{
    fprintf(stderr, "\nCGS DUMMY (__GMOVR2__):\n");
    fprintf(stderr, "\tYou are not supposed to be here!\n");
    fprintf(stderr, "Exiting now.\n\n");
    exit(-97);
}
void
bconve_()
{
    fprintf(stderr, "\nCGS DUMMY (__BCONVE__):\n");
    fprintf(stderr, "\tYou are not supposed to be here!\n");
    fprintf(stderr, "Exiting now.\n\n");
    exit(-97);
}
