/* rcb.f -- translated by f2c (version of 3 February 1990  3:36:42).
    You must link the resulting object file with the libraries:
	-lF77 -lI77 -lm -lc   (in that order)
*/

#include <strings.h>
#include "f2c.h"
#include "rcb.h"
#include "rcb2.h"
#include "RCBfit.h"

/*
   flag to distinguish the standard data format from complex alternatives
*/
int two_column_data = 1;
int customized_data_output = 0;
int customized_distance_calculation = 0;
int entered_traditionally = 0;

void
rcb_fit(char *tape_file, void(*ini)(double*), double(*value)(), double(*diff)())
{
    entered_traditionally = 1;
    if (two_column_data)
    {
	_RCB_residual = two_column_data_residual_outdated;
	_RCB_tcd_residual = diff;
    }
    else
    {
	_RCB_residual = multi_column_data_residual_outdated;
	_RCB_mcd_residual = diff;
    }
    RCBfit(tape_file, ini, value);
}

/* Subroutine */ 
void
RCBfit(char *tape_file, void(*ini)(double*), double(*value)())
{
    /* System generated locals */
    olist o_1;

    /* Builtin functions */
    integer f_open();

    /* Local variables */
    extern /* Subroutine */ int rcbtop_();

    /*
     *   set global pointers to
     *   user-defined functions
     */
    _RCB_initialize_parameters = ini;
    /*
     *   by default, rcbfit expects data in a two column format, i.e., 
     *   the first data column is the value of the independent variable
     *   and the last data column the value of the depend variable.
     *   For each data point, the fit program passes those two values to
     *   the routine which computes the residual.
     *   Data can be processed from more complex data files.  For instance,
     *   for each data point, the values in all columns may be passed to 
     *   to the routine that computes the residual.
     */
    if (two_column_data)
    {
	_RCB_tcd_y_value = (double(*)(double*))value;
	_RCB_theory = two_column_data_theory;
	if (!customized_distance_calculation)
	{
	    if (!entered_traditionally)
		_RCB_residual = two_column_data_residual;
	    _RCB_adderror = adderror_tcd;
	}
	_RCB_output = outinf_tcd;
	if (!customized_data_output) 
	    _RCB_write_fit_data = write_fit_data_tcd;
    }
    else
    {
	_RCB_mcd_y_value = (double(*)(double*,double*))value;
	_RCB_theory = multi_column_data_theory;
	if (!customized_distance_calculation)
	{
	    if (!entered_traditionally)
		_RCB_residual = multi_column_data_residual;
	    _RCB_adderror = adderror_mcd;
	}
	_RCB_output = outinf_mcd;
	if (!customized_data_output) 
	    _RCB_write_fit_data = write_fit_data_mcd;
    }

    o_1.oerr = 0;
    o_1.ounit = 2;
    o_1.ofnmlen = strlen(tape_file);
    o_1.ofnm = tape_file;
    o_1.orl = 0;
    o_1.osta = 0;
    o_1.oacc = 0;
    o_1.ofm = 0;
    o_1.oblnk = 0;
    f_open(&o_1);
    rcbtop_();
} /* rcbfit_ */


void
rcb_guess_ini_function_pointers (int nvar, double(*value)())
{
    if (two_column_data)
    {
	_RCB_tcd_y_value = (double(*)(double*))value;
	_RCB_make_guess = make_guess_tcd;
    }
    else
    {
	_RCB_mcd_y_value = (double(*)(double*,double*))value;
	_RCB_make_guess = make_guess_mcd;
    }
    if (!customized_data_output)
	_RCB_write_guess_data = write_guess_data;
}



void
rcb_select_data_style (int type)
{
    switch (type)
    {
      case _RCB_TWO_COLUMN:
	two_column_data = 1;
	if (!customized_distance_calculation)
	{
	    if (!entered_traditionally)
		_RCB_residual = two_column_data_residual;
	    else
		_RCB_residual = two_column_data_residual_outdated;
	    _RCB_adderror = adderror_tcd;
	    _RCB_write_fit_data = write_fit_data_tcd;
	}
	else
	{
	    _RCB_residual = two_column_data_residual_custom;
	    _RCB_adderror = adderror_tcd_custom;
	    _RCB_write_fit_data = write_fit_data_tcd_custom;
	}
	_RCB_theory = two_column_data_theory;
	break;
	
      case _RCB_MULTI_COLUMN:
	two_column_data = 0;
	if (!customized_distance_calculation)
	{
	    if (!entered_traditionally)
		_RCB_residual = multi_column_data_residual;
	    else
		_RCB_residual = multi_column_data_residual_outdated;
	    _RCB_adderror = adderror_mcd;
	    _RCB_write_fit_data = write_fit_data_mcd;
	}
	else
	{
	    _RCB_residual = multi_column_data_residual_custom;
	    _RCB_adderror = adderror_mcd_custom;
	    _RCB_write_fit_data = write_fit_data_mcd_custom;
	}
	_RCB_theory = multi_column_data_theory;
	break;
      
      default:
	break;
    }
}

void
rcb_set_customized_data_output (void (*c)(int*, int*, double*, double*, double*))
{
    customized_data_output = 1;
    if (two_column_data) {
	_RCB_write_fit_data   = write_fit_data_tcd_custom;
    }
    else
    {
	_RCB_write_fit_data   = write_fit_data_mcd_custom;
    }
    _RCB_write_guess_data = write_guess_data_custom;
    _RCB_data_converter = c;
}

void
rcb_set_customized_distance_measure (double(*forward)(double*,double*), 
				     double(*reverse)(double*,double*))
{
    customized_distance_calculation = 1;

    if (two_column_data)
    {
	_RCB_residual = two_column_data_residual_custom;
	_RCB_adderror = adderror_tcd_custom;
    }
    else
    {
	_RCB_residual = multi_column_data_residual_custom;
	_RCB_adderror = adderror_mcd_custom;
    }    
    _RCB_forward = forward;
    _RCB_reverse = reverse;
}
