/*
 *      FitDataFormat: TwoColumn
 */
#include "mbs.h"

double   X, X0, xp, t_ode;
int      dim, init;

void
inip_ (double *parameters)
{
    void    decay(int, double*, double*, double*);
/*
    Begin: Synonyms

    X0                    Initial_Value    x0
    xp                    exponent         xp

    End: Synonyms
*/
    X0 = parameters[0];
    xp = parameters[1];

    dim = 1;
    t_ode = 0.0;
    X = X0;
#ifdef  RKF
    mbs_ini_clams_runge_kutta (dim, decay);
#else
    mbs_ini_clams_ddrive (dim, decay);
#endif
    init = TRUE;
}
double
fun_ (double *t)
{
    if (*t > t_ode)
    {
#ifdef  RKF
	mbs_clams_runge_kutta (dim, &t_ode, &X, *t, init);
#else
	mbs_clams_ddrive (dim, &t_ode, &X, *t, init);
#endif
	init = FALSE;
    }
    return (X);
}
void    
decay (int dim, double *t, double *x, double *x_dot)
{
    *x_dot = -xp * *x;
}
