/*********************************
 *
 *      FUI header comments
 *
 *  FitDataFormat:    TwoColumn  
 *
 *********************************/
#include "mbs.h"

double   Y, Y0, xp, t_ode;
int      dim, init;

void
initialize (double *parameters)
{
    void    decay(int, double*, double*, double*);
/*
    Begin: Synonyms

    X0                    Initial_Value    x0
    xp                    exponent         xp

    End: Synonyms
*/
    Y0 = parameters[0];
    xp = parameters[1];

    dim = 1;
    t_ode = 0.0;
    Y = Y0;
#ifdef RKF
    mbs_ini_clams_depac (dim, decay, __CDEPAC__DDERKF);
#else
    mbs_ini_clams_ddrive (dim, decay);
#endif
    init = TRUE;
}
double
value (double *t)
{
    if (*t > t_ode)
    {
#ifdef  RKF
	mbs_clams_runge_kutta (dim, &t_ode, &Y, *t, init);
#else
	mbs_clams_ddrive (dim, &t_ode, &Y, *t, init);
#endif
	init = FALSE;
    }
    return (Y);
}
double 
residual (double *t, double *y)  {  return (*y - Y);  }
void    
decay (int dim, double *t, double *y, double *y_dot)  {  *y_dot = -xp * *y;  }

