#include <stdio.h>
#include <stdlib.h>
#include "RCBfit.h"

int
main (int argc, char *argv[])
{
    void    initialize(double*);
    double  value(double*);
    void    prn_data(int*, int*, double*, double*, double*);
    
    if (argc>=4 || argc==2) 
    {
	fprintf (stderr,"Wrong number of arguments: %d\n", argc);
	exit(1);
    }
    else
    {
	rcb_set_customized_data_output(prn_data);
	if (argc==1) 
	    RCBfit ("fittp", initialize, value);
	if (argc==3)
	{
	    if (strcmp(argv[1],"-fit")==0)
	    {
		fprintf (stderr, "Calling fit program with tapefile \"%s\"...\n", argv[2]);
		RCBfit (argv[2], initialize, value);
	    }
	    else if (strcmp(argv[1],"-guess")==0)
		rcb_guess (argv[2], initialize, value);
	    else 
		fprintf (stderr, "Unknown option: %s\n", argv[1]);
	}
	exit(0);
    }
}
