/*********************************
 *
 *      FUI header comments
 *
 *  FitDataFormat:    MultiColumn  
 *  NumbDepVars:      5
 *
 *********************************/
#include <math.h>
#include <stdio.h>
#include <stdlib.h>


double         a, b, c, d, scale;

void
initialize (double *parameters)
{
/*
    Begin: Synonyms

    a      initial_value   a
    b      exponent        b
    c      factor1         c
    d      factor2         d
    scale  scale           s

    End: Synonyms
*/
    a = parameters[0];
    b = parameters[1];
    c = parameters[2];
    d = parameters[3];
    scale = parameters[4];
}
double
value (double *t, double *y)  
{  
    double   t2, t3;
    
    t2 = (*t)*(*t);		/* t^2 (auxiliary) */
    t3 = (*t)*t2;		/* t^3 (auxiliary) */

    y[1] = a * exp(-b*(*t));  
    y[2] = a + c*(*t);
    y[3] = d + c*t2;
    y[4] = scale * (y[3] + b*t3); /* scale of Y_4 needs to be determined */
    y[5] = a + d*(*t) + b*t2;
}
void
dcnv (int *data_idx, int *var_idx, double *exp_val, double *cal_val, double *c)
{
    if (*var_idx == 4)		/* adjust output for Y_4 according to parameter estimate */
    {
	c[0] = *exp_val/scale;
	c[1] = *cal_val/scale;
    }
    else 
    {
	c[0] = *exp_val;
	c[1] = *cal_val;
    }
}
