#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "RCBfit.h"

double r,k,n0;

int main(int argc, char *argv[])
{
  void initialize(double*);
  double function(double*);
    

  if (argc>4 || argc==2) {
    fprintf (stderr,"Wrong number of arguments.\n");
    exit(1);
  } else {
    if (argc==1) 
      RCBfit ("fittp", initialize, function);
    else {
      if (strcmp(argv[1],"-fit")==0)
        RCBfit (argv[2], initialize, function);
      else if (strcmp(argv[1],"-guess")==0)
        rcb_guess (argv[2], initialize, function);
      else {
        fprintf (stderr, "Unknown option: %s\n", argv[1]);
        exit(1);
      }
    }
  exit(0);
  }
}

void initialize (double *par)
{
/*
   Begin: Synonyms

	r	r	r
	k	k	k
	n0	n0	n0

   End: Synonyms
*/
    r = par[0];
    k = par[1];
    n0 = par[2];
}

double f_dist (double *dy, double *cy)  {  return (log(*dy) - log(*cy));  }
double r_dist (double *cy, double *r)   {  return (exp(log(*cy) + *r));   }

double function (double *time)
{
  double t;
  t = *time;
  return (k*n0/(n0+(k-n0)*exp(-r*t)));
}
