#ifndef _MBS_INTEGRATOR_INTERFACE_H_
#define _MBS_INTEGRATOR_INTERFACE_H_


#include  "mbs-CDVP-types.h"
#include  "mbs-CDEPAC-types.h"

/*
 *  Declare the routine(s) which computes the right hand side of your
 *  system of differential equations and set the pointer  __ode_RHS__ .
 *  Each simulation must have a   u n i q u e   routine computing its
 *  right hand side.
 */
void (*__ode_RHS__)(int, double*, double*, double*);

#define  mbs_ini_clams_runge_kutta(A,B)     mbs_ini_clams_depac((A),(B),__CDEPAC__DDERKF)
#define  mbs_ini_clams_adams_bashforth(A,B) mbs_ini_clams_depac((A),(B),__CDEPAC__DDEABM)
#define  mbs_ini_clams_backward_diff(A,B)   mbs_ini_clams_depac((A),(B),__CDEPAC__DDEBDF)

/*
 *  prototypes
 */
void  mbs_set_clams_ode_right_hand_side (void(*)(int,double*,double*,double*));

void  mbs_clams_ddrive (int, double*, double*, double, int);
void  mbs_ini_clams_ddrive (int, void(*)(int,double*,double*,double*));
void  mbs_set_clams_ddrive_ewt (int, double*);
void  mbs_set_clams_ddrive_parameter (int, void*);

void  mbs_clams_runge_kutta (int, double*, double*, double, int);
void  mbs_clams_adams_bashforth (int, double*, double*, double, int);
void  mbs_clams_backward_diff (int, double*, double*, double, int);
void  mbs_ini_clams_depac (int, void(*)(int,double*,double*,double*), int);
void  mbs_set_clams_depac_info (int, int);
void  mbs_set_clams_depac_eps (int, double);
void  mbs_set_clams_depac_abs (int, double);

void  mbs_num_rec_runge_kutta (int, double*, double*, double, int);
void  mbs_num_rec_bulirsch_stoer (int, double*, double*, double, int);


#endif
