
proc getDatafile {windowName} {
    global  FUIdataChanged

    regexp {.d.bd\(([0-9]+)\)} $windowName match i
    getFileNameByBrowser . data$i
    set FUIdataChanged 1
}
proc createDataFileSelection {n} {
    global     fit_mode tk_version filenameByBrowser
    global     data_use_nmax data_skip_first data_skip
    global     data_nmax data_numb_skip_first data_skip_intv
    global     FUIstandardFont FUIbackground tk_version

    for {set i 0} {$i<$n} {incr i} {
        frame .d.f($i)    
        button .d.bd($i) -text "Data File [expr $i+1]" -relief flat \
            -font $FUIstandardFont(pane)
        bind .d.bd($i) <1> { getDatafile "%W" }
        entry .d.ed($i) -width 35 -relief sunken -bd 2 \
            -textvariable filenameByBrowser(data$i) -bd 2 \
            -font $FUIstandardFont(popupEntry)
        button .d.opt($i) -text "Options..." -relief raised -font $FUIstandardFont(1)
        bind .d.opt($i) <1> {
                regexp {.d.opt\(([0-9]+)\)} "%W" match index
                createDataOptionSelection $index
            }
        pack .d.bd($i) -ipadx 5m -pady 3m -side left -in .d.f($i)
        pack .d.ed($i) -padx 5m -pady 3m -side left -in .d.f($i)
        pack .d.opt($i) -ipadx 3m -padx 2m -pady 3m -side left -in .d.f($i)
        pack .d.f($i)
        if {![info exists data_use_nmax($i)]}        { set data_use_nmax($i) 0 }
        if {![info exists data_skip_first($i)]}      { set data_skip_first($i) 0 }
        if {![info exists data_skip($i)]}            { set data_skip($i) 0 }
        if {![info exists data_nmax($i)]}            { set data_nmax($i) 100 }
        if {![info exists data_numb_skip_first($i)]} { set data_numb_skip_first($i) 0 }
        if {![info exists data_skip_intv($i)]}       { set data_skip_intv($i) 1 }
        if {$tk_version>=4.0} {
            .d.bd($i) configure -highlightbackground $FUIbackground -takefocus 0
            .d.ed($i) configure -highlightbackground $FUIbackground 
            .d.opt($i) configure -highlightbackground $FUIbackground -takefocus 0
        }
    }
    if {$n>1} {
        frame .d.fm
        label .d.fml -text "Fit data" -font $FUIstandardFont(pane) 
        radiobutton .d.fm_sim -text simultaneously -variable fit_mode -value 0 -relief flat \
            -font $FUIstandardFont(pane)
        radiobutton .d.fm_sep -text separately -variable fit_mode -value 1 -relief flat \
            -font $FUIstandardFont(pane)
        pack .d.fml .d.fm_sim .d.fm_sep -padx 5m -side left -in .d.fm
        pack .d.fm -pady 3m -anchor w
        if {$tk_version>=4.0} {
            .d.fm_sim configure -highlightbackground $FUIbackground -takefocus 0
            .d.fm_sep configure -highlightbackground $FUIbackground -takefocus 0
        }
    }
}
proc destroyDataFileSelection n {
    global fit_mode

    set fit_mode 0
    for {set i 0} {$i<$n} {incr i} {
        destroy .d.bd($i) .d.ed($i) .d.f($i) .d.opt($i)
    }
    if {$n>1} {
        destroy .d.fml .d.fm_sim .d.fm_sep .d.fm
    }
}
proc mapDataDescription {} {
    global  numb_exp numb_exp_old numb_par FUIdataChanged
    global  FUIstandardFont FUIbackground tk_version

    if [winfo exists .d] { raise .d } else {
        toplevel .d
        wm title .d "FUI: data"
        frame .d.fne
        label .d.nexp -text "Number of experiments:" -font $FUIstandardFont(pane) 
        entry .d.nx -width 3 -bd 2 -font $FUIstandardFont(pane) \
            -relief sunken -textvariable numb_exp
        bind .d.nx <Return> {
            if [regexp {^[1-9][0-9]*$} $numb_exp] {
                destroyDataFileSelection  $numb_exp_old
                createDataFileSelection   $numb_exp
                if [winfo exists .p] {
                    updateParDescription $numb_par $numb_par $numb_exp $numb_exp_old
                }
                if [winfo exists .paav] { destroy .paav }
                set numb_exp_old $numb_exp
                set FUIdataChanged 1
            } else {
                BSerror "mapDataDescription" \
                    "Number of experiments must be a strictly positive integer"
            }
        }
        pack .d.nexp .d.nx -padx 2m -pady 2m -side left -in .d.fne
        button .d.close -text "C L O S E" -command "destroy .d" -font $FUIstandardFont(pane)
        frame .d.fne_frame -width 2.1c
        pack .d.close -padx 2m -pady 2m -ipadx 4m -side right -in .d.fne
        pack .d.fne_frame -side right -in .d.fne
        pack .d.fne -pady 2m -anchor e
        set numb_exp_old $numb_exp
        createDataFileSelection $numb_exp
        focus .d.nx
        if {$tk_version>=4.0} {
            .d.nx configure -highlightbackground $FUIbackground
            .d.close configure -highlightbackground $FUIbackground -takefocus 0
        }
    }
}
proc createDataOptionSelection {i} {
    global  FUIstandardFont FUIbackground tk_version
    global  data_use_nmax data_skip_first data_skip
    global  data_nmax data_numb_skip_first data_skip_intv

    if [winfo exists .dos$i] { raise .dos$i } else {
        toplevel .dos$i
        wm title .dos$i "FUI: Data [expr $i+1] Options"
        frame .dos$i.f1
        checkbutton .dos$i.nmax_cb -variable data_use_nmax($i)
        label .dos$i.nmax_l1 -text "Fit at most" -font $FUIstandardFont(1)
        entry .dos$i.nmax -width 5 -relief sunken -textvariable data_nmax($i) \
            -font $FUIstandardFont(1)
        label .dos$i.nmax_l2 -text "data points." -font $FUIstandardFont(1)
        pack .dos$i.nmax_cb .dos$i.nmax_l1 .dos$i.nmax .dos$i.nmax_l2 \
            -side left -padx 3m -pady 3m -in .dos$i.f1
        frame .dos$i.f2
        checkbutton .dos$i.skip0_cb -variable data_skip_first($i)
        label .dos$i.skip0_l1 -text "Skip first" -font $FUIstandardFont(1)
        entry .dos$i.skip0 -width 5 -relief sunken -textvariable data_numb_skip_first($i) \
            -font $FUIstandardFont(1)
        label .dos$i.skip0_l2 -text "data points." -font $FUIstandardFont(1)
        pack .dos$i.skip0_cb .dos$i.skip0_l1 .dos$i.skip0 .dos$i.skip0_l2 \
            -side left -padx 3m -pady 3m -in .dos$i.f2
        frame .dos$i.f3
        checkbutton .dos$i.skip_cb -variable data_skip($i)
        label .dos$i.skip_l1 -text "Use every" -font $FUIstandardFont(1)
        entry .dos$i.skip -width 5 -relief sunken -textvariable data_skip_intv($i) \
            -font $FUIstandardFont(1)
        label .dos$i.skip_l3 -text "." -font $FUIstandardFont(1)
        label .dos$i.skip_l2 -text "data point." -font $FUIstandardFont(1)
        pack .dos$i.skip_cb .dos$i.skip_l1 -padx 3m -pady 3m -side left -in .dos$i.f3
        pack .dos$i.skip .dos$i.skip_l3 -pady 3m -side left -in .dos$i.f3
        pack .dos$i.skip_l2 -side left -padx 3m -pady 3m -in .dos$i.f3
        pack .dos$i.f1 .dos$i.f2 .dos$i.f3 -side top -anchor w
        button .dos$i.close -text "C L O S E" -font $FUIstandardFont(1) -command {
            global  FUIdosIndex tk_version
            destroy .dos$FUIdosIndex
        }
        bind .dos$i.close <Button-1> {
            global  FUIdosIndex tk_version
            if {$tk_version<4.0} { tk_butDown %W }
            regexp {.dos([0-9]+).close} "%W" match FUIdosIndex
        }
        pack .dos$i.close -ipadx 3m -padx 2m -pady 3m -side top -anchor e
        focus .dos$i.nmax
        if {$tk_version>=4.0} {
            .dos$i.nmax_cb configure -highlightbackground $FUIbackground -takefocus 0
            .dos$i.skip0_cb configure -highlightbackground $FUIbackground -takefocus 0
            .dos$i.skip_cb configure -highlightbackground $FUIbackground -takefocus 0
            .dos$i.nmax configure -highlightbackground $FUIbackground
            .dos$i.skip0 configure -highlightbackground $FUIbackground
            .dos$i.skip configure -highlightbackground $FUIbackground
            .dos$i.close configure -highlightbackground $FUIbackground -takefocus 0
        }
    }
}
