
proc mapFitParameters {} {
    global  cc do_jacknife
    global  FUIstandardFont FUIbackground tk_version

    if [winfo exists .fit] { raise .fit } else {
        toplevel .fit
        wm title .fit "FUI: fit parameters"
        label .fit.conv_label -text "Convergence Criteria for Optimization:" \
            -font $FUIstandardFont(pane) 
        pack .fit.conv_label -padx 3m -pady 2m -anchor w
        frame .fit.c_frame
        frame .fit.c_labels
        frame .fit.c_sep
        frame .fit.c_entries
        label .fit.c_l(maxfev) -text "maxfev" -font $FUIstandardFont(pane) 
        entry .fit.c_e(maxfev) -width 10 -relief sunken -textvariable cc(maxfev) \
            -font $FUIstandardFont(pane) 
        bind .fit.c_e(maxfev) <Tab> { focus .fit.c_e(ftol) }
        label .fit.c_l(ftol) -text ftol -font $FUIstandardFont(pane) 
        entry .fit.c_e(ftol) -width 10 -relief sunken -textvariable cc(ftol) \
            -font $FUIstandardFont(pane) 
        bind .fit.c_e(ftol) <Tab> { focus .fit.c_e(xtol) }
        label .fit.c_l(xtol) -text xtol -font $FUIstandardFont(pane) 
        entry .fit.c_e(xtol) -width 10 -relief sunken -textvariable cc(xtol) \
            -font $FUIstandardFont(pane) 
        bind .fit.c_e(xtol) <Tab> { focus .fit.c_e(gtol) }
        label .fit.c_l(gtol) -text gtol -font $FUIstandardFont(pane) 
        entry .fit.c_e(gtol) -width 10 -relief sunken -textvariable cc(gtol) \
            -font $FUIstandardFont(pane) 
        bind .fit.c_e(gtol) <Tab> { focus .fit.c_e(maxfev) }
        pack  .fit.c_l(maxfev) .fit.c_l(ftol) .fit.c_l(xtol) .fit.c_l(gtol) \
            -padx 3m -anchor w -in .fit.c_labels
        pack  .fit.c_e(maxfev) .fit.c_e(ftol) .fit.c_e(xtol) .fit.c_e(gtol) \
            -in .fit.c_entries
        pack  .fit.c_labels -side left -in .fit.c_frame
        pack  .fit.c_sep -side left -padx 5m -in .fit.c_frame
        pack  .fit.c_entries -side right -in .fit.c_frame
        pack  .fit.c_frame -pady 2m 
        frame .fit.j_f
        label .fit.j_l -text "Perform jacknife fitting: " -font $FUIstandardFont(pane) 
        radiobutton .fit.j_yes -text yes -variable do_jacknife -value 1 -relief flat \
            -font $FUIstandardFont(pane)
        radiobutton .fit.j_no -text no -variable do_jacknife -value 0 -relief flat \
            -font $FUIstandardFont(pane)
        pack .fit.j_l .fit.j_yes .fit.j_no -padx 3m -pady 2m -side left -in .fit.j_f 
        pack .fit.j_f -anchor w
        button .fit.close -text "C L O S E" -command "destroy .fit" \
            -font $FUIstandardFont(pane)
        pack .fit.close -padx 2m -pady 2m -ipadx 4m -anchor e
        focus .fit.c_e(maxfev)
        if {$tk_version>=4.0} {
            .fit.c_e(maxfev) configure -highlightbackground $FUIbackground
            .fit.c_e(ftol) configure -highlightbackground $FUIbackground
            .fit.c_e(xtol) configure -highlightbackground $FUIbackground
            .fit.c_e(gtol) configure -highlightbackground $FUIbackground
            .fit.j_yes configure -highlightbackground $FUIbackground -takefocus 0
            .fit.j_no configure -highlightbackground $FUIbackground -takefocus 0
            .fit.close configure -highlightbackground $FUIbackground -takefocus 0
        }
    }
}
