
proc FUIinitialize filename {
    global  env
    global  numb_par numb_par_old numb_exp numb_exp_old
    global  number_of_simulations sim_noise confidence
    global  cc do_jacknife fit_mode fit_status
    global  FUIfit_instance FUIcleanup_interval 
    global  FUIplot_status FUItmp FUIuid
    global  FUIgraphType FUIaxisLabelStyle FUIaxisTitle
    global  FUIstartupDirectory FUIrootDirectory
    global  two_column_data numb_dependent_vars FORTRAN_has_C_main
    global  residual_scale_type
    global  xvgrGraph xvgrColor xvgrUseP filenameByBrowser
    global  savefile readfile resultfile
    global  FUIstandardFont FUIbackground
    global  tcl_precision FloatingpointNumber

    set tcl_precision 10
    set FUIstandardFont(1)  -*-helvetica-bold-r-normal--*-120-*
    set FUIstandardFont(2)  -*-times-medium-r-normal--*-140-*
    set FUIstandardFont(3)  -*-helvetica-bold-r-normal--*-140-*
    set FUIstandardFont(menubar)    $FUIstandardFont(3)
    set FUIstandardFont(menu)       $FUIstandardFont(1)
    set FUIstandardFont(pane)       $FUIstandardFont(1)
    set FUIstandardFont(popup)      $FUIstandardFont(1)
    set FUIstandardFont(popupEntry) $FUIstandardFont(2)

    set FUIbackground [lindex [. configure -bg] 4]

    set FUIstartupDirectory [pwd]
    if {[info exists env(FUIHOME)]} {
        set FUIrootDirectory $env(FUIHOME)
    }

    cd $FUIstartupDirectory
    set FUIuid [pid]
    set FUItmp "/tmp/FUI$FUIuid"
    set FloatingpointNumber {[-]?[0-9]*(\.[0-9]+)?([eE][-+]?[0-9]+)?}

    set xvgrGraph(0) xy
    set xvgrGraph(1) logy
    set xvgrGraph(2) logx
    set xvgrGraph(3) logxy
    set xvgrColor color
    set xvgrUseP  0
    set filenameByBrowser(xvgrParameters) ""

    set FUIplot_status 0
    set FUIgraphType 0
    set FUIaxisLabelStyle(x) decimal
    set FUIaxisLabelStyle(y) decimal
    set FUIaxisTitle(x) ""
    set FUIaxisTitle(y) ""
    set FUIfit_instance 0
    set FUIcleanup_interval 10
    set fit_status ""
    set numb_par 0
    set numb_par_old 0
    set numb_exp 1
    set numb_exp_old 1

    set number_of_simulations 0
    set sim_noise 3
    set confidence 95
    set cc(maxfev) 999
    set cc(ftol)   1e-9
    set cc(xtol)   1e-9
    set cc(gtol)   0.0
    set do_jacknife 0
    set fit_mode 0
    set savefile ""
    set readfile $filename

    set two_column_data      1
    set numb_dependent_vars  2
    set FORTRAN_has_C_main   0
    set residual_scale_type  abs

    if {$readfile!=""} { 
        FUIreadSetup init 
    } else {
        for {set i 0} {$i<$numb_exp} {incr i} {
            set data_use_nmax($i) 0
            set data_skip_first($i) 0
            set data_skip($i) 0
            set data_nmax($i) 100
            set data_numb_skip_first($i) 0
            set data_skip_intv($i) 1
        }
    }
    set resultfile ""
}
proc FUImapMainWindow {} {
    global env readfile tk_version
    global FUIrootDirectory
    global FUIgraphType FUIaxisLabelStyle FUIstandardFont FUIbackground
    
    frame .mbar -relief raised -bd 2
#   frame .logo -relief ridge
    pack .mbar -side top -fill x
#   pack .logo -side top
#   if {[info exists env(HOSTNAME)] && $env(HOSTNAME)=="loplop"} {
#       label .bitmap -bitmap "@$FUIrootDirectory/lib/Tk/logo-small.xbm" -bg orangered -fg palegreen
#   } else {
#       label .bitmap -bitmap "@$FUIrootDirectory/lib/Tk/logo-small.xbm" -bg #ffffdddddddd
#   }
#   pack .bitmap -in .logo
    menubutton .mbar.file -text File -menu .mbar.file.menu \
        -font $FUIstandardFont(menubar)
    menubutton .mbar.input -text Input -menu .mbar.input.menu \
        -font $FUIstandardFont(menubar)
    menubutton .mbar.model -text Model -menu .mbar.model.menu \
        -font $FUIstandardFont(menubar)
    menubutton .mbar.plot -text Plot -menu .mbar.plot.menu \
        -font $FUIstandardFont(menubar)
    menubutton .mbar.diag -text Diagnostics -menu .mbar.diag.menu \
        -font $FUIstandardFont(menubar)
    button .mbar.help -text Help -font $FUIstandardFont(menubar) -relief flat -pady 1 \
        -command { mapHelpWindow "$FUIrootDirectory/lib/Tk/FUI-DOC" doc.txt }
    frame .mbar.separator -width 15m
    pack .mbar.file .mbar.input .mbar.model .mbar.plot .mbar.diag -side left -ipadx 3.5m
    pack .mbar.help -side right -anchor e -fill x -ipadx 3.5m
    menu .mbar.file.menu
    .mbar.file.menu add command -label "Save Setup" -command "FUIsaveSetup current" \
        -font $FUIstandardFont(menu)
    .mbar.file.menu add command -label "Save Setup as..." -command "FUIsaveSetup new" \
        -font $FUIstandardFont(menu)
    .mbar.file.menu add command -label "Read Setup..." -command "FUIreadSetup" \
        -font $FUIstandardFont(menu)
    .mbar.file.menu add separator
    .mbar.file.menu add command -label "Save Tapefile as..." -command "saveTapeFileQuery" \
        -font $FUIstandardFont(menu)
    .mbar.file.menu add separator
    .mbar.file.menu add command -label "Save Results" -command "FUIsaveResults current" \
        -font $FUIstandardFont(menu)
    .mbar.file.menu add command -label "Save Results as..." -command "FUIsaveResults new" \
        -font $FUIstandardFont(menu)
    .mbar.file.menu add separator
    .mbar.file.menu add command -label Exit -font $FUIstandardFont(menu) \
        -command { 
            global  FUIstartupDirectory FUItmp FUIuid
            if [regexp FUI$FUIuid [glob /tmp/*]] { 
                eval exec rm [glob ${FUItmp}*] 
            }
            cd $FUIstartupDirectory
            exit 
        }
    menu .mbar.input.menu
    .mbar.input.menu add command -label "Parameters..." -command "mapParDescription" \
        -font $FUIstandardFont(menu)
    .mbar.input.menu add command -label "Data..." -command "mapDataDescription" \
        -font $FUIstandardFont(menu)
    .mbar.input.menu add command -label "Fitting..." -command "mapFitParameters" \
        -font $FUIstandardFont(menu)
    .mbar.input.menu add command -label "Simulations..." -command "mapSimulationDescription" \
        -font $FUIstandardFont(menu)
    menu .mbar.model.menu
    .mbar.model.menu add command -label "Specify Model..." -command "getModelSpecifications" \
        -font $FUIstandardFont(menu)
    .mbar.model.menu add command -label "Fit Data" -command "doFit" \
        -font $FUIstandardFont(menu)
    .mbar.model.menu add command -label "Copy Fit" -command "copyFit" \
        -font $FUIstandardFont(menu)
    .mbar.model.menu add command -label "Plot Guess" -command "calcNdrawGuess" \
        -font $FUIstandardFont(menu)
    menu .mbar.plot.menu
    .mbar.plot.menu add cascade -label "Plot Fits & Data" -menu .mbar.plot.menu.fdmode \
        -font $FUIstandardFont(menu)
    .mbar.plot.menu add cascade -label "Plot Fits" -menu .mbar.plot.menu.fmode \
        -font $FUIstandardFont(menu)
    .mbar.plot.menu add cascade -label "Plot Data" -menu .mbar.plot.menu.dmode \
        -font $FUIstandardFont(menu)
    .mbar.plot.menu add cascade -label "Plot Residuals" -menu .mbar.plot.menu.rmode \
        -font $FUIstandardFont(menu)
    .mbar.plot.menu add separator
    .mbar.plot.menu add cascade -label "Graph Type" -menu .mbar.plot.menu.graph \
        -font $FUIstandardFont(menu)
    .mbar.plot.menu add cascade -label "Annotations" -menu .mbar.plot.menu.label \
        -font $FUIstandardFont(menu)
    .mbar.plot.menu add separator
    .mbar.plot.menu add command -label "Grace Options..." -command "mapXvgrOptions" \
        -font $FUIstandardFont(menu)
    menu .mbar.plot.menu.fmode
    .mbar.plot.menu.fmode add command -label "...Common Frame" -command "FUIplot single f" \
        -font $FUIstandardFont(menu)
    .mbar.plot.menu.fmode add command -label "...Separate Frames" -command "FUIplot multiple f" \
        -font $FUIstandardFont(menu) 
    .mbar.plot.menu.fmode add command -label "...Grace" -command "FUIplot xvgr f" \
        -font $FUIstandardFont(menu) 
    menu .mbar.plot.menu.fdmode
    .mbar.plot.menu.fdmode add command -label "...Common Frame" -command "FUIplot single fd" \
        -font $FUIstandardFont(menu)
    .mbar.plot.menu.fdmode add command -label "...Separate Frames" -command "FUIplot multiple fd" \
        -font $FUIstandardFont(menu) 
    .mbar.plot.menu.fdmode add command -label "...Grace" -command "FUIplot xvgr fd" \
        -font $FUIstandardFont(menu) 
    menu .mbar.plot.menu.dmode
    .mbar.plot.menu.dmode add command -label "...Common Frame" -command "FUIplot single d" \
        -font $FUIstandardFont(menu) 
    .mbar.plot.menu.dmode add command -label "...Separate Frames" -command "FUIplot multiple d" \
        -font $FUIstandardFont(menu) 
    .mbar.plot.menu.dmode add command -label "...Grace" -command "FUIplot xvgr d" \
        -font $FUIstandardFont(menu) 
    menu .mbar.plot.menu.rmode
    .mbar.plot.menu.rmode add command -label "...Common Frame" -command "FUIplot single res" \
        -font $FUIstandardFont(menu) 
    .mbar.plot.menu.rmode add command -label "...Separate Frames" -command "FUIplot multiple res" \
        -font $FUIstandardFont(menu) 
    .mbar.plot.menu.rmode add command -label "...Grace" -command "FUIplot xvgr res" \
        -font $FUIstandardFont(menu) 
    menu .mbar.plot.menu.graph
    .mbar.plot.menu.graph add radiobutton -label "XY graph" -variable FUIgraphType -value 0 \
        -font $FUIstandardFont(menu)
    .mbar.plot.menu.graph add radiobutton -label "Linear--Log" -variable FUIgraphType -value 1 \
        -font $FUIstandardFont(menu)
    .mbar.plot.menu.graph add radiobutton -label "Log--Linear" -variable FUIgraphType -value 2 \
        -font $FUIstandardFont(menu)
    .mbar.plot.menu.graph add radiobutton -label "Log--Log" -variable FUIgraphType -value 3 \
        -font $FUIstandardFont(menu)
    menu .mbar.plot.menu.label
    .mbar.plot.menu.label add command -label "Axis Titles..." -font $FUIstandardFont(menu) \
        -command {FUIqueryAxesTitle}
    .mbar.plot.menu.label add separator
    .mbar.plot.menu.label add cascade -label "X Axis Labels" -menu .mbar.plot.menu.label.xlabel \
        -font $FUIstandardFont(menu)
    menu .mbar.plot.menu.label.xlabel
    .mbar.plot.menu.label.xlabel add radiobutton -label "Decimal" -font $FUIstandardFont(menu) \
        -variable FUIaxisLabelStyle(x) -value decimal
    .mbar.plot.menu.label.xlabel add radiobutton -label "Power" -font $FUIstandardFont(menu) \
        -variable FUIaxisLabelStyle(x) -value power -command {
	    if {$FUIgraphType==0 || $FUIgraphType==1} {
                set FUIaxisLabelStyle(x) decimal
            }
        }
    .mbar.plot.menu.label add cascade -label "Y Axis Labels" -menu .mbar.plot.menu.label.ylabel \
        -font $FUIstandardFont(menu)
    menu .mbar.plot.menu.label.ylabel
    .mbar.plot.menu.label.ylabel add radiobutton -label "Decimal" -font $FUIstandardFont(menu) \
        -variable FUIaxisLabelStyle(y) -value decimal
    .mbar.plot.menu.label.ylabel add radiobutton -label "Power" -font $FUIstandardFont(menu) \
        -variable FUIaxisLabelStyle(y) -value power -command {
	    if {$FUIgraphType==0 || $FUIgraphType==2} {
                set FUIaxisLabelStyle(y) decimal
            }
        }
    menu .mbar.diag.menu
    .mbar.diag.menu add command -label "Partial Averages..." \
        -font $FUIstandardFont(menu) -command displayPartialAverages
    if {$tk_version>=4.0} {
        .mbar.help configure -highlightbackground $FUIbackground
    }
}
