
proc updateKeepSelection {windowName} {
    regexp {.p.pkeep\(([0-9]+),([0-9]+)\)} $windowName match i j
    global par_keep numb_exp numb_par
    global ParameterTabList

    if $par_keep($i,$j)  {
        for {set j 1} {$j<$numb_exp} {incr j} {
            PDsetFrames $i $j
            PDsetValues $i $j noTabListInsert
            set k [expr [lsearch -exact $ParameterTabList .p.pguess($i,[expr $j-1])]+1]
            set ParameterTabList [linsert $ParameterTabList $k .p.pguess($i,$j)]
        }
        foreach win $ParameterTabList {
            bind $win <Tab> { }
            bind $win <Tab> { tabForward $ParameterTabList }
        }
        foreach win $ParameterTabList {
            bind $win <Meta-Tab> { }
            bind $win <Meta-Tab> { tabBackward $ParameterTabList }
        }
    } else {
        set focus_window [lindex $ParameterTabList [lsearch -exact $ParameterTabList [focus]]]
        for {set j 1} {$j<$numb_exp} {incr j} {
            if {$focus_window == ".p.pguess($i,$j)"} {
                set k [expr $i+1]
                if {$k>=$numb_par} { set k 0 }
                focus .p.pguess($k,0)
            }
            set k [lsearch -exact $ParameterTabList .p.pguess($i,$j)]
            set ParameterTabList [lreplace $ParameterTabList $k $k]
            destroy .p.pguess($i,$j) .p.pfit($i,$j) .p.psim_mean($i,$j) \
                .p.psim_var($i,$j)
            destroy .p.fname($i,$j) .p.ffixed($i,$j) .p.fkeep($i,$j) \
                .p.fpos($i,$j) .p.fguess($i,$j) .p.ffit($i,$j) \
                .p.fsim_mean($i,$j) .p.fsim_var($i,$j)
            destroy .p.fpd($i,$j)
        }
    }
}
proc PDsetFrames {i j} {
    frame .p.fpd($i,$j)
    frame .p.fname($i,$j) -width 2.6c -height 21p
    pack propagate .p.fname($i,$j) 0
    frame .p.ffixed($i,$j) -width 2.6c -height 21p
    pack propagate .p.ffixed($i,$j) 0
    frame .p.fkeep($i,$j) -width 2.6c -height 21p
    pack propagate .p.fkeep($i,$j) 0
    frame .p.fpos($i,$j) -width 2.6c -height 21p
    pack propagate .p.fpos($i,$j) 0
    frame .p.fguess($i,$j) -width 2.6c -height 21p
    pack propagate .p.fguess($i,$j) 0
    frame .p.ffit($i,$j) -width 2.6c -height 21p
    pack propagate .p.ffit($i,$j) 0
    frame .p.fsim_mean($i,$j) -width 2.6c -height 21p
    pack propagate .p.fsim_mean($i,$j) 0
    frame .p.fsim_var($i,$j) -width 2.6c -height 21p
    pack propagate .p.fsim_var($i,$j) 0
    pack .p.fname($i,$j) .p.ffixed($i,$j) .p.fkeep($i,$j) .p.fpos($i,$j) \
        .p.fguess($i,$j) .p.ffit($i,$j) .p.fsim_mean($i,$j) .p.fsim_var($i,$j) \
        -side left -in .p.fpd($i,$j)
    if {$j} {
        pack .p.fpd($i,$j) -in .p.fpd -after .p.fpd($i,[expr $j-1])
    } else {
        pack .p.fpd($i,$j) -in .p.fpd
    }
}
proc PDsetSelections {i j} {
    global  par_name par_fixed par_keep par_pos
    global  par_guess par_fit par_sim_lower par_sim_upper
    global  FUIstandardFont FUIbackground tk_version
    global  numb_par ParameterTabList

    label .p.pname($i,$j) -text $par_name($i,$j) -font $FUIstandardFont(pane) 
    pack .p.pname($i,$j) -side top -anchor w -in .p.fname($i,$j)
    checkbutton .p.pfixed($i,$j) -variable par_fixed($i,$j)
    pack .p.pfixed($i,$j) -side top -in .p.ffixed($i,$j)
    checkbutton .p.pkeep($i,$j) -variable par_keep($i,$j)
    if {$tk_version>=4.0} {
        bind .p.pkeep($i,$j) <1> {updateKeepSelection "%W"}
    } else {
        bind .p.pkeep($i,$j) <1> {tk_butDown %W; updateKeepSelection "%W"}
    }
    pack .p.pkeep($i,$j) -side top -in .p.fkeep($i,$j)
    checkbutton .p.ppos($i,$j) -variable par_pos($i,$j)
    pack .p.ppos($i,$j) -side top -in .p.fpos($i,$j)
    entry .p.pguess($i,$j) -width 10 -bd 2 -font $FUIstandardFont(pane) \
        -relief sunken -textvariable par_guess($i,$j)
    pack .p.pguess($i,$j) -side top -in .p.fguess($i,$j)
    set ParameterTabList [linsert $ParameterTabList end .p.pguess($i,$j)]
    entry .p.pfit($i,$j) -width 10 -bd 2 -font $FUIstandardFont(pane) \
        -relief flat -textvariable par_fit($i,$j)
    pack .p.pfit($i,$j) -side top -in .p.ffit($i,$j)
    entry .p.psim_mean($i,$j) -width 10 -bd 2 -font $FUIstandardFont(pane) \
        -relief flat -textvariable par_sim_lower($i,$j)
    pack .p.psim_mean($i,$j) -side top -in .p.fsim_mean($i,$j)
    entry .p.psim_var($i,$j) -width 10 -bd 2 -font $FUIstandardFont(pane) \
        -relief flat -textvariable par_sim_upper($i,$j)
    pack .p.psim_var($i,$j) -side top -in .p.fsim_var($i,$j)
    if {$tk_version>=4.0} {
        .p.pfixed($i,$j) configure -highlightbackground $FUIbackground
        .p.pkeep($i,$j) configure -highlightbackground $FUIbackground
        .p.ppos($i,$j) configure -highlightbackground $FUIbackground
        .p.pguess($i,$j) configure -highlightbackground $FUIbackground
        .p.pfit($i,$j) configure -highlightbackground $FUIbackground
        .p.psim_mean($i,$j) configure -highlightbackground $FUIbackground
        .p.psim_var($i,$j) configure -highlightbackground $FUIbackground
        .p.pfixed($i,$j) configure -takefocus 0
        .p.pkeep($i,$j) configure -takefocus 0
        .p.ppos($i,$j) configure -takefocus 0
        .p.pfit($i,$j) configure -takefocus 0
        .p.psim_mean($i,$j) configure -takefocus 0
        .p.psim_var($i,$j) configure -takefocus 0
    }
}
proc PDsetValues {i j mode} {
    global  par_guess par_fit par_sim_lower par_sim_upper par_keep
    global  FUIstandardFont FUIbackground tk_version
    global  ParameterTabList

    entry .p.pguess($i,$j) -width 10 -bd 2 -font $FUIstandardFont(pane) \
        -relief sunken -textvariable par_guess($i,$j)
    pack .p.pguess($i,$j) -side top -in .p.fguess($i,$j)
    if {$mode == "TabListInsert"} {
        set ParameterTabList [linsert $ParameterTabList end .p.pguess($i,$j)]
    }
    entry .p.pfit($i,$j) -width 10 -bd 2 -font $FUIstandardFont(pane) \
        -relief flat -textvariable par_fit($i,$j)
    pack .p.pfit($i,$j) -side top -in .p.ffit($i,$j)
    entry .p.psim_mean($i,$j) -width 10 -bd 2 -font $FUIstandardFont(pane) \
        -relief flat -textvariable par_sim_lower($i,$j)
    pack .p.psim_mean($i,$j) -side top -in .p.fsim_mean($i,$j)
    entry .p.psim_var($i,$j) -width 10 -bd 2 -font $FUIstandardFont(pane) \
        -relief flat -textvariable par_sim_upper($i,$j)
    pack .p.psim_var($i,$j) -side top -in .p.fsim_var($i,$j)
    if {$tk_version>=4.0} {
        .p.pguess($i,$j) configure -highlightbackground $FUIbackground
        .p.pfit($i,$j) configure -highlightbackground $FUIbackground
        .p.psim_mean($i,$j) configure -highlightbackground $FUIbackground
        .p.psim_var($i,$j) configure -highlightbackground $FUIbackground
        .p.pfit($i,$j) configure -takefocus 0
        .p.psim_mean($i,$j) configure -takefocus 0
        .p.psim_var($i,$j) configure -takefocus 0
    }
}
proc createParDescription {np nx} {
    global ParameterTabList

    set ParameterTabList [list]
    for {set i 0} {$i<$np} {incr i} {
        set j 0
        PDsetFrames $i $j
        PDsetSelections $i $j
        global  par_keep
        set k [set par_keep($i,$j)]
        if {$k == 0} {
            for {set j 1} {$j<$nx} {incr j} {
                PDsetFrames $i $j
                PDsetValues $i $j TabListInsert
            }
        }
    }
    label .p.comment_keep -text "* when fitting multiple data sets, \
        parameter will remain the same for each data set" \
        -font -*-helvetica-bold-r-normal--*-100-*
    pack .p.comment_keep -pady 3m -anchor w -in .p.fpd
    foreach win $ParameterTabList {
        bind $win <Tab> { }
        bind $win <Tab> { tabForward $ParameterTabList }
    }
    foreach win $ParameterTabList {
        bind $win <Meta-Tab> { }
        bind $win <Meta-Tab> { tabBackward $ParameterTabList }
    }
}
proc destroyParDescription {np nx} {
    global par_keep

    for {set i 0} {$i<$np} {incr i} {
        set j 0
        destroy .p.pname($i,$j) .p.pfixed($i,$j) .p.pkeep($i,$j) .p.ppos($i,$j) \
            .p.pguess($i,$j) .p.pfit($i,$j) .p.psim_mean($i,$j) .p.psim_var($i,$j)
        destroy .p.fname($i,$j) .p.ffixed($i,$j) .p.fkeep($i,$j) .p.fpos($i,$j) \
            .p.fguess($i,$j) .p.ffit($i,$j) .p.fsim_mean($i,$j) .p.fsim_var($i,$j)
        destroy .p.fpd($i,$j)
        if {!$par_keep($i,0)} {
            for {set j 1} {$j<$nx} {incr j} {
            destroy .p.pguess($i,$j) .p.pfit($i,$j) .p.psim_mean($i,$j) \
                .p.psim_var($i,$j)
            destroy .p.fname($i,$j) .p.ffixed($i,$j) .p.fkeep($i,$j) \
                .p.fpos($i,$j) .p.fguess($i,$j) .p.ffit($i,$j) \
                .p.fsim_mean($i,$j) .p.fsim_var($i,$j)
            destroy .p.fpd($i,$j)
            }
        }
    }
    destroy .p.comment_keep
}
proc updateParDescription {np old_np nx old_nx} {
    destroyParDescription $old_np $old_nx
    createParDescription  $np $nx
}


proc mapParDescription {} {
    global  numb_par numb_exp numb_par_old
    global  sum_of_square variance fit_status
    global  FUIstandardFont FUIbackground tk_version

    if [winfo exists .p] { raise .p } else {
        toplevel .p
        wm title .p "FUI: parameters"
        frame .p.fnp
        frame .p.results
        frame .p.fsep
        frame .p.fpd
        pack .p.fnp -pady 1m -anchor e
        pack .p.results -pady 1m -anchor w
        pack .p.fsep -pady 1m -padx 1m -anchor w
        pack .p.fpd -pady 1m -padx 2m
        set numb_par_old $numb_par
        button .p.close -text "C L O S E" -command "destroy .p" -font $FUIstandardFont(pane)
        pack .p.close -padx 2m -pady 2m -ipadx 4m -side right -in .p.fnp
        frame .p.f_ssq
        label .p.l_ssq -text "Sum of Squares =" -font $FUIstandardFont(pane) 
        entry .p.e_ssq -width 10 -font $FUIstandardFont(pane) \
            -relief flat -textvariable sum_of_squares
        frame .p.f_var
        label .p.l_var -text "Variance =" -font $FUIstandardFont(pane) 
        entry .p.e_var -width 10 -font $FUIstandardFont(pane) \
            -relief flat -textvariable variance
        pack .p.l_ssq .p.e_ssq  -padx 2m -pady 2m -side left -in .p.f_ssq
        pack .p.l_var .p.e_var  -padx 2m -pady 2m -side left -in .p.f_var
        pack .p.f_ssq .p.f_var -padx 6m -side left -in .p.results
        label .p.query -text "Specify parameter options:" -font $FUIstandardFont(pane) 
        pack .p.query -in .p.fsep
        frame .p.fpd0
        frame .p.fname0 -width 2.6c -height 36p
        pack propagate .p.fname0 0
        frame .p.ffixed0 -width 2.6c -height 36p
        pack propagate .p.ffixed0 0
        frame .p.fkeep0 -width 2.6c -height 36p
        pack propagate .p.fkeep0 0
        frame .p.fpos0 -width 2.6c -height 36p
        pack propagate .p.fpos0 0
        frame .p.fguess0 -width 2.6c -height 36p
        pack propagate .p.fguess0 0
        frame .p.ffit0 -width 2.6c -height 36p
        pack propagate .p.ffit0 0
        frame .p.fsim_mean0 -width 2.6c -height 36p
        pack propagate .p.fsim_mean0 0
        frame .p.fsim_var0 -width 2.6c -height 36p
        pack propagate .p.fsim_var0 0
        pack .p.fname0 .p.ffixed0 .p.fkeep0 .p.fpos0 .p.fguess0 .p.ffit0 .p.fsim_mean0 \
            .p.fsim_var0 -side left -in .p.fpd0
        pack .p.fpd0 -in .p.fpd
        label .p.lname     -text "Name" -font $FUIstandardFont(pane) 
        pack .p.lname -anchor w -pady 2m -in .p.fname0
        label .p.lfixed    -text "Fixed" -font $FUIstandardFont(pane) 
        pack .p.lfixed -pady 2m -in .p.ffixed0
        label .p.lkeep     -text "Keep*" -font $FUIstandardFont(pane) 
        pack .p.lkeep -pady 2m -in .p.fkeep0
        label .p.lpos      -text "Positive" -font $FUIstandardFont(pane) 
        pack .p.lpos -pady 2m -in .p.fpos0
        label .p.lguess    -text "Guess" -font $FUIstandardFont(pane) 
        pack .p.lguess -pady 2m -in .p.fguess0
        label .p.lfit      -text "Result" -font $FUIstandardFont(pane) 
        pack .p.lfit -pady 2m -in .p.ffit0
        label .p.lsim_mean -text "Lower" -font $FUIstandardFont(pane) 
        pack .p.lsim_mean -pady 2m -in .p.fsim_mean0
        label .p.lsim_var  -text "Upper" -font $FUIstandardFont(pane) 
        pack .p.lsim_var -pady 2m -in .p.fsim_var0
        createParDescription $numb_par $numb_exp
        if [winfo exists .p.pguess(0,0)] { focus .p.pguess(0,0) }
        if {$tk_version>=4.0} {
            .p.close configure -highlightbackground $FUIbackground
            .p.e_ssq configure -highlightbackground $FUIbackground
            .p.e_var configure -highlightbackground $FUIbackground
            .p.close configure -takefocus 0
            .p.e_ssq configure -takefocus 0
            .p.e_var configure -takefocus 0
        }
    }
}