
proc FUIplot {mode type} {
    global numb_exp datafile FUIfit_instance FUIplot_status FUItmp
    global two_column_data numb_dependent_vars residual_scale_type
    global TBS_symbolList TBS_linecolorList frame_id
    global FUIgraphType TBSgraphType xvgrGraph xvgrUseP
    global filenameByBrowser
    global FUIaxisLabelStyle FUIaxisTitle TBSaxisLabelStyle TBSaxisTitle
    global FUInextsymbol FUInextcolor
    global FUIplotMaxFrame FUIplotMultiple
    
    if [info exists frame_id] { set frame [expr $frame_id+1] } else { set frame 1 }
    if {$FUIplot_status==0} {
        set FUIplot_status [TBSinitializeStyleConstants]
    }
    set FUInextsymbol 0
    set FUInextcolor  1
    if {$mode=="single"} {
        set FUIplotMultiple 0
        set FUIplotMaxFrame $frame
	set TBSgraphType($frame) $FUIgraphType
        set TBSaxisLabelStyle($frame,x) $FUIaxisLabelStyle(x)
        set TBSaxisLabelStyle($frame,y) $FUIaxisLabelStyle(y)
        set TBSaxisTitle($frame,x)      $FUIaxisTitle(x)
        set TBSaxisTitle($frame,y)      $FUIaxisTitle(y)
        if {$type=="fd"} {
            for {set i 0; set n 0} {$i<$numb_exp} {incr i} {
                if {$two_column_data} {
                    set filename($n) "${FUItmp}plt$FUIfit_instance-$i.sdata"
                    setPlotAttributes $n $frame marker [lindex $TBS_symbolList $FUInextsymbol] "" ""
                    incr FUInextsymbol
                    if {$FUInextsymbol>=[llength $TBS_symbolList]} { set FUInextsymbol 0 }
                    incr n
                    set filename($n) "${FUItmp}plt$FUIfit_instance-$i.fit"
                    setPlotAttributes $n $frame line "" 2 [lindex $TBS_linecolorList $FUInextcolor]
                    incr FUInextcolor
                    if {$FUInextcolor>=[llength $TBS_linecolorList]} { set FUInextcolor 0 }
                    incr n
                } else {
                    for {set k 1} {$k<=$numb_dependent_vars} {incr k} {
                        set filename($n) "${FUItmp}plt$FUIfit_instance-$i-$k.plt-dt"
                        setPlotAttributes $n $frame marker [lindex $TBS_symbolList $FUInextsymbol] "" ""
                        incr FUInextsymbol
                        if {$FUInextsymbol>=[llength $TBS_symbolList]} { set FUInextsymbol 0 }
                        set df($k) [open "${FUItmp}plt$FUIfit_instance-$i-$k.plt-dt" w];   incr n;
                        set filename($n) "${FUItmp}plt$FUIfit_instance-$i-$k.plt-th"
                        setPlotAttributes $n $frame line "" 2 [lindex $TBS_linecolorList $FUInextcolor]
                        incr FUInextcolor
                        if {$FUInextcolor>=[llength $TBS_linecolorList]} { set FUInextcolor 0 }
                        set tf($k) [open "${FUItmp}plt$FUIfit_instance-$i-$k.plt-th" w];   incr n;
                    }
                    set outfile [open "outdata[expr $i+1]"]
                    while {[gets $outfile line]>=0} {
                        set x [lindex $line 0]
                        for {set l 1; set k 1} {$k<=$numb_dependent_vars} {incr k} {
                            puts $df($k) "$x [lindex $line $l]";  incr l
                            puts $tf($k) "$x [lindex $line $l]";  incr l
                        }
                    }
                    for {set k 1} {$k<=$numb_dependent_vars} {incr k} {
                        close $df($k)
                        close $tf($k)
                    }
                    close $outfile
                }
            }
        } elseif {$type=="f"} {
            for {set i 0; set n 0} {$i<$numb_exp} {incr i} {
                if {$two_column_data} {
                    set filename($n) "${FUItmp}plt$FUIfit_instance-$i.fit"
                    setPlotAttributes $n $frame line "" 2 [lindex $TBS_linecolorList $FUInextcolor]
                    incr FUInextcolor
                    if {$FUInextcolor>=[llength $TBS_linecolorList]} { set FUInextcolor 0 }
                    incr n
                } else {
                    for {set k 1} {$k<=$numb_dependent_vars} {incr k} {
                        set filename($n) "${FUItmp}plt$FUIfit_instance-$i-$k.plt-th"
                        setPlotAttributes $n $frame line "" 2 [lindex $TBS_linecolorList $FUInextcolor]
                        incr FUInextcolor
                        if {$FUInextcolor>=[llength $TBS_linecolorList]} { set FUInextcolor 0 }
                        set tf($k) [open "${FUItmp}plt$FUIfit_instance-$i-$k.plt-th" w];   incr n;
                    }
                    set outfile [open "outdata[expr $i+1]"]
                    while {[gets $outfile line]>=0} {
                        set x [lindex $line 0]
                        for {set l 2; set k 1} {$k<=$numb_dependent_vars} {incr k} {
                            puts $tf($k) "$x [lindex $line $l]";  incr l 2
                        }
                    }
                    for {set k 1} {$k<=$numb_dependent_vars} {incr k} {
                        close $tf($k)
                    }
                    close $outfile
                }
            }
        } elseif {$type=="res"} {
            for {set i 0; set n 0} {$i<$numb_exp} {incr i} {
		set TBSgraphType($frame) [expr 2*($FUIgraphType/2)]
                set TBSaxisLabelStyle($frame,y) decimal
                set TBSaxisTitle($frame,y)      residual
                if {$two_column_data} {
                    set filename($n) "${FUItmp}plt$FUIfit_instance-$i.residuals"
                    setPlotAttributes $n $frame marker [lindex $TBS_symbolList $FUInextsymbol] "" ""
                    incr FUInextsymbol
                    if {$FUInextsymbol>=[llength $TBS_symbolList]} { set FUInextsymbol 0 }
                    incr n
                } else {
                    for {set k 1} {$k<=$numb_dependent_vars} {incr k} {
                        set filename($n) "${FUItmp}plt$FUIfit_instance-$i-$k.plt-rd"
                        setPlotAttributes $n $frame marker [lindex $TBS_symbolList $FUInextsymbol] "" ""
                        incr FUInextsymbol
                        if {$FUInextsymbol>=[llength $TBS_symbolList]} { set FUInextsymbol 0 }
                        set rf($k) [open "${FUItmp}plt$FUIfit_instance-$i-$k.plt-rd" w];   incr n;
                    }
                    set outfile [open "outdata[expr $i+1]"]
                    if [string match $residual_scale_type abs] {
                        while {[gets $outfile line]>=0} {
                            set x [lindex $line 0]
                            for {set l1 1; set l2 2; set k 1} {$k<=$numb_dependent_vars} {incr k} {
                                puts $rf($k) "$x [expr [lindex $line $l1]-[lindex $line $l2]]"
                                incr l1 2;  incr l2 2
                            }
                        }
                    } elseif [string match $residual_scale_type rel] {
                        while {[gets $outfile line]>=0} {
                            set x [lindex $line 0]
                            for {set l1 1; set l2 2; set k 1} {$k<=$numb_dependent_vars} {incr k} {
                                set cv [lindex $line $l2]
                                puts $rf($k) "$x [expr ([lindex $line $l1]-$cv)/$cv]"
                                incr l1 2;  incr l2 2
                            }
                        }
                    } elseif [string match $residual_scale_type log] {
                        while {[gets $outfile line]>=0} {
                            set x [lindex $line 0]
                            for {set l1 1; set l2 2; set k 1} {$k<=$numb_dependent_vars} {incr k} {
                                set dv [lindex $line $l1]
                                set cv [lindex $line $l2]
                                if {$dv>0 && $cv>0} {
                                    puts $rf($k) "$x [expr log($dv)-log($cv)]"
                                }
                                incr l1 2;  incr l2 2
                            }
                        }
                    }
                    for {set k 1} {$k<=$numb_dependent_vars} {incr k} {
                        close $rf($k)
                    }
                    close $outfile
                }
            }
        } else {
            for {set i 0; set n 0} {$i<$numb_exp} {incr i} {
                if {$two_column_data} {
                    set filename($n) "${FUItmp}plt$FUIfit_instance-$i.sdata"
                    setPlotAttributes $n $frame marker [lindex $TBS_symbolList $FUInextsymbol] "" ""
                    incr FUInextsymbol
                    if {$FUInextsymbol>=[llength $TBS_symbolList]} { set FUInextsymbol 0 }
                    incr n
                } else {
                    for {set k 1} {$k<=$numb_dependent_vars} {incr k} {
                        set filename($n) "${FUItmp}plt$FUIfit_instance-$i-$k.plt-dt"
                        setPlotAttributes $n $frame marker [lindex $TBS_symbolList $FUInextsymbol] "" ""
                        incr FUInextsymbol
                        if {$FUInextsymbol>=[llength $TBS_symbolList]} { set FUInextsymbol 0 }
                        set df($k) [open "${FUItmp}plt$FUIfit_instance-$i-$k.plt-dt" w];   incr n;
                    }
                    set outfile [open "outdata[expr $i+1]"]
                    while {[gets $outfile line]>=0} {
                        set x [lindex $line 0]
                        for {set l 1; set k 1} {$k<=$numb_dependent_vars} {incr k} {
                            puts $df($k) "$x [lindex $line $l]";  incr l 2
                        }
                    }
                    for {set k 1} {$k<=$numb_dependent_vars} {incr k} {
                        close $df($k)
                    }
                    close $outfile
                }
            }
        }
        mapPlot filename [array size filename] "FUI"
    } elseif {$mode=="multiple"} {
        set FUIplotMultiple 1
        if {$type=="fd"} {
            for {set i 0} {$i<$numb_exp} {incr i; incr frame} {
                set FUIplotMaxFrame $frame
		set TBSgraphType($frame) $FUIgraphType
                set TBSaxisLabelStyle($frame,x) $FUIaxisLabelStyle(x)
                set TBSaxisLabelStyle($frame,y) $FUIaxisLabelStyle(y)
                set TBSaxisTitle($frame,x)      $FUIaxisTitle(x)
                set TBSaxisTitle($frame,y)      $FUIaxisTitle(y)
                set filename file$i
                if {$two_column_data} {
                    set ${filename}(0) "${FUItmp}plt$FUIfit_instance-$i.sdata"
                    setPlotAttributes 0 $frame marker [lindex $TBS_symbolList $FUInextsymbol] "" ""
                    incr FUInextsymbol
                    if {$FUInextsymbol>=[llength $TBS_symbolList]} { set FUInextsymbol 0 }
                    set ${filename}(1) "${FUItmp}plt$FUIfit_instance-$i.fit"
                    setPlotAttributes 1 $frame line "" 2 [lindex $TBS_linecolorList $FUInextcolor]
                    incr FUInextcolor
                    if {$FUInextcolor>=[llength $TBS_linecolorList]} { set FUInextcolor 0 }
                    set n 2
                } else {
                    for {set n 0; set k 1} {$k<=$numb_dependent_vars} {incr k} {
                        set ${filename}($n) "${FUItmp}plt$FUIfit_instance-$i-$k.plt-dt"
                        setPlotAttributes $n $frame marker [lindex $TBS_symbolList $FUInextsymbol] "" ""
                        incr FUInextsymbol
                        if {$FUInextsymbol>=[llength $TBS_symbolList]} { set FUInextsymbol 0 }
                        set df($k) [open "${FUItmp}plt$FUIfit_instance-$i-$k.plt-dt" w];   incr n;
                        set ${filename}($n) "${FUItmp}plt$FUIfit_instance-$i-$k.plt-th"
                        setPlotAttributes $n $frame line "" 2 [lindex $TBS_linecolorList $FUInextcolor]
                        incr FUInextcolor
                        if {$FUInextcolor>=[llength $TBS_linecolorList]} { set FUInextcolor 0 }
                        set tf($k) [open "${FUItmp}plt$FUIfit_instance-$i-$k.plt-th" w];   incr n;
                    }
                    set outfile [open "outdata[expr $i+1]"]
                    while {[gets $outfile line]>=0} {
                        set x [lindex $line 0]
                        for {set l 1; set k 1} {$k<=$numb_dependent_vars} {incr k} {
                            puts $df($k) "$x [lindex $line $l]";  incr l
                            puts $tf($k) "$x [lindex $line $l]";  incr l
                        }
                    }
                    for {set k 1} {$k<=$numb_dependent_vars} {incr k} {
                        close $df($k)
                        close $tf($k)
                    }
                    close $outfile
                }
                mapPlot ${filename} $n "FUI"
            }
        } elseif {$type=="f"} {
            for {set i 0} {$i<$numb_exp} {incr i; incr frame} {
                set FUIplotMaxFrame $frame
		set TBSgraphType($frame) $FUIgraphType
                set TBSaxisLabelStyle($frame,x) $FUIaxisLabelStyle(x)
                set TBSaxisLabelStyle($frame,y) $FUIaxisLabelStyle(y)
                set TBSaxisTitle($frame,x)      $FUIaxisTitle(x)
                set TBSaxisTitle($frame,y)      $FUIaxisTitle(y)
                set filename file$i
                if {$two_column_data} {
                    set ${filename}(0) "${FUItmp}plt$FUIfit_instance-$i.fit"
                    setPlotAttributes 0 $frame line "" 2 [lindex $TBS_linecolorList $FUInextcolor]
                    incr FUInextcolor
                    if {$FUInextcolor>=[llength $TBS_linecolorList]} { set FUInextcolor 0 }
                    set n 1
                } else {
                    for {set n 0; set k 1} {$k<=$numb_dependent_vars} {incr k} {
                        set ${filename}($n) "${FUItmp}plt$FUIfit_instance-$i-$k.plt-th"
                        setPlotAttributes $n $frame line "" 2 [lindex $TBS_linecolorList $FUInextcolor]
                        incr FUInextcolor
                        if {$FUInextcolor>=[llength $TBS_linecolorList]} { set FUInextcolor 0 }
                        set tf($k) [open "${FUItmp}plt$FUIfit_instance-$i-$k.plt-th" w];   incr n;
                    }
                    set outfile [open "outdata[expr $i+1]"]
                    while {[gets $outfile line]>=0} {
                        set x [lindex $line 0]
                        for {set l 2; set k 1} {$k<=$numb_dependent_vars} {incr k} {
                            puts $tf($k) "$x [lindex $line $l]";  incr l 2
                        }
                    }
                    for {set k 1} {$k<=$numb_dependent_vars} {incr k} {
                        close $tf($k)
                    }
                    close $outfile
                }
                mapPlot ${filename} $n "FUI"
            }
        } elseif {$type=="res"} {
            for {set i 0} {$i<$numb_exp} {incr i; incr frame} {
                set FUIplotMaxFrame $frame
		set TBSgraphType($frame) [expr 2*($FUIgraphType/2)]
                set TBSaxisLabelStyle($frame,x) $FUIaxisLabelStyle(x)
                set TBSaxisLabelStyle($frame,y) decimal
                set TBSaxisTitle($frame,x)      $FUIaxisTitle(x)
                set TBSaxisTitle($frame,y)      residual
                set filename file$i
                if {$two_column_data} {
                    set ${filename}(0) "${FUItmp}plt$FUIfit_instance-$i.residuals"
                    setPlotAttributes 0 $frame marker [lindex $TBS_symbolList $FUInextsymbol] "" ""
                    incr FUInextsymbol
                    if {$FUInextsymbol>=[llength $TBS_symbolList]} { set FUInextsymbol 0 }
                    set n 1
                } else {
                    for {set n 0; set k 1} {$k<=$numb_dependent_vars} {incr k} {
                        set ${filename}($n) "${FUItmp}plt$FUIfit_instance-$i-$k.plt-rd"
                        setPlotAttributes $n $frame marker [lindex $TBS_symbolList $FUInextsymbol] "" ""
                        incr FUInextsymbol
                        if {$FUInextsymbol>=[llength $TBS_symbolList]} { set FUInextsymbol 0 }
                        set rf($k) [open "${FUItmp}plt$FUIfit_instance-$i-$k.plt-rd" w];   incr n;
                    }
                    set outfile [open "outdata[expr $i+1]"]
                    while {[gets $outfile line]>=0} {
                        set x [lindex $line 0]
                        for {set l1 1; set l2 2; set k 1} {$k<=$numb_dependent_vars} {incr k} {
                            puts $rf($k) "$x [expr [lindex $line $l1]-[lindex $line $l2]]"
                            incr l1 2;  incr l2 2
                        }
                    }
                    for {set k 1} {$k<=$numb_dependent_vars} {incr k} {
                        close $rf($k)
                    }
                    close $outfile
                }
                mapPlot ${filename} $n "FUI"
            }
        } else {
            for {set i 0} {$i<$numb_exp} {incr i; incr frame} {
                set FUIplotMaxFrame $frame
		set TBSgraphType($frame) $FUIgraphType
                set TBSaxisLabelStyle($frame,x) $FUIaxisLabelStyle(x)
                set TBSaxisLabelStyle($frame,y) $FUIaxisLabelStyle(y)
                set TBSaxisTitle($frame,x)      $FUIaxisTitle(x)
                set TBSaxisTitle($frame,y)      $FUIaxisTitle(y)
                set filename file$i
                if {$two_column_data} {
                    set ${filename}(0) "${FUItmp}plt$FUIfit_instance-$i.sdata"
                    setPlotAttributes 0 $frame marker [lindex $TBS_symbolList $FUInextsymbol] "" ""
                    incr FUInextsymbol
                    if {$FUInextsymbol>=[llength $TBS_symbolList]} { set FUInextsymbol 0 }
                    set n 1
                } else {
                    for {set n 0; set k 1} {$k<=$numb_dependent_vars} {incr k} {
                        set ${filename}($n) "${FUItmp}plt$FUIfit_instance-$i-$k.plt-dt"
                        setPlotAttributes $n $frame marker [lindex $TBS_symbolList $FUInextsymbol] "" ""
                        incr FUInextsymbol
                        if {$FUInextsymbol>=[llength $TBS_symbolList]} { set FUInextsymbol 0 }
                        set df($k) [open "${FUItmp}plt$FUIfit_instance-$i-$k.plt-dt" w];   incr n;
                    }
                    set outfile [open "outdata[expr $i+1]"]
                    while {[gets $outfile line]>=0} {
                        set x [lindex $line 0]
                        for {set l 1; set k 1} {$k<=$numb_dependent_vars} {incr k} {
                            puts $df($k) "$x [lindex $line $l]";  incr l 2
                        }
                    }
                    for {set k 1} {$k<=$numb_dependent_vars} {incr k} {
                        close $df($k)
                    }
                    close $outfile
                }

                mapPlot ${filename} $n "FUI"
            }
        }
    } else {
        if {$type=="fd"} {
            resetPlotdataBounds xvgrBounds
            set n 0
            for {set i 0} {$i<$numb_exp} {incr i} {
                if {$two_column_data} {
                    set xvgrFilename($n) "${FUItmp}plt$FUIfit_instance-$i.sdata";          incr n
                    set xvgrFilename($n) "${FUItmp}plt$FUIfit_instance-$i.fit";            incr n
                    updatePlotdataBounds "${FUItmp}plt$FUIfit_instance-$i.sdata" xvgrBounds
                    updatePlotdataBounds "${FUItmp}plt$FUIfit_instance-$i.fit"   xvgrBounds
                } else {
                    for {set k 1} {$k<=$numb_dependent_vars} {incr k} {
                        set xvgrFilename($n) "${FUItmp}plt$FUIfit_instance-$i-$k.plt-dt";  incr n
                        set df($k) [open "${FUItmp}plt$FUIfit_instance-$i-$k.plt-dt" w]
                        set xvgrFilename($n) "${FUItmp}plt$FUIfit_instance-$i-$k.plt-th";  incr n
                        set tf($k) [open "${FUItmp}plt$FUIfit_instance-$i-$k.plt-th" w]
                    }
                    set outfile [open "outdata[expr $i+1]"]
                    while {[gets $outfile line]>=0} {
                        set x [lindex $line 0]
                        for {set l 1; set k 1} {$k<=$numb_dependent_vars} {incr k} {
                            puts $df($k) "$x [lindex $line $l]";  incr l
                            puts $tf($k) "$x [lindex $line $l]";  incr l
                        }
                    }
                    for {set k 1} {$k<=$numb_dependent_vars} {incr k} {
                        close $df($k)
                        close $tf($k)
                    }
                    close $outfile
                    for {set k 1} {$k<=$numb_dependent_vars} {incr k} {
                        updatePlotdataBounds "${FUItmp}plt$FUIfit_instance-$i-$k.plt-dt" xvgrBounds
                        updatePlotdataBounds "${FUItmp}plt$FUIfit_instance-$i-$k.plt-th" xvgrBounds
                    }
                }
            }
            setXvgrParameters "fd" $n xvgrFilename xvgrBounds $FUIgraphType \
                $FUIaxisLabelStyle(x) $FUIaxisLabelStyle(y) $FUIaxisTitle(x) $FUIaxisTitle(y) 
        } elseif {$type=="f"} {
            resetPlotdataBounds xvgrBounds
            set n 0
            for {set i 0} {$i<$numb_exp} {incr i} {
                updatePlotdataBounds "${FUItmp}plt$FUIfit_instance-$i.fit" xvgrBounds
                set xvgrFilename($j) "${FUItmp}plt$FUIfit_instance-$i.fit"
                incr j
                if {$two_column_data} {
                    set xvgrFilename($n) "${FUItmp}plt$FUIfit_instance-$i.fit";            incr n
                    updatePlotdataBounds "${FUItmp}plt$FUIfit_instance-$i.fit"   xvgrBounds
                } else {
                    for {set k 1} {$k<=$numb_dependent_vars} {incr k} {
                        set xvgrFilename($n) "${FUItmp}plt$FUIfit_instance-$i-$k.plt-th";  incr n
                        set tf($k) [open "${FUItmp}plt$FUIfit_instance-$i-$k.plt-th" w]
                    }
                    set outfile [open "outdata[expr $i+1]"]
                    while {[gets $outfile line]>=0} {
                        set x [lindex $line 0]
                        for {set l 2; set k 1} {$k<=$numb_dependent_vars} {incr k} {
                            puts $tf($k) "$x [lindex $line $l]";  incr l 2
                        }
                    }
                    for {set k 1} {$k<=$numb_dependent_vars} {incr k} {
                        close $tf($k)
                    }
                    close $outfile
                    for {set k 1} {$k<=$numb_dependent_vars} {incr k} {
                        updatePlotdataBounds "${FUItmp}plt$FUIfit_instance-$i-$k.plt-th" xvgrBounds
                    }
                }
            }
            setXvgrParameters "fits" $n xvgrFilename xvgrBounds $FUIgraphType \
                $FUIaxisLabelStyle(x) $FUIaxisLabelStyle(y) $FUIaxisTitle(x) $FUIaxisTitle(y) 
        } elseif {$type=="res"} {
            resetPlotdataBounds xvgrBounds
            set n 0
            for {set i 0} {$i<$numb_exp} {incr i} {
                if {$two_column_data} {
                    set xvgrFilename($n) "${FUItmp}plt$FUIfit_instance-$i.residuals";      incr n
                    updatePlotdataBounds "${FUItmp}plt$FUIfit_instance-$i.residuals" xvgrBounds
                } else {
                    for {set k 1} {$k<=$numb_dependent_vars} {incr k} {
                        set xvgrFilename($n) "${FUItmp}plt$FUIfit_instance-$i-$k.plt-rd";  incr n
                        set rf($k) [open "${FUItmp}plt$FUIfit_instance-$i-$k.plt-rd" w]
                    }
                    set outfile [open "outdata[expr $i+1]"]
                    while {[gets $outfile line]>=0} {
                        set x [lindex $line 0]
                        for {set l1 1; set l2 2; set k 1} {$k<=$numb_dependent_vars} {incr k} {
                            puts $rf($k) "$x [expr [lindex $line $l1]-[lindex $line $l2]]"
                            incr l1 2; incr l2 2
                        }
                    }
                    for {set k 1} {$k<=$numb_dependent_vars} {incr k} {
                        close $rf($k)
                    }
                    close $outfile
                    for {set k 1} {$k<=$numb_dependent_vars} {incr k} {
                        updatePlotdataBounds "${FUItmp}plt$FUIfit_instance-$i-$k.plt-rd" xvgrBounds
                    }
                }
            }
            setXvgrParameters "data" $n xvgrFilename xvgrBounds [expr 2*($FUIgraphType/2)] \
                $FUIaxisLabelStyle(x) "decimal" $FUIaxisTitle(x) $FUIaxisTitle(y) 
        } else {
            resetPlotdataBounds xvgrBounds
            set n 0
            for {set i 0} {$i<$numb_exp} {incr i} {
                if {$two_column_data} {
                    set xvgrFilename($n) "${FUItmp}plt$FUIfit_instance-$i.sdata";          incr n
                    updatePlotdataBounds "${FUItmp}plt$FUIfit_instance-$i.sdata" xvgrBounds
                } else {
                    for {set k 1} {$k<=$numb_dependent_vars} {incr k} {
                        set xvgrFilename($n) "${FUItmp}plt$FUIfit_instance-$i-$k.plt-dt";  incr n
                        set df($k) [open "${FUItmp}plt$FUIfit_instance-$i-$k.plt-dt" w]
                    }
                    set outfile [open "outdata[expr $i+1]"]
                    while {[gets $outfile line]>=0} {
                        set x [lindex $line 0]
                        for {set l 1; set k 1} {$k<=$numb_dependent_vars} {incr k} {
                            puts $df($k) "$x [lindex $line $l]";  incr l 2
                        }
                    }
                    for {set k 1} {$k<=$numb_dependent_vars} {incr k} {
                        close $df($k)
                    }
                    close $outfile
                    for {set k 1} {$k<=$numb_dependent_vars} {incr k} {
                        updatePlotdataBounds "${FUItmp}plt$FUIfit_instance-$i-$k.plt-dt" xvgrBounds
                    }
                }
            }
            setXvgrParameters "data" $n xvgrFilename xvgrBounds $FUIgraphType \
                $FUIaxisLabelStyle(x) $FUIaxisLabelStyle(y) $FUIaxisTitle(x) $FUIaxisTitle(y) 
        }
        if $xvgrUseP {
            set xvgrCommand "xmgrace -p $filenameByBrowser(xvgrParameters) -graph 0"
        } else {
            set xvgrCommand "xmgrace -p $FUItmp.xvgr.p -graph 0"
        }
        for {set i 0} {$i<$n} {incr i} {
            set xvgrCommand "$xvgrCommand $xvgrFilename($i)"
        }
        set xvgrCommand "$xvgrCommand >&${FUItmp}.dump.xvgr &"
        eval exec $xvgrCommand
    }
}

proc FUIqueryAxesTitle {} {
    global FUIaxisTitle FUIstandardFont FUIbackground title tk_version

    if [winfo exists .fqat] { raise .fqat } else {
        toplevel .fqat
        wm title .fqat "FUI: Axis Titles"
        frame .fqat.fx
        label .fqat.lx -text "X axis title" -font $FUIstandardFont(popup)
        entry .fqat.ex -width 35 -relief sunken -bd 2 \
            -textvariable title(x) -bd 2 \
            -font $FUIstandardFont(popup)
        bind .fqat.ex <Tab> { focus .fqat.ey }
        pack .fqat.lx .fqat.ex -padx 5m -pady 3m -side left -in .fqat.fx
        frame .fqat.fy
        label .fqat.ly -text "Y axis title" -font $FUIstandardFont(popup)
        entry .fqat.ey -width 35 -relief sunken -bd 2 \
            -textvariable title(y) -bd 2 \
            -font $FUIstandardFont(popup)
        bind .fqat.ey <Tab> { focus .fqat.ex }
        pack .fqat.ly .fqat.ey -padx 5m -pady 3m -side left -in .fqat.fy
        pack .fqat.fx .fqat.fy
        focus .fqat.ex
    
        frame .fqat.f2
        button .fqat.ok -text Ok -font $FUIstandardFont(popup) -command {
            set FUIaxisTitle(x) $title(x)
            set FUIaxisTitle(y) $title(y)
            destroy .fqat }
        button .fqat.cancel -text Cancel -font $FUIstandardFont(popup) -command { 
            set title(x) $FUIaxisTitle(x)
            set title(y) $FUIaxisTitle(y)
            destroy .fqat }
        pack .fqat.ok .fqat.cancel -ipadx 6m -padx 6m -pady 3m -side left -in .fqat.f2
        pack .fqat.f2 -anchor w
        if {$tk_version>=4.0} {
            .fqat.ex configure -highlightbackground $FUIbackground
            .fqat.ey configure -highlightbackground $FUIbackground
            .fqat.ok configure -highlightbackground $FUIbackground -takefocus 0
            .fqat.ok configure -highlightbackground $FUIbackground -takefocus 0
        }
    }
}
proc resetPlotdataBounds {b} {
    upvar $b bounds

    set bounds(min,x)  1e300
    set bounds(max,x) -1e300
    set bounds(min,y)  1e300
    set bounds(max,y) -1e300
}
proc updatePlotdataBounds {file b} {
    upvar $b bounds

    set df [open $file "r"]
    while {[gets $df line] >= 0} {
	if [regexp {^[ 	]*([\#\%].*)?$} $line match]  continue

        set x [lindex $line 0]
        set y [lindex $line 1]
        set bounds(min,x) [expr $bounds(min,x)>$x ? $x : $bounds(min,x)]
        set bounds(max,x) [expr $bounds(max,x)<$x ? $x : $bounds(max,x)]
        set bounds(min,y) [expr $bounds(min,y)>$y ? $y : $bounds(min,y)]
        set bounds(max,y) [expr $bounds(max,y)<$y ? $y : $bounds(max,y)]
    }
    close $df
}
proc setXvgrParameters {plotdatatype n f b type x_label y_label x_title y_title} {
    global  FUIrootDirectory FUItmp xvgrGraph xvgrColor
    upvar $b bounds
    upvar $f filename

    if [expr $type/2] { set fx log10 } else { set fx "" }
    if [expr $type%2] { set fy log10 } else { set fy "" }

    set range [expr ${fx}($bounds(max,x))-${fx}($bounds(min,x))]
    set base [expr pow(10,floor(log10($range)))]
    set b_range [expr ceil($range/$base)]
    if {$fx=="log10"} {
        set autoBound(min,x) [expr pow(10,floor(${fx}($bounds(min,x))/$base)*$base)]
        set autoBound(max,x) [expr pow(10,ceil(${fx}($bounds(max,x))/$base)*$base)]
        set xt 1
    } else {
        set autoBound(min,x) [expr floor(${fx}($bounds(min,x))/$base)*$base]
        set autoBound(max,x) [expr ceil(${fx}($bounds(max,x))/$base)*$base]
        set xt $base
    }
    if {$x_label=="decimal"} {
        set xp [expr -log10($base)]
	set xp [expr int($xp>0 ? $xp : 0)]
    } else {
        set xp 0
    }
    set range [expr ${fy}($bounds(max,y))-${fy}($bounds(min,y))]
    set base [expr pow(10,floor(log10($range)))]
    set b_range [expr ceil($range/$base)]
    if {$fy=="log10"} {
        set autoBound(min,y) [expr pow(10,floor(${fy}($bounds(min,y))/$base)*$base)]
        set autoBound(max,y) [expr pow(10,ceil(${fy}($bounds(max,y))/$base)*$base)]
        set yt 1
    } else {
        set autoBound(min,y) [expr floor(${fy}($bounds(min,y))/$base)*$base]
        set autoBound(max,y) [expr ceil(${fy}($bounds(max,y))/$base)*$base]
        set yt $base
    }
    if {$y_label=="decimal"} {
        set yp [expr -log10($base)]
	set yp [expr int($yp>0 ? $yp : 0)]
    } else {
        set yp 0
    }

    exec cp "$FUIrootDirectory/lib/Tk/xmgr-parameters.template.$plotdatatype" "$FUItmp.xvgr.p"
    set xf [open "$FUItmp.xvgr.p" a]
    puts $xf "g0 type $xvgrGraph($type)"
    puts $xf "    xaxis label \"$x_title\""
    puts $xf "    xaxis ticklabel prec $xp"
    puts $xf "    xaxis ticklabel format $x_label"
    puts $xf "    xaxis tick major $xt"
    puts $xf "    xaxis tick minor $xt"
    puts $xf "    yaxis label \"$y_title\""
    puts $xf "    yaxis ticklabel prec $yp"
    puts $xf "    yaxis ticklabel format $y_label"
    puts $xf "    yaxis tick major $yt"
    puts $xf "    yaxis tick minor $yt"
    puts $xf "    world xmin $autoBound(min,x)"
    puts $xf "    world xmax $autoBound(max,x)"
    puts $xf "    world ymin $autoBound(min,y)"
    puts $xf "    world ymax $autoBound(max,y)"
    for {set j 0} {$j<$n} {incr j} {
        puts $xf "    legend string $j \"$filename($j)\""
    }
    if {$xvgrColor=="mono"} {
        for {set j 0} {$j<30} {incr j} {
            puts $xf "    s$j color 1"
        }
    }
    close $xf
}
proc mapXvgrOptions {} {
    global  FUIstandardFont FUIbackground tk_version
    global  xvgrColor xvgrUseP xvgrPfile

    if [winfo exists .xvgr] { raise .xvgr } else {
        toplevel .xvgr
        wm title .xvgr "FUI: Xvgr Options"
        button .xvgr.close -text "C L O S E" -font $FUIstandardFont(1) -command {
            destroy .xvgr
        }
        pack .xvgr.close -ipadx 3m -padx 2m -pady 3m -side top -anchor e
        frame .xvgr.f1
        label .xvgr.l1 -text "Data:" -font $FUIstandardFont(1)
        radiobutton .xvgr.mono -text monochrome -variable xvgrColor -value mono \
            -font $FUIstandardFont(1)
        radiobutton .xvgr.color -text color -variable xvgrColor -value color \
            -font $FUIstandardFont(1)
        pack .xvgr.l1 .xvgr.mono .xvgr.color -padx 3m -pady 3m -side left -in .xvgr.f1
        pack .xvgr.f1 -side top -anchor w
        frame .xvgr.f2
        checkbutton .xvgr.use_pfile -variable xvgrUseP -command "updateXvgrOptions"
        label .xvgr.uplabel -text "User-specified parameter file" -font $FUIstandardFont(1)
        pack .xvgr.use_pfile .xvgr.uplabel -padx 3m -pady 3m -side left -in .xvgr.f2
        pack .xvgr.f2 -side top -anchor w
        if {$tk_version>=4.0} {
            .xvgr.mono configure -highlightbackground $FUIbackground -takefocus 0
            .xvgr.color configure -highlightbackground $FUIbackground -takefocus 0
            .xvgr.close configure -highlightbackground $FUIbackground -takefocus 0
            .xvgr.use_pfile configure -highlightbackground $FUIbackground -takefocus 0
        }
        if $xvgrUseP {
            frame .xvgr.f3 
            button .xvgr.gpf -relief flat -text "Parameter file" -font $FUIstandardFont(popup) \
                -command "getFileNameByBrowser . xvgrParameters" 
            entry .xvgr.file -relief sunken -width 15 -font $FUIstandardFont(popupEntry) \
                -textvariable filenameByBrowser(xvgrParameters)
            pack .xvgr.gpf .xvgr.file -padx 3m -pady 2m -side left -in .xvgr.f3
            pack .xvgr.f3 -side top -anchor w
            if {$tk_version>=4.0} {
                .xvgr.gpf configure -highlightbackground $FUIbackground -takefocus 0
                .xvgr.file configure -highlightbackground $FUIbackground
            }
        }
    }
}
proc updateXvgrOptions {} {
    global FUIstandardFont
    global FUIbackground
    global xvgrUseP filenameByBrowser
    global tk_version 

    if $xvgrUseP {
        frame .xvgr.f3 
        button .xvgr.gpf -relief flat -text "Parameter file" -font $FUIstandardFont(popup) \
            -command "getFileNameByBrowser . xvgrParameters" 
        entry .xvgr.file -relief sunken -width 15 -font $FUIstandardFont(popupEntry) \
            -textvariable filenameByBrowser(xvgrParameters)
        pack .xvgr.gpf .xvgr.file -padx 3m -pady 2m -side left -in .xvgr.f3
        pack .xvgr.f3 -side top -anchor w
        if {$tk_version>=4.0} {
            .xvgr.gpf configure -highlightbackground $FUIbackground -takefocus 0
            .xvgr.file configure -highlightbackground $FUIbackground
        }
    } else {
        destroy .xvgr.gpf .xvgr.file .xvgr.f3
    }
}
