proc  FUIsaveTapefile mode {

    saveTapeFileQuery
}
proc  saveTapeFileQuery {} {
    global  filenameByBrowser numb_par tk_version
    global  FUIstandardFont FUIbackground 

    set filenameByBrowser(tapefile_save) ""
    if [winfo exists .tapefile_save] {raise .tapefile_save} else {
        toplevel .tapefile_save 
        wm title .tapefile_save "FUI: Save Tape File"
        frame .tapefile_save.f
        button .tapefile_save.bd -text "File" -font $FUIstandardFont(1) \
            -command "getFileNameByBrowser . tapefile_save" -relief flat
        entry .tapefile_save.ed -width 35 -relief sunken -bd 2 \
            -textvariable filenameByBrowser(tapefile_save) -bd 2 \
            -font $FUIstandardFont(2)
        bind .tapefile_save.ed <Return> {
            if $numb_par {
                writeTapeFile
                exec cp fittp $filenameByBrowser(tapefile_save)
                destroy .tapefile_save 
                return 1 
            } else {
                BSerror "saveTapefile" "No model specified"
                destroy .tapefile_save
                return 0
            }
        }
        focus .tapefile_save.ed
        pack .tapefile_save.bd -ipadx 5m -pady 3m -side left -in .tapefile_save.f
        pack .tapefile_save.ed -padx 5m -pady 3m -side left -in .tapefile_save.f
        pack .tapefile_save.f
    
        frame .tapefile_save.f2
        button .tapefile_save.ok -text Ok -font $FUIstandardFont(1) -command {
            if $numb_par {
                writeTapeFile
                exec cp fittp $filenameByBrowser(tapefile_save)
                destroy .tapefile_save 
                return 1 
            } else {
                BSerror "saveTapefile" "No model specified"
                destroy .tapefile_save
                return 0
            }
        }
        button .tapefile_save.cancel -text Cancel -command { destroy .tapefile_save; return 0 } \
            -font $FUIstandardFont(1)
        pack .tapefile_save.ok .tapefile_save.cancel -ipadx 6m -padx 6m -pady 3m -side left \
            -in .tapefile_save.f2
        pack .tapefile_save.f2 -anchor w
        if {$tk_version>=4.0} {
            .tapefile_save.bd configure -highlightbackground $FUIbackground
            .tapefile_save.ed configure -highlightbackground $FUIbackground
            .tapefile_save.ok configure -highlightbackground $FUIbackground
            .tapefile_save.cancel configure -highlightbackground $FUIbackground
            .tapefile_save.bd configure -takefocus 0
            .tapefile_save.ok configure -takefocus 0
            .tapefile_save.cancel configure -takefocus 0
        }
    }
}

proc  FUIsaveResults mode {
    global  resultfile

    if {![string compare $mode new]} {
        set resultfile ""
    }
    if {![string compare $resultfile ""]} {
        saveResultFileQuery
    } else {
        writeResult $resultfile
    }
}
proc  saveResultFileQuery {} {
    global  filenameByBrowser resultfile tk_version
    global  FUIstandardFont FUIbackground

    set filenameByBrowser(result_save) ""
    if [winfo exists .result_save] { raise .result_save } else {
        toplevel .result_save 
        wm title .result_save "FUI: Save Result"
        frame .result_save.f
        button .result_save.bd -text "File" -font $FUIstandardFont(1) \
            -command "getFileNameByBrowser . result_save" -relief flat
        entry .result_save.ed -width 35 -relief sunken -bd 2 \
            -textvariable filenameByBrowser(result_save) -bd 2 \
            -font $FUIstandardFont(2)
        bind .result_save.ed <Return> {
            set resultfile $filenameByBrowser(result_save)
            writeResult $resultfile
            destroy .result_save 
            return 1 }
        focus .result_save.ed
        pack .result_save.bd -ipadx 5m -pady 3m -side left -in .result_save.f
        pack .result_save.ed -padx 5m -pady 3m -side left -in .result_save.f
        pack .result_save.f
    
        frame .result_save.f2
        button .result_save.ok -text Ok -font $FUIstandardFont(1) -command {
            set resultfile $filenameByBrowser(result_save)
            writeResult $resultfile
            destroy .result_save 
            return 1 }
        button .result_save.cancel -text Cancel -command { destroy .result_save; return 0 } \
            -font $FUIstandardFont(1)
        pack .result_save.ok .result_save.cancel -ipadx 6m \
            -padx 6m -pady 3m -side left -in .result_save.f2
        pack .result_save.f2 -anchor w
        if {$tk_version>=4.0} {
            .result_save.bd configure -highlightbackground $FUIbackground
            .result_save.ed configure -highlightbackground $FUIbackground
            .result_save.ok configure -highlightbackground $FUIbackground
            .result_save.cancel configure -highlightbackground $FUIbackground
            .result_save.bd configure -takefocus 0
            .result_save.ok configure -takefocus 0
            .result_save.cancel configure -takefocus 0
        }
    }
}
proc writeResult filename {
    global  numb_par numb_exp number_of_simulations two_column_data
    global  par_name par_short par_keep par_fixed
    global  par_fit par_sim_mean par_sim_var par_sim_lower par_sim_upper
    global  FUIfit_instance FUItmp

    exec cp output "$filename.out"
    exec cp simout "$filename.sim"
    exec cp jacout "$filename.jac"
    for {set i 0; set j 1} {$i<$numb_exp} {incr i; incr j} {
        if {$two_column_data} {
            exec cp "${FUItmp}plt$FUIfit_instance-$i.sdata" "$filename-$j.sdata"
            exec cp "${FUItmp}plt$FUIfit_instance-$i.fit" "$filename-$j.fit"
        } else {
            exec cp "outdata$j" "$filename-$j.outdata"
        }
    }
    set sf [open $filename w]
    puts $sf ""
    puts $sf "       long name   short      result   sim. mean  sim. sigma       lower       upper"
    puts $sf "------------------------------------------------------------------------------------"
    puts $sf ""
    for {set i 0} {$i<$numb_par} {incr i} {
        if $par_keep($i,0) { set top 1 } else { set top $numb_exp }
        for {set j 0} {$j<$top} {incr j} {
            set outstring [format "%16s%8s%12.3e" $par_name($i,0) \
                $par_short($i,0) $par_fit($i,$j)]
            if {$number_of_simulations && $par_fixed($i,0)==0} {
                set outstring [format "%s%12.3e%12.3e%12.3e%12.3e" $outstring \
                    $par_sim_mean($i,$j) $par_sim_var($i,$j) \
                    $par_sim_lower($i,$j) $par_sim_upper($i,$j)]
            }
            puts $sf "$outstring"
        }
    }
    close $sf
}

proc  FUIsaveSetup mode {
    global  savefile

    if {![string compare $mode new]} {
        set savefile ""
    }
    if {![string compare $savefile ""]} {
        saveSetupFileQuery
    } else {
        writeSetup $savefile
    }
}
proc  saveSetupFileQuery {} {
    global  filenameByBrowser savefile tk_version
    global  FUIstandardFont FUIbackground 

    set filenameByBrowser(setup_save) ""
    if [winfo exists .setup_save] { raise .setup_save } else {
        toplevel .setup_save 
        wm title .setup_save "FUI: Save Setup"
        frame .setup_save.f
        button .setup_save.bd -text "File" -font $FUIstandardFont(1) \
            -command "getFileNameByBrowser . setup_save" -relief flat
        entry .setup_save.ed -width 35 -relief sunken -bd 2 \
            -textvariable filenameByBrowser(setup_save) -bd 2 \
            -font $FUIstandardFont(2)
        bind .setup_save.ed <Return> {
            set savefile $filenameByBrowser(setup_save)
            writeSetup $savefile
            destroy .setup_save 
            return 1 }
        focus .setup_save.ed
        pack .setup_save.bd -ipadx 5m -pady 3m -side left -in .setup_save.f
        pack .setup_save.ed -padx 5m -pady 3m -side left -in .setup_save.f
        pack .setup_save.f
    
        frame .setup_save.f2
        button .setup_save.ok -text Ok -font $FUIstandardFont(1) -command {
            set savefile $filenameByBrowser(setup_save)
            writeSetup $savefile
            destroy .setup_save 
            return 1 }
        button .setup_save.cancel -text Cancel -command { destroy .setup_save; return 0 } \
            -font $FUIstandardFont(1)
        pack .setup_save.ok .setup_save.cancel -ipadx 6m -padx 6m -pady 3m -side left \
            -in .setup_save.f2
        pack .setup_save.f2 -anchor w
        if {$tk_version>=4.0} {
            .setup_save.bd configure -highlightbackground $FUIbackground
            .setup_save.ed configure -highlightbackground $FUIbackground
            .setup_save.ok configure -highlightbackground $FUIbackground
            .setup_save.cancel configure -highlightbackground $FUIbackground
            .setup_save.bd configure -takefocus 0
            .setup_save.ok configure -takefocus 0
            .setup_save.cancel configure -takefocus 0
        }
    }
}
proc writeSetup filename {
    global  numb_par numb_exp modelname
    global  par_name par_short par_fixed par_keep par_pos par_guess
    global  data_use_nmax data_skip_first data_skip
    global  data_nmax data_numb_skip_first data_skip_intv
    global  two_column_data numb_dependent_vars FORTRAN_has_C_main
    global  residual_scale_type
    global  fit_mode datafile filenameByBrowser
    global  cc do_jacknife number_of_simulations sim_noise confidence
    global  FUIgraphType FUIaxisTitle FUIaxisLabelStyle
    global  xvgrColor xvgrUseP

    set sf [open $filename w]
    puts $sf "FUI: Version 1.2"; 
    puts $sf "---- Model ----"; puts $sf "----"
    puts $sf "   $modelname"
    puts $sf ""; puts $sf "---- Model Parameters ----"; puts $sf "----"
    puts $sf "$numb_par  $numb_exp"
    for {set i 0} {$i<$numb_par} {incr i} {
        set outstring [format "%16s%8s%3d%3d%3d" $par_name($i,0) $par_short($i,0) \
                $par_fixed($i,0) $par_keep($i,0) $par_pos($i,0)]
        if $par_keep($i,0) { set top 1 } else { set top $numb_exp }
        for {set j 0} {$j<$top} {incr j} {
            set outstring "$outstring  $par_guess($i,$j)"
        }
        puts $sf "$outstring"
    }
    puts $sf ""; puts $sf "---- Data ----"; puts $sf "----"
    puts $sf "$numb_exp  $fit_mode"
    for {set i 0} {$i<$numb_exp} {incr i} {
        set datafile($i) $filenameByBrowser(data$i)
        puts $sf "   $datafile($i)"
    }
    puts $sf ""; puts $sf "---- Fit Parameters ----"; puts $sf "----"
    puts $sf "$cc(maxfev) $cc(ftol) $cc(xtol) $cc(gtol) $do_jacknife"
    puts $sf ""; puts $sf "---- Simulations ----"; puts $sf "----"
    puts $sf "$number_of_simulations $sim_noise $confidence"
    puts $sf ""; puts $sf "---- Graph ----"; puts $sf "----"
    puts $sf "   $FUIgraphType"
    puts $sf "   `$FUIaxisTitle(x)' `$FUIaxisTitle(y)'"
    puts $sf "   $FUIaxisLabelStyle(x) $FUIaxisLabelStyle(y)"
    puts $sf ""; puts $sf "---- Data Options ----"; puts $sf "----"
    for {set i 0} {$i<$numb_exp} {incr i} {
        puts $sf "$data_use_nmax($i) $data_skip_first($i) $data_skip($i) $data_nmax($i) $data_numb_skip_first($i) $data_skip_intv($i)"
    }
    puts $sf ""; puts $sf "---- XVGR Options ----"; puts $sf "----"
    puts $sf "$xvgrColor $xvgrUseP $filenameByBrowser(xvgrParameters)"
    puts $sf ""; puts $sf "---- Model Background Information ----"; puts $sf "----"
    puts $sf "$two_column_data $numb_dependent_vars $FORTRAN_has_C_main $residual_scale_type"
    close $sf
}

proc  FUIreadSetup args {
    global readfile

    if [string compare [lindex $args 0] init] {
        readSetupFileQuery
    } else {
        readSetup $readfile
    }
}
proc  readSetupFileQuery {} {
    global  filenameByBrowser tk_version
    global  FUIstandardFont FUIbackground

    set filenameByBrowser(setup_read) ""
    if [winfo exists .setup_read] { raise .setup_read } else {
        toplevel .setup_read 
        wm title .setup_read "FUI: Read Setup"
        frame .setup_read.f
        button .setup_read.bd -text "File" -font $FUIstandardFont(1) \
            -command "getFileNameByBrowser . setup_read" -relief flat
        entry .setup_read.ed -width 35 -relief sunken -bd 2 \
            -textvariable filenameByBrowser(setup_read) -bd 2 \
            -font $FUIstandardFont(2)
        bind .setup_read.ed <Return> { read_n_updateSetup; return 1 }
        focus .setup_read.ed
        pack .setup_read.bd -ipadx 5m -pady 3m -side left -in .setup_read.f
        pack .setup_read.ed -padx 5m -pady 3m -side left -in .setup_read.f
        pack .setup_read.f
    
        frame .setup_read.f2
        button .setup_read.ok -text Ok -font $FUIstandardFont(1) \
            -command { read_n_updateSetup; return 1 }
        button .setup_read.cancel -text Cancel -font $FUIstandardFont(1) \
            -command { destroy .setup_read; return 0 }
        pack .setup_read.ok .setup_read.cancel -ipadx 6m -padx 6m -pady 3m -side left \
            -in .setup_read.f2
        pack .setup_read.f2 -anchor w
        if {$tk_version>=4.0} {
            .setup_read.bd configure -highlightbackground $FUIbackground
            .setup_read.ed configure -highlightbackground $FUIbackground
            .setup_read.ok configure -highlightbackground $FUIbackground
            .setup_read.cancel configure -highlightbackground $FUIbackground
            .setup_read.bd configure -takefocus 0
            .setup_read.ok configure -takefocus 0
            .setup_read.cancel configure -takefocus 0
        }
    }
}
proc read_n_updateSetup {} {
    global  readfile filenameByBrowser
    global  numb_par numb_par_old numb_exp numb_exp_old

    set readfile $filenameByBrowser(setup_read)
    if [winfo exists .p] { destroyParDescription $numb_par $numb_exp }
    if [winfo exists .d] { destroyDataFileSelection $numb_exp }
    readSetup $readfile
    if [winfo exists .p] { createParDescription $numb_par $numb_exp }
    if [winfo exists .d] { createDataFileSelection $numb_exp }
    if [winfo exists .paav] { destroy .paav }
    set numb_par_old $numb_par
    set numb_exp_old $numb_exp
    destroy .setup_read 
    return 1 
}

proc readSetup filename {
    global  numb_par numb_exp modelname
    global  par_name par_short par_fixed par_keep par_pos par_guess
    global  data_use_nmax data_skip_first data_skip
    global  data_nmax data_numb_skip_first data_skip_intv
    global  two_column_data numb_dependent_vars FORTRAN_has_C_main
    global  residual_scale_type
    global  fit_mode datafile filenameByBrowser FUIdataChanged
    global  cc do_jacknife number_of_simulations sim_noise confidence
    global  FUIgraphType FUIaxisTitle FUIaxisLabelStyle title
    global  xvgrColor xvgrUseP

    set fullname "./$filename"
    regexp {^(.*)/([^/]+)$} $fullname match directory filename
    cd $directory
    set rf [open $filename]
    gets $rf line;
    regexp {FUI: Version ([0-9]+)\.([0-9]+)} $line match major minor
    gets $rf; gets $rf
    gets $rf line
    set modelname [lindex $line 0]
    wm title . "FUI -- $modelname"
    gets $rf; gets $rf; gets $rf
    gets $rf line
    set numb_par [lindex $line 0]
    set numb_exp [lindex $line 1]
    for {set i 0} {$i<$numb_par} {incr i} {
        gets $rf line
        set par_name($i,0)  [lindex $line 0]
        set par_short($i,0) [lindex $line 1]
        set par_fixed($i,0) [lindex $line 2]
        set par_keep($i,0)  [lindex $line 3]
        set par_pos($i,0)   [lindex $line 4]
        if $par_keep($i,0) { set top 1 } else { set top $numb_exp }
        for {set j 0; set k 5} {$j<$top} {incr k; incr j} {
            set par_guess($i,$j) [lindex $line $k]
            set par_fit($i,$j) ""
            set par_sim_mean($i,$j) ""
            set par_sim_var($i,$j) ""
        }
    }
    gets $rf; gets $rf; gets $rf
    gets $rf line
    set fit_mode [lindex $line 1]
    for {set i 0} {$i<$numb_exp} {incr i} {
        gets $rf line
        set datafile($i) [lindex $line 0]
        set filenameByBrowser(data$i) $datafile($i)
    }
    set FUIdataChanged 1
    gets $rf; gets $rf; gets $rf
    gets $rf line
    set cc(maxfev)  [lindex $line 0]
    set cc(ftol)    [lindex $line 1]
    set cc(xtol)    [lindex $line 2]
    set cc(gtol)    [lindex $line 3]
    set do_jacknife [lindex $line 4]
    gets $rf; gets $rf; gets $rf
    gets $rf line
    set number_of_simulations [lindex $line 0]
    set sim_noise [lindex $line 1]
    set confidence [lindex $line 2]
    gets $rf; gets $rf; gets $rf
    gets $rf line
    set FUIgraphType [lindex $line 0]
    gets $rf line
    regexp {`([^']*)' *`([^']*)'} $line match xtitle ytitle
    set FUIaxisTitle(x) $xtitle
    set FUIaxisTitle(y) $ytitle
    set title(x) $xtitle
    set title(y) $ytitle
    gets $rf line
    set FUIaxisLabelStyle(x) [lindex $line 0]
    set FUIaxisLabelStyle(y) [lindex $line 1]
    if [info exists major] {
        if {$major==1} {
            gets $rf; gets $rf; gets $rf
            for {set i 0} {$i<$numb_exp} {incr i} {
                gets $rf line
                set data_use_nmax($i) [lindex $line 0]
                set data_skip_first($i) [lindex $line 1]
                set data_skip($i) [lindex $line 2]
                set data_nmax($i) [lindex $line 3]
                set data_numb_skip_first($i) [lindex $line 4]
                set data_skip_intv($i) [lindex $line 5]
            }
            gets $rf; gets $rf; gets $rf
            gets $rf line
            set xvgrColor [lindex $line 0]
            set xvgrUseP  [lindex $line 1]
            set filenameByBrowser(xvgrParameters) [lindex $line 2]
            if {$minor>0} {
                gets $rf; gets $rf; gets $rf
                gets $rf line
                set two_column_data [lindex $line 0]
                set numb_dependent_vars [lindex $line 1]
                set FORTRAN_has_C_main [lindex $line 2]
                if {$minor>1} {  set residual_scale_type [lindex $line 3]  }
            }
        }
    } else {
        for {set i 0} {$i<$numb_exp} {incr i} {
            set data_use_nmax($i) 0
            set data_skip_first($i) 0
            set data_skip($i) 0
            set data_nmax($i) 100
            set data_numb_skip_first($i) 0
            set data_skip_intv($i) 1
        }
    }
    close $rf
}
