
proc mapSimulationDescription {} {
    global  number_of_simulations sim_noise confidence
    global  FUIstandardFont FUIbackground tk_version

    if [winfo exists .sim] { raise .sim } else {
        toplevel .sim
        wm title .sim "FUI: simulation parameters"
        frame .sim.fns
        label .sim.nsiml1 -text "Perform" -font $FUIstandardFont(pane) 
        entry .sim.nsim -width 3 -bd 2 -font $FUIstandardFont(pane) \
            -relief sunken -textvariable number_of_simulations
        bind .sim.nsim <Tab> { focus .sim.ce }
        label .sim.nsiml2 -text "Simulations" -font $FUIstandardFont(pane) 
        pack .sim.nsiml1 .sim.nsim .sim.nsiml2 -padx 2m -pady 2m -side left -in .sim.fns
        button .sim.close -text "C L O S E" -command "destroy .sim" \
            -font $FUIstandardFont(pane)
        frame .sim.fns_frame -width 36.5m
        pack .sim.close -padx 2m -pady 2m -ipadx 4m -side right -in .sim.fns
        pack .sim.fns_frame -side right -in .sim.fns
        pack .sim.fns -pady 2m
        frame .sim.confidence
        label .sim.cl -text "% Confidence Interval:" -font $FUIstandardFont(pane)
        entry .sim.ce -width 5 -bd 2 -font $FUIstandardFont(pane) \
            -relief sunken -textvariable confidence
        bind .sim.ce <Tab> { focus .sim.nsim }
        pack .sim.cl .sim.ce -padx 2m -pady 2m -side left -in .sim.confidence
        pack .sim.confidence -pady 2m -anchor w
        frame .sim.fm
        label .sim.fml -text "Noise Distribution:" -font $FUIstandardFont(pane) 
        radiobutton .sim.fmu -text uniform -variable sim_noise -value 1 -relief flat \
            -font $FUIstandardFont(pane)
        radiobutton .sim.fmg -text gaussian -variable sim_noise -value 2 -relief flat \
            -font $FUIstandardFont(pane)
        radiobutton .sim.fmb -text bootstrap -variable sim_noise -value 3 -relief flat \
            -font $FUIstandardFont(pane)
        pack .sim.fml .sim.fmu .sim.fmg .sim.fmb -padx 2m -pady 2m -side left -in .sim.fm
        pack .sim.fm
        focus .sim.nsim
        if {$tk_version>=4.0} {
            .sim.nsim configure -highlightbackground $FUIbackground
            .sim.ce configure -highlightbackground $FUIbackground
            .sim.close configure -highlightbackground $FUIbackground -takefocus 0
            .sim.fmu configure -highlightbackground $FUIbackground -takefocus 0
            .sim.fmg configure -highlightbackground $FUIbackground -takefocus 0
            .sim.fmb configure -highlightbackground $FUIbackground -takefocus 0
        }
    }
}