
proc TBShideSet {} {
    global  TBSnumbSets TBSnameSet TBSsetStatus
    global  TBScurrentFrame
    global  TBSstandardFont TBSstandardBackground
    global  tk_version

    set fid $TBScurrentFrame
    if [winfo exists .hsquery$fid] { raise .hsquery$fid } else {
        toplevel .hsquery$fid -bg $TBSstandardBackground(main)
        wm title .hsquery$fid "TBSplot (frame #$fid): hide"
        label .hsquery$fid.prompt -text "Toggle between hidden and displayed" \
            -font $TBSstandardFont(popup) -bg $TBSstandardBackground(main)
        pack .hsquery$fid.prompt -padx 2m -pady 2m -fill x -side top 
        frame .hsquery$fid.f -bg $TBSstandardBackground(main)
        if {$tk_version>=4.0} {
            listbox .hsquery$fid.sets -relief raised -borderwidth 2 -selectmode extended \
                -height 10 -width 40 -yscrollcommand ".hsquery$fid.scroll set" \
                -font $TBSstandardFont(popup) -bg $TBSstandardBackground(main) \
                -selectbackground $TBSstandardBackground(select) \
                -highlightbackground $TBSstandardBackground(main)
        } else {
            listbox .hsquery$fid.sets -relief raised -borderwidth 2 \
                -geometry 40x10 -yscrollcommand ".hsquery$fid.scroll set" \
                -font $TBSstandardFont(popup) -bg $TBSstandardBackground(main)
        }
        pack .hsquery$fid.sets -side left -in .hsquery$fid.f
        scrollbar .hsquery$fid.scroll -command ".hsquery$fid.sets yview" \
            -bg $TBSstandardBackground(main)
        pack .hsquery$fid.scroll -side right -fill y -in .hsquery$fid.f
        button .hsquery$fid.abort -text "A b o r t" -font $TBSstandardFont(popup) \
            -bg $TBSstandardBackground(main) \
            -command { 
                global TBScurrentFrame 
                destroy .hsquery$TBScurrentFrame
            }
        bind .hsquery$fid.abort <1> { TBSfindFrameId {.hsquery([0-9]+).abort} %W }
        button .hsquery$fid.use -text "U s e" -font $TBSstandardFont(popup) \
            -bg $TBSstandardBackground(main) \
            -command { 
                global   TBScurrentFrame tk_version
                set modified [selection get]
                set n [llength $modified]
                if {$tk_version<4.0} {
                    for {set i 0} {$i<$n} {incr i} { TBShide [lindex $modified $i] }
                } else {
                    for {set i 0} {$i<$n} {incr i 2} {
                        set mod "[lindex $modified $i] [lindex $modified [expr $i+1]]"
                        TBShide $mod
                    }
                }
                destroy .hsquery$TBScurrentFrame
            }
        bind .hsquery$fid.use <1> { TBSfindFrameId {.hsquery([0-9]+).use} %W }
        pack .hsquery$fid.f -padx 1m -pady 1m -side top
        pack .hsquery$fid.use -padx 2m -pady 2m -fill x -side top
        pack .hsquery$fid.abort -padx 2m -pady 2m -fill x -side top
        if {$tk_version>=4.0} {
            .hsquery$fid.scroll configure -activebackground $TBSstandardBackground(hilite) \
                -troughcolor $TBSstandardBackground(select) \
                -highlightbackground $TBSstandardBackground(main) 
            .hsquery$fid.use configure -activebackground $TBSstandardBackground(hilite) \
                -highlightbackground $TBSstandardBackground(main)
            .hsquery$fid.abort configure -activebackground $TBSstandardBackground(hilite) \
                -highlightbackground $TBSstandardBackground(main)
        } else {
            .hsquery$fid.scroll configure -activeforeground $TBSstandardBackground(hilite) \
                -background $TBSstandardBackground(select) \
                -foreground $TBSstandardBackground(main) 
            .hsquery$fid.use configure -activebackground $TBSstandardBackground(hilite)
            .hsquery$fid.abort configure -activebackground $TBSstandardBackground(hilite)
            .hsquery$fid.sets configure -selectforeground white \
                -selectbackground $TBSstandardBackground(select)
        }
        for {set i 0} {$i<$TBSnumbSets($fid)} {incr i} {
            if {$TBSsetStatus($fid,$i)=="deleted"} {
                continue
            } elseif {$TBSsetStatus($fid,$i)=="hidden"} { 
                set s "$TBSnameSet($fid,$i) (hidden)" 
            } else {
                set s "$TBSnameSet($fid,$i) (displayed)" 
            }
            .hsquery$fid.sets insert end $s
        }
    }
}
proc TBShide {modified} {
    global  TBSnumbSets TBSnameSet TBSsetStatus TBScurrentFrame
    global  TBSshowLegends TBSlegendCoords
    global  tk_version

    set fid $TBScurrentFrame
    for {set i 0} {$i<$TBSnumbSets($fid)} {incr i} {
        if {$tk_version<4.0} { regsub -all \{|\} $modified {} m } else { set m $modified }
        if [regsub { *\(hidden\) *$} $m {} mhidden] {
            if {$mhidden==$TBSnameSet($fid,$i)} {
                set TBSsetStatus($fid,$i) active
                .g$fid.c raise data$i
                .g$fid.c raise viewframe
                if $TBSshowLegends($fid) {
                    .g$fid.c delete legend
                    TBSplaceLegend $TBSlegendCoords($fid,x) $TBSlegendCoords($fid,y)
                }
                return
            }
        } elseif [regsub { *\(displayed\) *$} $m {} mactive] {
            if {$mactive==$TBSnameSet($fid,$i)} {
                set TBSsetStatus($fid,$i) hidden
                .g$fid.c lower data$i priming
                if $TBSshowLegends($fid) {
                    .g$fid.c delete legend
                    TBSplaceLegend $TBSlegendCoords($fid,x) $TBSlegendCoords($fid,y)
                }
                return
            }
        }
    }
}
proc TBSdeleteSet {} {
    global  TBSnumbSets TBSnameSet TBSsetStatus
    global  TBScurrentFrame
    global  TBSstandardFont TBSstandardBackground
    global  tk_version

    set fid $TBScurrentFrame
    if [winfo exists .dsquery$fid] { raise .dsquery$fid } else {
        toplevel .dsquery$fid -bg $TBSstandardBackground(main)
        wm title .dsquery$fid "TBSplot (frame #$fid): delete"
        label .dsquery$fid.prompt -text "Select set for deletion" \
            -font $TBSstandardFont(popup) -bg $TBSstandardBackground(main)
        pack .dsquery$fid.prompt -padx 2m -pady 2m -fill x -side top 
        frame .dsquery$fid.f -bg $TBSstandardBackground(main)
        if {$tk_version>=4.0} {
            listbox .dsquery$fid.sets -relief raised -borderwidth 2 -selectmode extended \
                -height 10 -width 40 -yscrollcommand ".dsquery$fid.scroll set" \
                -font $TBSstandardFont(popup) -bg $TBSstandardBackground(main) \
                -selectbackground $TBSstandardBackground(select) \
                -highlightbackground $TBSstandardBackground(main)
        } else {
            listbox .dsquery$fid.sets -relief raised -borderwidth 2 \
                -geometry 40x10 -yscrollcommand ".dsquery$fid.scroll set" \
                -font $TBSstandardFont(popup) -bg $TBSstandardBackground(main)
        }
        pack .dsquery$fid.sets -side left -in .dsquery$fid.f
        scrollbar .dsquery$fid.scroll -command ".dsquery$fid.sets yview" \
            -bg $TBSstandardBackground(main)
        pack .dsquery$fid.scroll -side right -fill y -in .dsquery$fid.f
        button .dsquery$fid.abort -text "A b o r t" -font $TBSstandardFont(popup) \
            -bg $TBSstandardBackground(main) \
            -command { 
                global TBScurrentFrame 
                destroy .dsquery$TBScurrentFrame
            }
        bind .dsquery$fid.abort <1> { TBSfindFrameId {.dsquery([0-9]+).abort} %W }
        button .dsquery$fid.use -text "U s e" -font $TBSstandardFont(popup) \
            -bg $TBSstandardBackground(main) \
            -command { 
                global   TBScurrentFrame    
                set selected [selection get]
                set n [llength $selected]
                if {$tk_version<4.0} {
                    for {set i 0} {$i<$n} {incr i} { TBSdelete [lindex $selected $i] }
                } else {
                    for {set i 0} {$i<$n} {incr i 2} {
                        set sel "[lindex $selected $i] [lindex $selected [expr $i+1]]"
                        TBSdelete $sel
                    }
                }
                destroy .dsquery$TBScurrentFrame
            }
        bind .dsquery$fid.use <1> { TBSfindFrameId {.dsquery([0-9]+).use} %W }
        if {$tk_version>=4.0} {
            .dsquery$fid.scroll configure -activebackground $TBSstandardBackground(hilite) \
                -troughcolor $TBSstandardBackground(select) \
                -highlightbackground $TBSstandardBackground(main) 
            .dsquery$fid.use configure -activebackground $TBSstandardBackground(hilite) \
                -highlightbackground $TBSstandardBackground(main)
            .dsquery$fid.abort configure -activebackground $TBSstandardBackground(hilite) \
                -highlightbackground $TBSstandardBackground(main)
        } else {
            .dsquery$fid.scroll configure -activeforeground $TBSstandardBackground(hilite) \
                -background $TBSstandardBackground(select) \
                -foreground $TBSstandardBackground(main) 
            .dsquery$fid.use configure -activebackground $TBSstandardBackground(hilite)
            .dsquery$fid.abort configure -activebackground $TBSstandardBackground(hilite)
            .dsquery$fid.sets configure -selectforeground white \
                -selectbackground $TBSstandardBackground(select)
        }
        pack .dsquery$fid.f -padx 1m -pady 1m -side top
        pack .dsquery$fid.use -padx 2m -pady 2m -fill x -side top
        pack .dsquery$fid.abort -padx 2m -pady 2m -fill x -side top
    
        for {set i 0} {$i<$TBSnumbSets($fid)} {incr i} {
            if {$TBSsetStatus($fid,$i)=="deleted"} {
                continue
            } elseif {$TBSsetStatus($fid,$i)=="hidden"} { 
                set s "$TBSnameSet($fid,$i) (hidden)" 
            } else {
                set s "$TBSnameSet($fid,$i) (displayed)" 
            }
            .dsquery$fid.sets insert end $s
        }
    }
}
proc TBSdelete {selected} {
    global  TBSnumbSets TBSnameSet TBSsetStatus TBScurrentFrame
    global  TBSshowLegends TBSlegendCoords
    global  TBSdataSkip
    global  tk_version

    set fid $TBScurrentFrame
    for {set i 0} {$i<$TBSnumbSets($fid)} {incr i} {
        if {$tk_version<4.0} { regsub -all \{|\} $selected {} s } else { set s $selected}
        regsub -all {( *\(hidden\)| *\(displayed\))} $s {} filename
        if {$filename==$TBSnameSet($fid,$i)} {
            set data_index $i
            set TBSsetStatus($fid,$data_index) deleted
            .g$fid.c delete data$data_index
            TBSresetExtrema $fid
            TBSscratchData $fid $data_index
            set numbActiv 0
            set k 0
            while {$k<$TBSnumbSets($fid)} {
                if {$TBSsetStatus($fid,$k)=="active"} { incr numbActiv }
                incr k
            }
            .g$fid.c delete legend
            TBSupdateDataSelection .g$fid.mbar.style.menu.data $fid \
                            $filename $data_index remove
            if $numbActiv {
                TBSredraw .g$fid.c $fid
                if $TBSshowLegends($fid) {
                    TBSplaceLegend $TBSlegendCoords($fid,x) $TBSlegendCoords($fid,y)
                }
            }
            if [winfo exists .tql$fid] { 
                destroy .tql$fid 
                TBSqueryLegends $fid
            }
            return
        }
    }
}
proc TBSloadFile {filename args} {
    global  TBScurrentFrame TBSnumbSets

    set fid $TBScurrentFrame
    set pa(style)  line
    set pa(symbol) ""
    set pa(width)  2
    set pa(color)  black
    if {$filename==""} {
        TBSqueryLoadFile
    } else {
        set nargs [expr [llength $args]/2]
        for {set m 0; set n 1; set l 0} {$l<$nargs} {incr l} {
            set flag  [lindex $args $m];  incr m 2
            set value [lindex $args $n];  incr n 2
            regsub {\-} $flag {} index
            set pa($index) $value
        }
        setPlotAttributes $TBSnumbSets($fid) $fid $pa(style) $pa(symbol) $pa(width) $pa(color)
        readDatafile $filename
    }
}
proc TBSqueryLoadFile {} {
    global TBSstandardFont TBSstandardBackground TBScurrentFrame TBSnumbSets 
    global filenameByBrowser tk_version

    set fid $TBScurrentFrame
    set pa(style)  line
    set pa(symbol) ""
    set pa(width)  2
    set pa(color)  black
    setPlotAttributes $TBSnumbSets($fid) $fid $pa(style) $pa(symbol) $pa(width) $pa(color)
    if [winfo exists .qlf$fid] { raise .qlf$fid } else {
        toplevel .qlf$fid -bg $TBSstandardBackground(main)
        wm title .qlf$fid "TBSplot (frame #$fid): load file"
        set filenameByBrowser(load_file) ""
        label .qlf$fid.l -text "Select data file" -font $TBSstandardFont(popup) \
            -bg $TBSstandardBackground(main)
        frame .qlf$fid.f -bg $TBSstandardBackground(main)
        button .qlf$fid.bd -text "Data File" -font $TBSstandardFont(popup) \
            -bg $TBSstandardBackground(main) -relief flat \
            -command { 
                global TBSstandardBackground
                getFileNameByBrowser . load_file $TBSstandardBackground(main) \
                    $TBSstandardBackground(hilite) $TBSstandardBackground(select)
            }
        entry .qlf$fid.ed -width 35 -relief sunken -bd 2 \
            -textvariable filenameByBrowser(load_file) -bd 2 \
            -font $TBSstandardFont(popupEntry) -bg $TBSstandardBackground(main)
        bind .qlf$fid.ed <Return> {
            askForStyleOptions
            destroy .qlf$TBScurrentFrame;
        }
        focus .qlf$fid.ed
        pack .qlf$fid.bd -ipadx 5m -pady 3m -side left -in .qlf$fid.f
        pack .qlf$fid.ed -padx 5m -pady 3m -side left -in .qlf$fid.f
        pack .qlf$fid.f
    
        frame .qlf$fid.f2 -bg $TBSstandardBackground(main)
        button .qlf$fid.ok -text Ok -font $TBSstandardFont(popup) \
            -bg $TBSstandardBackground(main) \
            -command {
                global  TBScurrentFrame
                askForStyleOptions
                destroy .qlf$TBScurrentFrame;
            }
	bind .qlf$fid.ok <1> { TBSfindFrameId {.qlf([0-9]+).ok} %W }
        button .qlf$fid.cancel -text Cancel -font $TBSstandardFont(popup) \
            -bg $TBSstandardBackground(main) \
            -command { 
                global  TBScurrentFrame
                destroy .qlf$TBScurrentFrame
            }
	bind .qlf$fid.cancel <1> { TBSfindFrameId {.qlf([0-9]+).cancel} %W }
        pack .qlf$fid.ok .qlf$fid.cancel -ipadx 6m -padx 6m -pady 3m -side left -in .qlf$fid.f2
        pack .qlf$fid.f2 -anchor w
        if {$tk_version>=4.0} {
            .qlf$fid.bd configure -activebackground $TBSstandardBackground(hilite) \
                -highlightbackground $TBSstandardBackground(main)
            .qlf$fid.ed configure -highlightbackground $TBSstandardBackground(main)
            .qlf$fid.ok configure -activebackground $TBSstandardBackground(hilite) \
                -highlightbackground $TBSstandardBackground(main)
            .qlf$fid.cancel configure -activebackground $TBSstandardBackground(hilite) \
                -highlightbackground $TBSstandardBackground(main)
        } else {
            .qlf$fid.bd configure -activebackground $TBSstandardBackground(hilite)
            .qlf$fid.ok configure -activebackground $TBSstandardBackground(hilite)
            .qlf$fid.cancel configure -activebackground $TBSstandardBackground(hilite)
        }
    }
}
proc askForStyleOptions {} {
    global  TBScurrentFrame TBS_symbolList TBS_linewidthList TBS_linecolorList
    global  a4_style a4_symbol a4_width a4_color
    global  TBSstandardFont TBSstandardBackground
    global  filenameByBrowser tk_version

    set fid $TBScurrentFrame
    if [winfo exists .a4so$fid] { raise .a4so$fid } else {
        toplevel .a4so$fid -bg $TBSstandardBackground(main)
        wm title .a4so$fid "TBSplot (frame #$fid): load file"
        if {![info exists a4_style($fid)]} {
            set a4_style($fid)  "line"
            set a4_symbol($fid) "openDiamond"
            set a4_width($fid)   2
            set a4_color($fid)  "black"
        }
        frame .a4so$fid.f1 -bg $TBSstandardBackground(main)
        frame .a4so$fid.f3 -bg $TBSstandardBackground(main) -relief groove -bd 2
        label .a4so$fid.l -text "Select style options" -font $TBSstandardFont(popup) \
            -bg $TBSstandardBackground(main)
        menubutton .a4so$fid.mstyle -text "Plot Style" -menu .a4so$fid.mstyle.menu \
            -font $TBSstandardFont(popup) -bg $TBSstandardBackground(main) \
            -activebackground $TBSstandardBackground(hilite)
	bind .a4so$fid.mstyle <1> { 
            global   TBScurrentFrame tk_version 
            if ($tk_version<4.0) { tk_mbButtonDown %W }
            regexp {.a4so([0-9]+).mstyle} %W match TBScurrentFrame
        }
        menu .a4so$fid.mstyle.menu -bg $TBSstandardBackground(main) \
            -activebackground $TBSstandardBackground(hilite)
        .a4so$fid.mstyle.menu add radiobutton -label "Line Plot" -variable a4_style($fid) \
            -value line -font $TBSstandardFont(popup)
        .a4so$fid.mstyle.menu add radiobutton -label "Bezier Plot" -variable a4_style($fid) \
            -value bezier -font $TBSstandardFont(popup)
        .a4so$fid.mstyle.menu add radiobutton -label "Marker Plot" -variable a4_style($fid) \
            -value marker -font $TBSstandardFont(popup)
        menubutton .a4so$fid.msymbol -text "Symbols" -menu .a4so$fid.msymbol.menu \
            -font $TBSstandardFont(popup) -bg $TBSstandardBackground(main) \
            -activebackground $TBSstandardBackground(hilite)
	bind .a4so$fid.msymbol <1> { 
            global   TBScurrentFrame tk_version 
            if ($tk_version<4.0) { tk_mbButtonDown %W }
            regexp {.a4so([0-9]+).msymbol} %W match TBScurrentFrame
        }
        menu .a4so$fid.msymbol.menu -bg $TBSstandardBackground(main) \
            -activebackground $TBSstandardBackground(hilite)
        foreach symbol $TBS_symbolList {
            .a4so$fid.msymbol.menu add radiobutton -label "$symbol" -font $TBSstandardFont(popup) \
                -variable a4_symbol($fid) -value $symbol
        }
        menubutton .a4so$fid.mwidth -text "Line Width" -menu .a4so$fid.mwidth.menu \
            -font $TBSstandardFont(popup) -bg $TBSstandardBackground(main) \
            -activebackground $TBSstandardBackground(hilite)
	bind .a4so$fid.mwidth <1> { 
            global   TBScurrentFrame tk_version 
            if ($tk_version<4.0) { tk_mbButtonDown %W }
            regexp {.a4so([0-9]+).mwidth} %W match TBScurrentFrame
        }
        menu .a4so$fid.mwidth.menu -bg $TBSstandardBackground(main) \
            -activebackground $TBSstandardBackground(hilite)
        foreach width $TBS_linewidthList {
            .a4so$fid.mwidth.menu add radiobutton -label "${width}pt" -font $TBSstandardFont(popup) \
                -variable a4_width($fid) -value $width
        }
        menubutton .a4so$fid.mcolor -text "Line Color" -menu .a4so$fid.mcolor.menu \
            -font $TBSstandardFont(popup) -bg $TBSstandardBackground(main) \
            -activebackground $TBSstandardBackground(hilite)
	bind .a4so$fid.mcolor <1> { 
            global   TBScurrentFrame tk_version 
            if ($tk_version<4.0) { tk_mbButtonDown %W }
            regexp {.a4so([0-9]+).mcolor} %W match TBScurrentFrame
        }
        menu .a4so$fid.mcolor.menu -bg $TBSstandardBackground(main) \
            -activebackground $TBSstandardBackground(hilite)
        foreach color $TBS_linecolorList {
            .a4so$fid.mcolor.menu add radiobutton -label "$color" -font $TBSstandardFont(popup) \
                -variable a4_color($fid) -value $color
        }
        pack .a4so$fid.mstyle .a4so$fid.msymbol .a4so$fid.mwidth .a4so$fid.mcolor \
            -ipadx 5m -pady 3m -side top -in .a4so$fid.f3
        pack .a4so$fid.l -ipadx 2m -pady 5m -side top -in .a4so$fid.f1
        pack .a4so$fid.f3 -padx 2m -pady 2m -anchor nw -side top -in .a4so$fid.f1

        frame .a4so$fid.f2 -bg $TBSstandardBackground(main)
        button .a4so$fid.ok -text Ok -font $TBSstandardFont(popup) \
            -bg $TBSstandardBackground(main) -activebackground $TBSstandardBackground(hilite) \
            -command {
                global  TBScurrentFrame TBSnumbSets filenameByBrowser
                global  a4_style a4_symbol a4_width a4_color

                set fullname "./$filenameByBrowser(load_file)"
                if [TBScheckDatafile $fullname] {
                    regexp {^(.*)/([^/]+)$} $fullname match directory filename
                    cd $directory
                    set filenameByBrowser(load_file) ""
                    set fid $TBScurrentFrame
                    set sid $TBSnumbSets($fid)
                    setPlotAttributes $sid $fid $a4_style($fid) $a4_symbol($fid) \
                                        $a4_width($fid) $a4_color($fid)
                    if {!$sid} { TBSsetCurrentStyleOptions $fid }
                    readDatafile $filename
                }
                destroy .a4so$TBScurrentFrame;
            }
	bind .a4so$fid.ok <1> { TBSfindFrameId {.a4so([0-9]+).ok} %W }
        button .a4so$fid.cancel -text Cancel -font $TBSstandardFont(popup) \
            -bg $TBSstandardBackground(main) -activebackground $TBSstandardBackground(hilite) \
            -command { 
                global TBScurrentFrame
                destroy .a4so$TBScurrentFrame
            }
	bind .a4so$fid.cancel <1> { TBSfindFrameId {.a4so([0-9]+).cancel} %W }
        pack .a4so$fid.ok -ipadx 6m -padx 8m -pady 3m -fill x -side top -in .a4so$fid.f2
        pack .a4so$fid.cancel -ipadx 6m -padx 8m -pady 3m -side top -in .a4so$fid.f2
        pack .a4so$fid.f1 -side left
        pack .a4so$fid.f2 -side left -anchor s
        if {$tk_version>=4.0} {
            .a4so$fid.ok configure -highlightbackground $TBSstandardBackground(main)
            .a4so$fid.cancel configure -highlightbackground $TBSstandardBackground(main)
        }
    }

}
proc readDatafile filename {
    global  TBSnumbSets TBSnameSet TBSsetStatus 
    global  TBSlegend TBSlegendCoords TBSshowLegends 
    global  TBScurrentFrame

    set fid $TBScurrentFrame
    set k $TBSnumbSets($fid)
    set TBSnameSet($fid,$k) "$filename-$k"
    set TBSlegend($fid,$k) "$filename-$k"
    set TBSsetStatus($fid,$k) active
    incr TBSnumbSets($fid)
    TBSupdateDataSelection .g$fid.mbar.style.menu.data $fid "$filename-$k" $k add

    TBSreadDatafile $filename $k $fid
    TBSredraw .g$fid.c $fid
    if $TBSshowLegends($fid) {
        .g$fid.c delete legend
        TBSplaceLegend $TBSlegendCoords($fid,x) $TBSlegendCoords($fid,y)
    }
    .g$fid.c raise viewframe
    if [winfo exists .tql$fid] {
        destroy .tql$fid
        TBSqueryLegends $fid
    }
}
proc TBSupdateDataSelection {menu frame filename index mode} {
    global  TBSstandardFont TBScurrentFile tk_version
    global  TBSnumbSets TBSsetStatus

    if {$mode=="add"} {
        $menu add radiobutton -label $filename -variable TBScurrentFile($frame) \
            -value $index -font $TBSstandardFont(menu) -command {
                global TBScurrentFrame
                TBSsetCurrentStyleOptions $TBScurrentFrame
            }
    } elseif {$mode=="remove"} {
        set ns [$menu index 1000000]
        if {$tk_version<4.0} {
            set init 0
        } else {
            set init 1
        }
        for {set i $init} {$i<=$ns} {incr i} {
            if [string match "*$filename*" [$menu entryconfigure $i -label]] {
                if {[lindex [$menu entryconfigure $i -value] 4]==$TBScurrentFile($frame)} {
                    set j $i
                    set count 1
                    while {$count<$TBSnumbSets($frame) && $TBSsetStatus($frame,$j)=="deleted"} {
                        incr j
                        incr count
                        if {$j>=$TBSnumbSets($frame)} { set j 0 }
                    }
                    if {$count<$TBSnumbSets($frame)} {
                        set TBScurrentFile($frame) $j
                        TBSsetCurrentStyleOptions $frame
                    }
                }
                $menu delete $i
                break
            }
        }
    }
}