
proc mapPlot {filename number_of_files parent} {
    global  PX2MM env
    global  frame_id TBScurrentFrame TBSparentType
    global  TBSstandardBackground
    global  TBSgraphType 
    global  TBSnumbSets TBSnameSet TBSsetStatus TBSlegend TBSshowLegends
    upvar  $filename file

    incr frame_id
    if {[info exists env(HOSTNAME)] && $env(HOSTNAME)=="loplop"} {
        set PX2MM 0.33898305084745761
    } else {
        set PX2MM 0.30534351145038169
    }
    set  i $frame_id
    set  TBScurrentFrame $frame_id
    set  TBSparentType($i) $parent
    set  TBSshowLegends($i) 0
    set  TBSnumbSets($i) $number_of_files
    for {set j 0} {$j<$number_of_files} {incr j} {
        set TBSnameSet($i,$j) $file($j)
        set TBSlegend($i,$j) $file($j)
        set TBSsetStatus($i,$j) active
    }
    if [info exists TBSgraphType($i)] {
        TBSsetGraphType $i $TBSgraphType($i)
    } else {
        TBSsetGraphType $i 0 
    }
    if [winfo exists .g$i] { raise .g$i } else {
        toplevel .g$i
        wm title .g$i "TBSplot: frame #$i"
        frame .g$i.mbar -relief raised -bd 2 -bg $TBSstandardBackground(main) 
        frame .g$i.t -height 1.0c -bg $TBSstandardBackground(main)
        frame .g$i.b -bg $TBSstandardBackground(main)
    
        pack .g$i.mbar .g$i.t .g$i.b -side top -fill x
        createFileMenu $i
        createTypeMenu $i
        createStyleMenu $i file $number_of_files
        createLabelMenu $i
        createPostscriptMenu $i
        pack .g$i.mbar.file .g$i.mbar.type .g$i.mbar.style .g$i.mbar.label .g$i.mbar.post \
            -ipadx 5m -side left
    
        frame .g$i.f -relief ridge -bd 4
        canvas .g$i.c -width 19c -height 13.5c -bg $TBSstandardBackground(canvas) 
        pack .g$i.f -padx 1.5m -pady 1.5m -in .g$i.b
        pack .g$i.c -padx 0.75m -pady 0.75m -in .g$i.f
        .g$i.c create rectangle 0m 0m 190m 135m -fill $TBSstandardBackground(canvas) \
            -outline $TBSstandardBackground(canvas) -tags priming
        setVPC2CC 150 -100 34 106
        .g$i.c create rectangle 34m 6m 184m 106m -fill $TBSstandardBackground(viewbox) -tags viewbox

        bind .g$i.c <Button-3> { 
            global TBScurrentFrame TBSshowLegends
            global TBSlegendCoords
            regexp {.g([0-9]+).c} "%W" match TBScurrentFrame 
            if {!$TBSshowLegends($TBScurrentFrame)} {
                set TBSshowLegends($TBScurrentFrame) 1
                set TBSlegendCoords($TBScurrentFrame,x) %x
                set TBSlegendCoords($TBScurrentFrame,y) %y
                TBSplaceLegend %x %y 
                update
            }
        }
        .g$i.c bind legend <Any-Enter> { 
            global TBScurrentFrame
            regexp {.g([0-9]+).c} "%W" match TBScurrentFrame 
            .g$TBScurrentFrame.c itemconfigure legendtext -fill magenta
            update
        }
        .g$i.c bind legend <Any-Leave> { 
            global TBScurrentFrame
            regexp {.g([0-9]+).c} "%W" match TBScurrentFrame 
            .g$TBScurrentFrame.c itemconfigure legendtext -fill black 
            update
        }
        .g$i.c bind legend <Button-1> {
            global TBSlegendCoords currentCoords
            global TBScurrentFrame
            regexp {.g([0-9]+).c} "%W" match TBScurrentFrame 
            set currentCoords($TBScurrentFrame,x) %x
            set currentCoords($TBScurrentFrame,y) %y
            update
        }
        .g$i.c bind legend <B1-Motion> {
            global TBSlegendCoords
            global TBScurrentFrame
            regexp {.g([0-9]+).c} "%W" match TBScurrentFrame 
            set fid $TBScurrentFrame
            set shift(x) [expr %x-$currentCoords($fid,x)]
            set shift(y) [expr %y-$currentCoords($fid,y)]
            .g$fid.c move legend $shift(x) $shift(y)
            set currentCoords($fid,x) %x
            set currentCoords($fid,y) %y
            set TBSlegendCoords($fid,x) [expr $TBSlegendCoords($fid,x)+$shift(x)]
            set TBSlegendCoords($fid,y) [expr $TBSlegendCoords($fid,y)+$shift(y)]
            update
        }

        TBSdataInitialize $i
        for {set j 0} {$j<$number_of_files} {incr j} { TBSreadDatafile $file($j) $j $i }
        if {$number_of_files>0} { TBSdraw .g$i.c $i }
    
        .g$i.c create rectangle 34m 6m 184m 106m -width 3 -tags viewframe
    }
}
