
proc createFileMenu i {
    global  TBSstandardFont TBSstandardBackground

    menubutton .g$i.mbar.file -text File -menu .g$i.mbar.file.menu \
        -font $TBSstandardFont(menubar) -bg $TBSstandardBackground(menubar) \
        -activebackground $TBSstandardBackground(hilite)
    menu .g$i.mbar.file.menu -bg $TBSstandardBackground(menu) \
        -activebackground $TBSstandardBackground(hilite) 
    .g$i.mbar.file.menu add command -label "New Frame" -font $TBSstandardFont(menu) \
        -command { 
            global TBScurrentFrame TBSparentType
            global TBSgraphType TBSaxisTitle TBSaxisLabelStyle
            global frame_id

            set id [expr $frame_id+1]
            setPlotAttributes 0 $id line "" 2 black
            set TBSgraphType($id) $TBSgraphType($TBScurrentFrame)
            set TBSaxisTitle($id,x) $TBSaxisTitle($TBScurrentFrame,x)
            set TBSaxisTitle($id,y) $TBSaxisTitle($TBScurrentFrame,y)
            set TBSaxisLabelStyle($id,x) $TBSaxisLabelStyle($TBScurrentFrame,x)
            set TBSaxisLabelStyle($id,y) $TBSaxisLabelStyle($TBScurrentFrame,y)
            mapPlot {} 0 $TBSparentType($TBScurrentFrame)
        }
    .g$i.mbar.file.menu add separator
    .g$i.mbar.file.menu add command -label "Load Set..." -command { TBSloadFile "" } \
        -font $TBSstandardFont(menu)
    .g$i.mbar.file.menu add command -label "Hide Set..." -command { TBShideSet } \
        -font $TBSstandardFont(menu)
    .g$i.mbar.file.menu add command -label "Delete Set..." -command { TBSdeleteSet } \
        -font $TBSstandardFont(menu)
    .g$i.mbar.file.menu add separator
    .g$i.mbar.file.menu add command -label Redraw -font $TBSstandardFont(menu) \
        -command {
            global  TBScurrentFrame
            global  TBSshowLegends TBSlegendCoords
            set fid $TBScurrentFrame
            set numbActiv 0
            set k 0
            while {$k<$TBSnumbSets($fid)} {
                if {$TBSsetStatus($fid,$k)=="active"} { incr numbActiv }
                incr k
            }
            if $numbActiv {
                TBSredraw .g$fid.c $fid
                if $TBSshowLegends($fid) {
                    .g$fid.c delete legend
                    TBSplaceLegend $TBSlegendCoords($fid,x) $TBSlegendCoords($fid,y)
                }
            }
        }
    .g$i.mbar.file.menu add separator
    .g$i.mbar.file.menu add command -label Exit -font $TBSstandardFont(menu) \
        -command {
            global frame_id TBScurrentFrame TBSparentType
            set fid $TBScurrentFrame
            if {$TBSparentType($TBScurrentFrame) == "TBSplot"} {
                for {set count 0; set i 0} {$i<=$frame_id} {incr i} {
                    if [winfo exists .g$i] { incr count }
                }
            } else { set count 999 }
            destroy .g$fid
            if [winfo exists .tql$fid] { destroy .tql$fid }
            if {$count==1} exit
        }
    bind .g$i.mbar.file <Button-1> { 
        global TBScurrentFrame tk_version
        if {$tk_version<4.0} { tk_mbButtonDown %W }
        regexp {.g([0-9]+).mbar.file} "%W" match TBScurrentFrame 
    }
}
proc createTypeMenu i {
    global  TBSstandardFont TBSstandardBackground

    menubutton .g$i.mbar.type -text "Graph Type" -menu .g$i.mbar.type.menu \
        -font $TBSstandardFont(menubar) -bg $TBSstandardBackground(menubar) \
        -activebackground $TBSstandardBackground(hilite) 
    menu .g$i.mbar.type.menu -bg $TBSstandardBackground(menu) \
        -activebackground $TBSstandardBackground(hilite)
    .g$i.mbar.type.menu add radiobutton -label "XY Graph" -variable TBSgraphType($i) \
        -value 0 -font $TBSstandardFont(menu) -command { TBSchangeGraphType 0 "" "" }
    .g$i.mbar.type.menu add radiobutton -label "Linear--Log" -variable TBSgraphType($i) \
        -value 1 -font $TBSstandardFont(menu) -command { TBSchangeGraphType 1 "" "log10" }
    .g$i.mbar.type.menu add radiobutton -label "Log--Linear" -variable TBSgraphType($i) \
        -value 2 -font $TBSstandardFont(menu) -command { TBSchangeGraphType 2 "log10" "" }
    .g$i.mbar.type.menu add radiobutton -label "Log--Log" -variable TBSgraphType($i) \
        -value 3 -font $TBSstandardFont(menu) -command { TBSchangeGraphType 3 "log10" "log10" }
    bind .g$i.mbar.type <Button-1> { 
        global TBScurrentFrame tk_version
        if {$tk_version<4.0} { tk_mbButtonDown %W }
        regexp {.g([0-9]+).mbar.type} "%W" match TBScurrentFrame 
    }
}
proc createStyleMenu {i filename number_of_files} {
    global  TBSstandardFont TBSstandardBackground
    global  TBS_symbolList TBS_linewidthList TBS_linecolorList
    global  TBScurrentFile TBSlegend
    global  TBScurrentStyle TBScurrentSymbol TBScurrentLinewidth TBScurrentLinecolor
    upvar  $filename file

    set TBScurrentFile($i) 0
    TBSsetCurrentStyleOptions $i

    menubutton .g$i.mbar.style -text "Plot Style" -menu .g$i.mbar.style.menu \
        -font $TBSstandardFont(menubar) -bg $TBSstandardBackground(menubar) \
        -activebackground $TBSstandardBackground(hilite) 
    menu .g$i.mbar.style.menu -bg $TBSstandardBackground(menu) \
        -activebackground $TBSstandardBackground(hilite)
    bind .g$i.mbar.style <Button-1> { 
        global TBScurrentFrame tk_version
        if {$tk_version<4.0} { tk_mbButtonDown %W }
        regexp {.g([0-9]+).mbar.style} "%W" match TBScurrentFrame 
    }
    .g$i.mbar.style.menu add cascade -label "Select Data Set" -menu .g$i.mbar.style.menu.data \
        -font $TBSstandardFont(menu)
    menu .g$i.mbar.style.menu.data -bg $TBSstandardBackground(menubar) \
        -activebackground $TBSstandardBackground(hilite)
    for {set k 0} {$k<$number_of_files} {incr k} {
        .g$i.mbar.style.menu.data add radiobutton -label $file($k) -variable TBScurrentFile($i) \
            -value $k -font $TBSstandardFont(menu) -command {
                global TBScurrentFrame
                TBSsetCurrentStyleOptions $TBScurrentFrame
        }
    }
    .g$i.mbar.style.menu add separator
    .g$i.mbar.style.menu add radiobutton -label "Line Plot" -variable TBScurrentStyle($i) \
        -value line -font $TBSstandardFont(menu) -command {
            global  TBScurrentFrame TBSnumbSets
            if {$TBSnumbSets($TBScurrentFrame)>0} { TBSsetCurrentStyle $TBScurrentFrame line }
        }
    .g$i.mbar.style.menu add radiobutton -label "Bezier Plot" -variable TBScurrentStyle($i) \
        -value bezier -font $TBSstandardFont(menu) -command {
            global  TBScurrentFrame TBSnumbSets
            if {$TBSnumbSets($TBScurrentFrame)>0} { TBSsetCurrentStyle $TBScurrentFrame bezier }
        }
    .g$i.mbar.style.menu add radiobutton -label "Marker Plot" -variable TBScurrentStyle($i) \
        -value marker -font $TBSstandardFont(menu) -command {
            global  TBScurrentFrame TBSnumbSets
            if {$TBSnumbSets($TBScurrentFrame)>0} { TBSsetCurrentStyle $TBScurrentFrame marker }
        }
    .g$i.mbar.style.menu add separator
    .g$i.mbar.style.menu add cascade -label Symbols -menu .g$i.mbar.style.menu.symbols \
        -font $TBSstandardFont(menu)
    .g$i.mbar.style.menu add cascade -label "Line Width" -menu .g$i.mbar.style.menu.width \
        -font $TBSstandardFont(menu)
    .g$i.mbar.style.menu add cascade -label "Line Color" -menu .g$i.mbar.style.menu.color \
        -font $TBSstandardFont(menu)
    menu .g$i.mbar.style.menu.symbols -bg $TBSstandardBackground(menubar) \
        -activebackground $TBSstandardBackground(hilite)
    foreach symbol $TBS_symbolList {
        .g$i.mbar.style.menu.symbols add radiobutton -label "$symbol" -font $TBSstandardFont(menu) \
            -variable TBScurrentSymbol($i) -value $symbol -command {
                global  TBScurrentFrame TBSnumbSets
                if {$TBSnumbSets($TBScurrentFrame)>0} { TBSsetCurrentSymbol $TBScurrentFrame }
            }
    }
    menu .g$i.mbar.style.menu.width -bg $TBSstandardBackground(menubar) \
        -activebackground $TBSstandardBackground(hilite)
    foreach width $TBS_linewidthList {
        .g$i.mbar.style.menu.width add radiobutton -label ${width}pt -font $TBSstandardFont(menu) \
            -variable TBScurrentLinewidth($i) -value $width \
            -command {
                global TBScurrentFrame TBSnumbSets
                if {$TBSnumbSets($TBScurrentFrame)>0} { TBSsetCurrentLinewidth $TBScurrentFrame }
            }
    }
    menu .g$i.mbar.style.menu.color -bg $TBSstandardBackground(menubar) \
        -activebackground $TBSstandardBackground(hilite)
    foreach color $TBS_linecolorList {
        .g$i.mbar.style.menu.color add radiobutton -label $color -font $TBSstandardFont(menu) \
            -variable TBScurrentLinecolor($i) -value $color \
            -command {
                global TBScurrentFrame TBSnumbSets
                if {$TBSnumbSets($TBScurrentFrame)>0} { TBSsetCurrentLinecolor $TBScurrentFrame }
            }
    }
}
proc createLabelMenu i {
    global  TBSstandardFont TBSstandardBackground TBSaxisLabelStyle

    menubutton .g$i.mbar.label -text Annotations -menu .g$i.mbar.label.menu \
        -font $TBSstandardFont(menubar) -bg $TBSstandardBackground(menubar) \
        -activebackground $TBSstandardBackground(hilite) 
    menu .g$i.mbar.label.menu -bg $TBSstandardBackground(menu) \
        -activebackground $TBSstandardBackground(hilite)
    bind .g$i.mbar.label <Button-1> { 
        global TBScurrentFrame tk_version
        if {$tk_version<4.0} { tk_mbButtonDown %W }
        regexp {.g([0-9]+).mbar.label} "%W" match TBScurrentFrame 
    }
    .g$i.mbar.label.menu add command -label "Axis Titles..." -font $TBSstandardFont(menu) \
        -command {global TBScurrentFrame; TBSqueryAxesTitle $TBScurrentFrame}
    .g$i.mbar.label.menu add separator
    .g$i.mbar.label.menu add cascade -label "X Axis Labels" -menu .g$i.mbar.label.menu.xlabel \
        -font $TBSstandardFont(menu)
    menu .g$i.mbar.label.menu.xlabel -bg $TBSstandardBackground(menubar) \
        -activebackground $TBSstandardBackground(hilite)
    .g$i.mbar.label.menu.xlabel add radiobutton -label "Decimal" -font $TBSstandardFont(menu) \
        -variable TBSaxisLabelStyle($i,x) -value decimal -command {
            global TBScurrentFrame; TBSredrawAxesLabels .g$TBScurrentFrame.c $TBScurrentFrame }
    .g$i.mbar.label.menu.xlabel add radiobutton -label "Power" -font $TBSstandardFont(menu) \
        -variable TBSaxisLabelStyle($i,x) -value power -command {
            global TBScurrentFrame TBSgraphFunction TBSnumbSets
            set id $TBScurrentFrame
            if {$TBSnumbSets($id)>0} {
                if {$TBSgraphFunction($id,x)=="log10"} {
                    TBSredrawAxesLabels .g$id.c $id 
                } else {
                    set TBSaxisLabelStyle($id,x) decimal
                }
            }
        }
    .g$i.mbar.label.menu add cascade -label "Y Axis Labels" -menu .g$i.mbar.label.menu.ylabel \
        -font $TBSstandardFont(menu)
    menu .g$i.mbar.label.menu.ylabel -bg $TBSstandardBackground(menubar) \
        -activebackground $TBSstandardBackground(hilite)
    .g$i.mbar.label.menu.ylabel add radiobutton -label "Decimal" -font $TBSstandardFont(menu) \
        -variable TBSaxisLabelStyle($i,y) -value decimal -command {
            global TBScurrentFrame; TBSredrawAxesLabels .g$TBScurrentFrame.c $TBScurrentFrame }
    .g$i.mbar.label.menu.ylabel add radiobutton -label "Power" -font $TBSstandardFont(menu) \
        -variable TBSaxisLabelStyle($i,y) -value power -command {
            global TBScurrentFrame TBSgraphFunction TBSnumbSets
            set id $TBScurrentFrame
            if {$TBSnumbSets($id)>0} {
                if {$TBSgraphFunction($id,y)=="log10"} {
                    TBSredrawAxesLabels .g$id.c $id 
                } else {
                    set TBSaxisLabelStyle($id,y) decimal
                }
            }
        }
    .g$i.mbar.label.menu add separator
    .g$i.mbar.label.menu add command -label "Legends..." -font $TBSstandardFont(menu) \
        -command {global TBScurrentFrame; TBSqueryLegends $TBScurrentFrame}
}
proc createPostscriptMenu i {
    global  TBSstandardFont TBSstandardBackground

    menubutton .g$i.mbar.post -text PostScript -menu .g$i.mbar.post.menu \
        -font $TBSstandardFont(menubar) -bg $TBSstandardBackground(menubar) \
        -activebackground $TBSstandardBackground(hilite)
    menu .g$i.mbar.post.menu -bg $TBSstandardBackground(menu) \
        -activebackground $TBSstandardBackground(hilite)
    bind .g$i.mbar.post <Button-1> { 
        global TBScurrentFrame tk_version
        if {$tk_version<4.0} { tk_mbButtonDown %W }
        regexp {.g([0-9]+).mbar.post} "%W" match TBScurrentFrame 
    }
    .g$i.mbar.post.menu add command -label "Print..." -font $TBSstandardFont(menu) \
        -command {global TBScurrentFrame; TBSpostscript $TBScurrentFrame}
}
proc TBSqueryAxesTitle i {
    global  TBSstandardFont TBSstandardBackground
    global  TBSaxisTitle TBSqatXtitle TBSqatYtitle
    global  tk_version

    if [winfo exists .tqat$i] { raise .tqat$i } else {
        toplevel .tqat$i -bg $TBSstandardBackground(main)
        wm title .tqat$i "TBSplot (frame #$i): Axis Titles"
        frame .tqat$i.fx -bg $TBSstandardBackground(main)
        label .tqat$i.lx -text "X axis title" -font $TBSstandardFont(popup) \
            -bg $TBSstandardBackground(main)
        entry .tqat$i.ex -width 35 -relief sunken -bd 2 \
            -textvariable xtitle -bd 2 \
            -font $TBSstandardFont(popup) -bg $TBSstandardBackground(main)
        bind .tqat$i.ex <Tab> { global TBScurrentFrame; focus .tqat$TBScurrentFrame.ey }
        pack .tqat$i.lx .tqat$i.ex -padx 5m -pady 3m -side left -in .tqat$i.fx
        frame .tqat$i.fy -bg $TBSstandardBackground(main)
        label .tqat$i.ly -text "Y axis title" \
            -font $TBSstandardFont(popup) -bg $TBSstandardBackground(main)
        entry .tqat$i.ey -width 35 -relief sunken -bd 2 \
            -textvariable ytitle -bd 2 \
            -font $TBSstandardFont(popup) -bg $TBSstandardBackground(main)
        bind .tqat$i.ey <Tab> { global TBScurrentFrame; focus .tqat$TBScurrentFrame.ex }
        pack .tqat$i.ly .tqat$i.ey -padx 5m -pady 3m -side left -in .tqat$i.fy
        pack .tqat$i.fx .tqat$i.fy
        focus .tqat$i.ex
    
        frame .tqat$i.f2 -bg $TBSstandardBackground(main)
        button .tqat$i.ok -text Ok -font $TBSstandardFont(popup) \
            -bg $TBSstandardBackground(main) -activebackground $TBSstandardBackground(hilite) \
            -command {
                global  TBScurrentFrame TBSnumbSets
                set id $TBScurrentFrame
                set TBSaxisTitle($id,x) $xtitle
                set TBSaxisTitle($id,y) $ytitle
                if {$TBSnumbSets($id)>0} { TBSredrawAxesLabels .g$id.c $id }
                destroy .tqat$id 
            }
        bind .tqat$i.ok <1> { TBSfindFrameId {.tqat([0-9]+)} %W }
        button .tqat$i.cancel -text Cancel -font $TBSstandardFont(popup) \
            -bg $TBSstandardBackground(main) -activebackground $TBSstandardBackground(hilite) \
            -command { global TBScurrentFrame; destroy .tqat$TBScurrentFrame }
        bind .tqat$i.cancel <1> { TBSfindFrameId {.tqat([0-9]+)} %W }
        pack .tqat$i.ok .tqat$i.cancel -ipadx 6m -padx 6m -pady 3m -side left -in .tqat$i.f2
        pack .tqat$i.f2 -anchor w
        if {$tk_version>=4.0} {
            .tqat$i.ex configure -highlightbackground $TBSstandardBackground(main)
            .tqat$i.ey configure -highlightbackground $TBSstandardBackground(main)
            .tqat$i.ok configure -highlightbackground $TBSstandardBackground(main)
            .tqat$i.cancel configure -highlightbackground $TBSstandardBackground(main)
        }
    }
}
proc TBSqueryLegends id {
    global  TBSstandardFont TBSstandardBackground
    global  TBSlegend TBSnumbSets TBSsetStatus
    global  LegendTabList
    global  tk_version

    set numbActiv 0
    set k 0
    while {$k<$TBSnumbSets($id)} {
        if {$TBSsetStatus($id,$k)!="deleted"} { incr numbActiv }
        incr k
    }
    if [winfo exists .tql$id] { 
        raise .tql$id 
    } elseif $numbActiv {
        toplevel .tql$id -bg $TBSstandardBackground(main)
        wm title .tql$id "TBSplot (frame #$id): Legends"
        set LegendTabList [list]

        for {set i 0; set j 0} {$i<$TBSnumbSets($id)} {incr i} {
            if {$TBSsetStatus($id,$i)=="deleted"} { continue }
            frame .tql$id.f$j -bg $TBSstandardBackground(main)
            label .tql$id.l$j -text "Legend [expr $j+1]" -font $TBSstandardFont(popup) \
                -bg $TBSstandardBackground(main)
            entry .tql$id.e$j -width 35 -relief sunken -bd 2 -bg $TBSstandardBackground(main) \
                -textvariable TBSlegend($id,$i) -font $TBSstandardFont(popup)
            if {$tk_version>=4.0} {
                .tql$id.e$j configure -highlightbackground $TBSstandardBackground(main)
            }
            bind .tql$id.e$j <Return> {
                global  TBScurrentFrame
                regexp {.tql([0-9]+)} "%W" match TBScurrentFrame 
                updateLegends 
            }
            pack .tql$id.l$j .tql$id.e$j -padx 5m -pady 3m -side left -in .tql$id.f$j
            pack .tql$id.f$j -side top -fill x
            set LegendTabList [linsert $LegendTabList end .tql$id.e$j]
            incr j
        }
        foreach win $LegendTabList {
            bind $win <Tab> { tabForward $LegendTabList }
        }
        foreach win $LegendTabList {
            bind $win <Meta-Tab> { tabBackward $LegendTabList }
        }
        focus .tql$id.e0
        frame .tql$id.cf -bg $TBSstandardBackground(main)
        button .tql$id.update -text "U p d a t e" -font $TBSstandardFont(popup) \
            -bg $TBSstandardBackground(main) -activebackground $TBSstandardBackground(hilite) \
            -command {
                global  TBScurrentFrame
                updateLegends
            }
        bind .tql$id.update <Button-1> { TBSfindFrameId {.tql([0-9]+)} %W }
        button .tql$id.clear -text "C l e a r" -font $TBSstandardFont(popup) \
            -bg $TBSstandardBackground(main) -activebackground $TBSstandardBackground(hilite) \
            -command {
                global  TBScurrentFrame
                set TBSshowLegends($TBScurrentFrame) 0
                .g$TBScurrentFrame.c delete legend
            }
        bind .tql$id.clear <Button-1> { TBSfindFrameId {.tql([0-9]+)} %W }
        button .tql$id.close -text "C l o s e" -font $TBSstandardFont(popup) \
            -bg $TBSstandardBackground(main) -activebackground $TBSstandardBackground(hilite) \
            -command {
                global  TBScurrentFrame
                destroy .tql$TBScurrentFrame
            }
        bind .tql$id.close <Button-1> { TBSfindFrameId {.tql([0-9]+)} %W }
	pack .tql$id.update .tql$id.clear .tql$id.close -padx 5m -pady 3m -ipadx 2m -ipady 0m \
            -side left -in .tql$id.cf
        pack .tql$id.cf -side top -anchor w
        if {$tk_version>=4.0} {
            .tql$id.update configure -highlightbackground $TBSstandardBackground(main)
            .tql$id.clear configure -highlightbackground $TBSstandardBackground(main)
            .tql$id.close configure -highlightbackground $TBSstandardBackground(main)
        }
    }
}
proc updateLegends {} {
    global   TBScurrentFrame
    global   TBSlegendCoords TBSshowLegends

    set fid $TBScurrentFrame
    if {![info exists TBSlegendCoords($fid,x)]} {
        set TBSlegendCoords($fid,x) 120
    }
    if {![info exists TBSlegendCoords($fid,y)]} {
        set TBSlegendCoords($fid,y) 35
    }
    set TBSshowLegends($fid) 1
    .g$fid.c delete legend
    TBSplaceLegend $TBSlegendCoords($fid,x) $TBSlegendCoords($fid,y)
}
proc TBSpostscript id {
    global TBSpostscriptFile TBSstandardFont TBSstandardBackground
    global tk_version

    if [info exists TBSpostscriptFile($id)] {
        set filenameByBrowser(TBSpostscript) $TBSpostscriptFile($id)
    }
    if [winfo exists .ps$id] { raise .ps$id } else {
        toplevel .ps$id -bg $TBSstandardBackground(main)
        wm title .ps$id "TBSplot (frame #$id): PostScript file"
        label .ps$id.l -text "Print to..." -font $TBSstandardFont(1) -bg $TBSstandardBackground(main)
        frame .ps$id.f -bg $TBSstandardBackground(main)
        button .ps$id.bd -text "File" -font $TBSstandardFont(popup) \
            -bg $TBSstandardBackground(main) -activebackground $TBSstandardBackground(hilite) \
            -relief flat -command {
                global  TBSstandardBackground
                getFileNameByBrowser . TBSpostscript $TBSstandardBackground(main) \
                    $TBSstandardBackground(hilite) $TBSstandardBackground(select)
            }
        entry .ps$id.ed -width 35 -relief sunken -bd 2 \
            -textvariable filenameByBrowser(TBSpostscript) -bd 2 \
            -font $TBSstandardFont(popupEntry) -bg $TBSstandardBackground(main)
        bind .ps$id.ed <Return> {
            global  TBScurrentFrame
            set id $TBScurrentFrame
            set TBSpostscriptFile($id) $filenameByBrowser(TBSpostscript)
            if {$TBSpostscriptFile($id) != ""} {	
                .g$id.c postscript -file $TBSpostscriptFile($id) 
                exec TBSps-remove-gray.pl $TBSpostscriptFile($id)
            }
            destroy .ps$id 
        } 
        focus .ps$id.ed
        pack .ps$id.bd -ipadx 5m -pady 3m -side left -in .ps$id.f
        pack .ps$id.ed -padx 5m -pady 3m -side left -in .ps$id.f
        pack .ps$id.f
    
        frame .ps$id.f2 -bg $TBSstandardBackground(main)
        button .ps$id.ok -text Ok -font $TBSstandardFont(popup) \
            -bg $TBSstandardBackground(main) -activebackground $TBSstandardBackground(hilite) \
            -command {
                global  TBScurrentFrame
                set id $TBScurrentFrame
                set TBSpostscriptFile($id) $filenameByBrowser(TBSpostscript)
                if {$TBSpostscriptFile($id) != ""} { 
                    .g$id.c postscript -file $TBSpostscriptFile($id) 
                    exec TBSps-remove-gray.pl $TBSpostscriptFile($id)
                }
                destroy .ps$id 
            }
        bind .ps$id.ok <1> { TBSfindFrameId {.ps([0-9]+)} %W }
        button .ps$id.cancel -text Cancel -font $TBSstandardFont(popup) \
            -bg $TBSstandardBackground(main) -activebackground $TBSstandardBackground(hilite) \
            -command { 
                global TBScurrentFrame
                destroy .ps$TBScurrentFrame
            }
        bind .ps$id.cancel <1> { TBSfindFrameId {.ps([0-9]+)} %W }
        pack .ps$id.ok .ps$id.cancel -ipadx 6m -padx 6m -pady 3m \
            -side left -in .ps$id.f2
        pack .ps$id.f2 -anchor w
        if {$tk_version>=4.0} {
            .ps$id.bd configure -highlightbackground $TBSstandardBackground(main)
            .ps$id.ed configure -highlightbackground $TBSstandardBackground(main)
            .ps$id.ok configure -highlightbackground $TBSstandardBackground(main)
            .ps$id.cancel configure -highlightbackground $TBSstandardBackground(main)
        }
    }
}
