
proc filledTriangleUp   {win x y index args} {
	set delta_x   0.014
	set delta_y  [expr $delta_x*1.5]
	set x_minus  [expr $x-$delta_x]
	set x_plus   [expr $x+$delta_x]
	set y_minus  [expr $y-0.57735*$delta_y]
	set y_plus   [expr $y+1.1547*$delta_y]

	VPC2CC $x_minus $y_minus c1
	VPC2CC $x_plus  $y_minus c2
	VPC2CC $x       $y_plus  c3
	
	$win create polygon $c1(x) $c1(y) $c2(x) $c2(y) $c3(x) $c3(y) \
		$c1(x) $c1(y) -fill cyan -tags "$args data$index triangleUp"
	$win create line $c1(x) $c1(y) $c2(x) $c2(y) $c3(x) $c3(y) \
		$c1(x) $c1(y) -fill blue -tags "$args data$index triangleUp"
}	
proc filledTriangleDown {win x y index args} {
	set delta_x   0.014
	set delta_y  [expr $delta_x*1.5]
	set x_minus  [expr $x-$delta_x]
	set x_plus   [expr $x+$delta_x]
	set y_minus  [expr $y-1.1547*$delta_y]
	set y_plus   [expr $y+0.57735*$delta_y]

	VPC2CC $x_minus $y_plus  c1
	VPC2CC $x_plus  $y_plus  c2
	VPC2CC $x       $y_minus c3
	
	$win create polygon $c1(x) $c1(y) $c2(x) $c2(y) $c3(x) $c3(y) \
		$c1(x) $c1(y) -fill cyan -tags "$args data$index triangleDown"
	$win create line $c1(x) $c1(y) $c2(x) $c2(y) $c3(x) $c3(y) \
		$c1(x) $c1(y) -fill blue -tags "$args data$index triangleDown"
}	
proc filledTriangleLeft {win x y index args} {
	set delta_x   0.014
	set delta_y  [expr $delta_x*1.5]
	set x_minus  [expr $x-1.1547*$delta_x]
	set x_plus   [expr $x+0.57735*$delta_x]
	set y_minus  [expr $y-$delta_y]
	set y_plus   [expr $y+$delta_y]

	VPC2CC $x_minus $y       c1
	VPC2CC $x_plus  $y_minus c2
	VPC2CC $x_plus  $y_plus  c3
	
	$win create polygon $c1(x) $c1(y) $c2(x) $c2(y) $c3(x) $c3(y) \
		$c1(x) $c1(y) -fill cyan -tags "$args data$index triangleLeft"
	$win create line $c1(x) $c1(y) $c2(x) $c2(y) $c3(x) $c3(y) \
		$c1(x) $c1(y) -fill blue -tags "$args data$index triangleLeft"
}	
proc filledTriangleRight {win x y index args} {
	set delta_x   0.014
	set delta_y  [expr $delta_x*1.5]
	set x_minus  [expr $x-0.57735*$delta_x]
	set x_plus   [expr $x+1.1547*$delta_x]
	set y_minus  [expr $y-$delta_y]
	set y_plus   [expr $y+$delta_y]

	VPC2CC $x_plus  $y       c1
	VPC2CC $x_minus $y_minus c2
	VPC2CC $x_minus $y_plus  c3
	
	$win create polygon $c1(x) $c1(y) $c2(x) $c2(y) $c3(x) $c3(y) \
		$c1(x) $c1(y) -fill cyan -tags "$args data$index triangleRight"
	$win create line $c1(x) $c1(y) $c2(x) $c2(y) $c3(x) $c3(y) \
		$c1(x) $c1(y) -fill blue -tags "$args data$index triangleRight"
}	
proc filledCircle  {win x y index args} {
	set delta_x   0.012
	set delta_y  [expr $delta_x*1.5]
	set x_minus  [expr $x-$delta_x]
	set x_plus   [expr $x+$delta_x]
	set y_minus  [expr $y-$delta_y]
	set y_plus   [expr $y+$delta_y]

	VPC2CC $x_minus $y_minus c1
	VPC2CC $x_plus  $y_plus  c2
	$win create oval $c1(x) $c1(y) $c2(x) $c2(y) \
		-outline blue -fill cyan -tags "$args data$index circle"
}
proc filledSquare  {win x y index args} {
	set delta_x   0.01
	set delta_y  [expr $delta_x*1.5]
	set x_minus  [expr $x-$delta_x]
	set x_plus   [expr $x+$delta_x]
	set y_minus  [expr $y-$delta_y]
	set y_plus   [expr $y+$delta_y]

	VPC2CC $x_minus $y_minus c1
	VPC2CC $x_plus  $y_plus  c2
	$win create rectangle $c1(x) $c1(y) $c2(x) $c2(y) \
		-outline blue -fill cyan -tags "$args data$index square"
}
proc filledDiamond {win x y index args} {
	
	set delta_x   0.014
	set delta_y  [expr $delta_x*1.5]
	set x_minus  [expr $x-$delta_x]
	set x_plus   [expr $x+$delta_x]
	set y_minus  [expr $y-$delta_y]
	set y_plus   [expr $y+$delta_y]
	
	VPC2CC $x $y_minus c1
	VPC2CC $x_plus $y  c2
	VPC2CC $x $y_plus  c3
	VPC2CC $x_minus $y c4

	$win create polygon $c1(x) $c1(y) $c2(x) $c2(y) $c3(x) $c3(y) \
		$c4(x) $c4(y) $c1(x) $c1(y) -fill cyan -tags "$args data$index diamond"
	$win create line $c1(x) $c1(y) $c2(x) $c2(y) $c3(x) $c3(y) \
		$c4(x) $c4(y) $c1(x) $c1(y) -fill blue -tags "$args data$index diamond"
}
proc openTriangleUp   {win x y index args} {
	set delta_x   0.014
	set delta_y  [expr $delta_x*1.5]
	set x_minus  [expr $x-$delta_x]
	set x_plus   [expr $x+$delta_x]
	set y_minus  [expr $y-0.57735*$delta_y]
	set y_plus   [expr $y+1.1547*$delta_y]

	VPC2CC $x_minus $y_minus c1
	VPC2CC $x_plus  $y_minus c2
	VPC2CC $x       $y_plus  c3
	
	$win create line $c1(x) $c1(y) $c2(x) $c2(y) $c3(x) $c3(y) \
		$c1(x) $c1(y) -fill blue -tags "$args data$index triangleUp" 
}	
proc openTriangleDown {win x y index args} {
	set delta_x   0.014
	set delta_y  [expr $delta_x*1.5]
	set x_minus  [expr $x-$delta_x]
	set x_plus   [expr $x+$delta_x]
	set y_minus  [expr $y-1.1547*$delta_y]
	set y_plus   [expr $y+0.57735*$delta_y]

	VPC2CC $x_minus $y_plus  c1
	VPC2CC $x_plus  $y_plus  c2
	VPC2CC $x       $y_minus c3
	
	$win create line $c1(x) $c1(y) $c2(x) $c2(y) $c3(x) $c3(y) \
		$c1(x) $c1(y) -fill blue -tags "$args data$index triangleDown"
}	
proc openTriangleLeft {win x y index args} {
	set delta_x   0.014
	set delta_y  [expr $delta_x*1.5]
	set x_minus  [expr $x-1.1547*$delta_x]
	set x_plus   [expr $x+0.57735*$delta_x]
	set y_minus  [expr $y-$delta_y]
	set y_plus   [expr $y+$delta_y]

	VPC2CC $x_minus $y       c1
	VPC2CC $x_plus  $y_minus c2
	VPC2CC $x_plus  $y_plus  c3
	
	$win create line $c1(x) $c1(y) $c2(x) $c2(y) $c3(x) $c3(y) \
		$c1(x) $c1(y) -fill blue -tags "$args data$index triangleLeft"
}	
proc openTriangleRight {win x y index args} {
	set delta_x   0.014
	set delta_y  [expr $delta_x*1.5]
	set x_minus  [expr $x-0.57735*$delta_x]
	set x_plus   [expr $x+1.1547*$delta_x]
	set y_minus  [expr $y-$delta_y]
	set y_plus   [expr $y+$delta_y]

	VPC2CC $x_plus  $y       c1
	VPC2CC $x_minus $y_minus c2
	VPC2CC $x_minus $y_plus  c3
	
	$win create line $c1(x) $c1(y) $c2(x) $c2(y) $c3(x) $c3(y) \
		$c1(x) $c1(y) -fill blue -tags "$args data$index triangleRight"
}	
proc openCircle  {win x y index args} {
	set delta_x   0.012
	set delta_y  [expr $delta_x*1.5]
	set x_minus  [expr $x-$delta_x]
	set x_plus   [expr $x+$delta_x]
	set y_minus  [expr $y-$delta_y]
	set y_plus   [expr $y+$delta_y]

	VPC2CC $x_minus $y_minus c1
	VPC2CC $x_plus  $y_plus  c2
	$win create oval $c1(x) $c1(y) $c2(x) $c2(y) \
		-outline blue -tags "$args data$index circle"
}
proc openSquare  {win x y index args} {
	set delta_x   0.01
	set delta_y  [expr $delta_x*1.5]
	set x_minus  [expr $x-$delta_x]
	set x_plus   [expr $x+$delta_x]
	set y_minus  [expr $y-$delta_y]
	set y_plus   [expr $y+$delta_y]

	VPC2CC $x_minus $y_minus c1
	VPC2CC $x_plus  $y_plus  c2
	$win create rectangle $c1(x) $c1(y) $c2(x) $c2(y) \
		-outline blue -tags "$args data$index square"
}
proc openDiamond {win x y index args} {
	
	set delta_x   0.014
	set delta_y  [expr $delta_x*1.5]
	set x_minus  [expr $x-$delta_x]
	set x_plus   [expr $x+$delta_x]
	set y_minus  [expr $y-$delta_y]
	set y_plus   [expr $y+$delta_y]
	
	VPC2CC $x $y_minus c1
	VPC2CC $x_plus $y  c2
	VPC2CC $x $y_plus  c3
	VPC2CC $x_minus $y c4

	$win create line $c1(x) $c1(y) $c2(x) $c2(y) $c3(x) $c3(y) \
		$c4(x) $c4(y) $c1(x) $c1(y) -fill blue -tags "$args data$index diamond"
}
