
proc setVPC2CC {xscale yscale xoffset yoffset} {
	global  VPC2CC

	set VPC2CC(ax)  $xscale
	set VPC2CC(ay)  $yscale
	set VPC2CC(bx)  $xoffset
	set VPC2CC(by)  $yoffset
}
proc setDC2VPC {minx maxx miny maxy} {
	global DC2VPC

	set DC2VPC(ax) [expr 1.0/($maxx-$minx)]
	set DC2VPC(bx) [expr -$minx/($maxx-$minx)]
	set DC2VPC(ay) [expr 1.0/($maxy-$miny)]
	set DC2VPC(by) [expr -$miny/($maxy-$miny)]
}
proc DIRECT {x y c} {
	global VPC2CC
	upvar  $c CC

	set CC(x) $x
	set CC(y) $y
}
proc CC2VPC {x y c} {
	global VPC2CC PX2MM
	upvar  $c CC

	set CC(x) [expr double($x*$PX2MM-$VPC2CC(bx))/double($VPC2CC(ax))]
	set CC(y) [expr double($y*$PX2MM-$VPC2CC(by))/double($VPC2CC(ay))]
}
proc VPC2CC {x y c} {
	global VPC2CC
	upvar  $c CC

	set CC(x) "[expr $VPC2CC(ax)*$x + $VPC2CC(bx)]m"
	set CC(y) "[expr $VPC2CC(ay)*$y + $VPC2CC(by)]m"
}
proc DC2VPC {x y c} {
	global DC2VPC
	upvar  $c VPC

	set VPC(x) [expr $DC2VPC(ax)*$x + $DC2VPC(bx)]
	set VPC(y) [expr $DC2VPC(ay)*$y + $DC2VPC(by)]
}
proc DC2CC  {x y c} {
	global DC2VPC
	upvar  $c CC

	set VPCx [expr $DC2VPC(ax)*$x + $DC2VPC(bx)]
	set VPCy [expr $DC2VPC(ay)*$y + $DC2VPC(by)]
	VPC2CC $VPCx $VPCy CC
}
