

proc getFileNameByBrowser {dir name args} {
    global  filenameByBrowserIndex
    set filenameByBrowserIndex $name

    if [info exists args] {
        fileBrowser $dir $args
    } else {
        fileBrowser $dir
    }
}
proc fileBrowser {dir args} {
    global filenameByBrowser filenameByBrowserIndex
    global tk_version 

    set configureBackground 0
    if [expr $args!={}] { 
        set bgMain   [lindex [lindex $args 0] 0]
        set bgHilite [lindex [lindex $args 0] 1]
        set bgSelect [lindex [lindex $args 0] 2]
        set configureBackground 1
    }
    set standardFont -*-helvetica-bold-r-normal--*-120-*    
    set filenameByBrowser($filenameByBrowserIndex) ""
    if [winfo exists .browser] { raise .browser } else {
        toplevel .browser 
        frame .browser.f 
        if {$tk_version>=4.0} {
            listbox .browser.files -relief raised -borderwidth 2 \
                    -height 18 -yscrollcommand ".browser.scroll set" \
                    -font $standardFont
        } else {
            listbox .browser.files -relief raised -borderwidth 2 \
                    -geometry 20x18 -yscrollcommand ".browser.scroll set" \
                    -font $standardFont
        }
        pack .browser.files -side left -in .browser.f
        scrollbar .browser.scroll -command ".browser.files yview"
        pack .browser.scroll -side right -fill y -in .browser.f
        button .browser.abort -text "A b o r t" -command {destroy .browser} \
            -font $standardFont
        pack .browser.f -padx 1m -pady 1m -side top
        pack .browser.abort -padx 2m -pady 2m -side top -fill x
        foreach i [lsort [exec ls -a $dir]] {
            if {![regexp {^\.+[^\.]+} $i] && ![regexp {~$} $i]} {
                .browser.files insert end $i
            }
        }
        bind .browser.files <Double-Button-1> {
            set filenameByBrowser($filenameByBrowserIndex) \
                $filenameByBrowser($filenameByBrowserIndex)[selection get]
            if {[file isfile $filenameByBrowser($filenameByBrowserIndex)]} {
                        destroy .browser 
            } elseif {[file isdirectory $filenameByBrowser($filenameByBrowserIndex)]} {
                .browser.files delete 0 end
                foreach i [lsort [exec ls -a $filenameByBrowser($filenameByBrowserIndex)]] {
                    if {![regexp {^\.+[^\.]+} $i] && ![regexp {~$} $i]} {
                        .browser.files insert end $i
                    }
                }
                set filenameByBrowser($filenameByBrowserIndex) \
                     $filenameByBrowser($filenameByBrowserIndex)/
            } 
        }
        if $configureBackground {
            if {$tk_version>=4.0} {
                .browser configure -bg $bgMain
                .browser.f configure -bg $bgMain
                .browser.abort configure -bg $bgMain -activebackground $bgHilite \
                    -highlightbackground $bgMain
                .browser.files configure -bg $bgMain -selectbackground $bgSelect \
                    -highlightbackground $bgMain
                .browser.scroll configure -bg $bgMain -activebackground $bgHilite \
                    -troughcolor $bgSelect -highlightbackground $bgMain
            } else {
                .browser configure -bg $bgMain
                .browser.f configure -bg $bgMain
                .browser.abort configure -bg $bgMain -activebackground $bgHilite
                .browser.files configure -bg $bgMain -selectbackground $bgSelect \
                    -selectforeground white
                .browser.scroll configure -activeforeground $bgHilite \
                    -background $bgSelect -foreground $bgMain
            }
        }
    }
}
