#include "mbs.h"

/*********************************************************************
**
**   MACROS:        
**
**   ROUTINES:      mbs_binomi
**                 
**********************************************************************/

/*********************************************************************
**
**   Routine Name:  mbs_binomi
**                  
**   Purpose:       
**
**   Input:         
**   Output:        
**
**   Called By:     
**
**   Written By:    Bernhard Sulzer, LANL
**   Last Edited:   
**
**********************************************************************/

void 
mbs_binomi(double **bc, int n)
{
    int  k, l;
    
    for (k=0 ; k<=n ; k++)
    {
	bc[k][0] = 1.0;
	l=1;
	while (l<k)
	{
	    if ((bc[k][l] = bc[k-1][l-1] + bc[k-1][l]) > 1e308)
	    {
		fprintf(stderr, "MBS BINOMI -- WARNING:\n");
		fprintf(stderr, "\tBinomial coefficients approaching\n");
		fprintf(stderr, "\tfloating point range boundary.\n");
		fprintf(stderr, "(n , k) = (%d , %d); b(n,k) = %e\n", k, l, bc[k][l]);
	    }
	    l++;
	}
	bc[k][k] = 1.0;
    }
}


