#ifndef _MBS_LIGAND_PROTOTYPES_H_
#define _MBS_LIGAND_PROTOTYPES_H_

void
mbs_initialize_1L1C_aggregation (int, int);
double
mbs_1L1C_get_aggregates (double);
int
mbs_ligand_binding_curve (char*, double*);
double
mbs_get_signal_strength ();
double
mbs_get_signal_strength_per_cell (int);
void
mbs_write_signal_strength (FILE*, double);
void
mbs_write_signal_strength_per_cell (FILE*, double);
void 
mbs_ini_bound_state_computation_vk (double*);
void
mbs_compute_bound_state_distribution_vk ();
void 
mbs_ini_bound_state_computation (double*);
void
mbs_compute_bound_state_distribution ();
int
mbs_get_concentration_boundaries (double*, double*);
void
mbs_ini_ligand_concentrations ();
void
mbs_increment_ligand_concentration (double*);
void 
mbs_select_signal_function (int);
void 
mbs_set_signal_function (double(*)(int,int));
void
mbs_set_interaction_parameters (int, int, double, double, double, double, double, double);
void
mbs_set_ligand_attributes (int, double, int, int, double);
void
mbs_set_cell_attributes (int, double, int, double, double);
void
mbs_set_number_of_ligands (int n);
void
mbs_set_number_of_cell_types (int n);
int
mbs_file_ini_ligand_binding_curve (char*, char*, char*, char*);
int
mbs_read_ligand_file (char*, int);
int
mbs_read_cell_type_file (char*, int);
int
mbs_read_interaction_file (char*, int);
int 
mbs_read_control_variable_file (char*, int);
void
mbs_initialize_receptor_aggregation (int, int);
int
mbs_set_ligand_scale_parameters (double, double, double, int, int);
int
mbs_set_ligand_scale_converters (int);
void
mbs_set_receptor_conservation (double(*)(double*,int*));
void
mbs_set_ligand_control_variables (int, int, int, double);
void
mbs_set_cell_control_variables (int, int, int, double);


#endif
